#ifndef __LIBRARY_H
#define __LIBRARY_H

// user definition ...

extern "C" {
	CONCEPT_DLL_API ON_CREATE_CONTEXT MANAGEMENT_PARAMETERS;

        // other functions declared here
	CONCEPT_DLL_API CONCEPT__fopen CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__fclose CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__fread CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__fwrite CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__fseek CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__ftell CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__fsize CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__fgetstring CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__feof CONCEPT_API_PARAMETERS;

	CONCEPT_DLL_API CONCEPT__fflush CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__fgetc CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__fputc CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__fgets CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__fputs CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT___fileno CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__freopen CONCEPT_API_PARAMETERS;
	
	CONCEPT_DLL_API CONCEPT__remove CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT___unlink CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT___chdir CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT___mkdir CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT___rmdir CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__exec CONCEPT_API_PARAMETERS;

	CONCEPT_DLL_API CONCEPT__opendir CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__readdir CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__telldir CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__seekdir CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__rewinddir CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__closedir CONCEPT_API_PARAMETERS;
	//CONCEPT_DLL_API CONCEPT__dirfd CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__dirname CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT___stat CONCEPT_API_PARAMETERS;

	CONCEPT_DLL_API CONCEPT__filetype CONCEPT_API_PARAMETERS;

	CONCEPT_DLL_API CONCEPT__filesize CONCEPT_API_PARAMETERS;

	CONCEPT_DLL_API CONCEPT__filelast_acc CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__filelast_mod CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__filelast_ch CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__fileuid CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__filegid CONCEPT_API_PARAMETERS;

	CONCEPT_DLL_API CONCEPT___getenv CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT___putenv CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__system CONCEPT_API_PARAMETERS;

	CONCEPT_DLL_API CONCEPT__ReadFile CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__WriteFile CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__FileExists CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__DirectoryExists CONCEPT_API_PARAMETERS;

	CONCEPT_DLL_API CONCEPT___errno CONCEPT_API_PARAMETERS;

	CONCEPT_DLL_API CONCEPT_rename CONCEPT_API_PARAMETERS;
	
	CONCEPT_FUNCTION(IniGet)
	CONCEPT_FUNCTION(IniSet)
	CONCEPT_FUNCTION(popen)
	CONCEPT_FUNCTION(pclose)
    CONCEPT_FUNCTION(_WEXITSTATUS)
	CONCEPT_FUNCTION(_MSWINDOWS)
	CONCEPT_FUNCTION(_BITS)

	CONCEPT_FUNCTION(IsSymlink)
	CONCEPT_FUNCTION(utime)

    CONCEPT_FUNCTION(dup)
    CONCEPT_FUNCTION(dup2)
    CONCEPT_FUNCTION(fdopen)
    CONCEPT_FUNCTION(pipe)
    CONCEPT_FUNCTION(close)
    CONCEPT_FUNCTION(write)
    CONCEPT_FUNCTION(read)
    CONCEPT_FUNCTION(seek)


    CONCEPT_FUNCTION(remap_pipe_stdin_stdout)
}


#endif // __LIBRARY_H
