//------------ standard header -----------------------------------//
#include "stdlibrary.h"
//------------ end of standard header ----------------------------//
#include <math.h>
#include <stdlib.h>
#include "library.h"
#include <time.h>
#include <float.h>
#include <ctype.h>
#include "AnsiString.h"

#define MAX(A,B) A>B ? A : B
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API ON_CREATE_CONTEXT MANAGEMENT_PARAMETERS {
	AnsiString value=M_E;
	Invoke(INVOKE_DEFINE_CONSTANT, HANDLER, "M_E",value.c_str());
	value=M_LOG2E;
	Invoke(INVOKE_DEFINE_CONSTANT, HANDLER, "M_LOG2E",value.c_str());
	value=M_LOG10E;
	Invoke(INVOKE_DEFINE_CONSTANT, HANDLER, "M_LOG10E",value.c_str());
	value=M_LN2;
	Invoke(INVOKE_DEFINE_CONSTANT, HANDLER, "M_LN2",value.c_str());
	value=M_LN10;
	Invoke(INVOKE_DEFINE_CONSTANT, HANDLER, "M_LN10",value.c_str());
	value=M_PI;
	Invoke(INVOKE_DEFINE_CONSTANT, HANDLER, "M_PI",value.c_str());
	value=M_PI_2;
	Invoke(INVOKE_DEFINE_CONSTANT, HANDLER, "M_PI_2",value.c_str());
	value=M_PI_4;
	Invoke(INVOKE_DEFINE_CONSTANT, HANDLER, "M_PI_4",value.c_str());
	value=M_1_PI;
	Invoke(INVOKE_DEFINE_CONSTANT, HANDLER, "M_1_PI",value.c_str());
	value=M_2_PI;
	Invoke(INVOKE_DEFINE_CONSTANT, HANDLER, "M_2_PI",value.c_str());
	value=M_2_SQRTPI;
	Invoke(INVOKE_DEFINE_CONSTANT, HANDLER, "M_2_SQRTPI",value.c_str());
	value=M_SQRT2;
	Invoke(INVOKE_DEFINE_CONSTANT, HANDLER, "M_SQRT2",value.c_str());
	value=M_SQRT1_2;
	Invoke(INVOKE_DEFINE_CONSTANT, HANDLER, "M_SQRT1_2",value.c_str());
	srand( (unsigned)time( NULL ) );
	return 0;
}
//---------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__abs CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=1)
           return (void *)": 'abs' parameters error. This fuction takes one parameter.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        int	_C_call_result;
        // Specific variables
        NUMBER       nParam0;

        // Variable type check
        // Parameter 1
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &STRING_DUMMY, &nParam0);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"abs: parameter 1 should be of STATIC NUMBER type";

        // function call
        _C_call_result=(int)abs((int)nParam0);

        SetVariable(RESULT,VARIABLE_NUMBER,"",_C_call_result);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__acos CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=1)
           return (void *)": 'acos' parameters error. This fuction takes one parameter.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        double	_C_call_result;
        // Specific variables
        NUMBER       nParam0;

        // Variable type check
        // Parameter 1
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &STRING_DUMMY, &nParam0);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"acos: parameter 1 should be of STATIC NUMBER type";

        // function call
        _C_call_result=(double)acos((double)nParam0);

        SetVariable(RESULT,VARIABLE_NUMBER,"",_C_call_result);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__asin CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=1)
           return (void *)": 'asin' parameters error. This fuction takes one parameter.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        double	_C_call_result;
        // Specific variables
        NUMBER       nParam0;

        // Variable type check
        // Parameter 1
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &STRING_DUMMY, &nParam0);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"asin: parameter 1 should be of STATIC NUMBER type";

        // function call
        _C_call_result=(double)asin((double)nParam0);

        SetVariable(RESULT,VARIABLE_NUMBER,"",_C_call_result);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__atan CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=1)
           return (void *)": 'atan' parameters error. This fuction takes one parameter.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        double	_C_call_result;
        // Specific variables
        NUMBER       nParam0;

        // Variable type check
        // Parameter 1
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &STRING_DUMMY, &nParam0);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"atan: parameter 1 should be of STATIC NUMBER type";

        // function call
        _C_call_result=(double)atan((double)nParam0);

        SetVariable(RESULT,VARIABLE_NUMBER,"",_C_call_result);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__ceil CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=1)
           return (void *)": 'ceil' parameters error. This fuction takes one parameter.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        double	_C_call_result;
        // Specific variables
        NUMBER       nParam0;

        // Variable type check
        // Parameter 1
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &STRING_DUMMY, &nParam0);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"ceil: parameter 1 should be of STATIC NUMBER type";

        // function call
        _C_call_result=(double)ceil((double)nParam0);

        SetVariable(RESULT,VARIABLE_NUMBER,"",_C_call_result);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__cos CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=1)
           return (void *)": 'cos' parameters error. This fuction takes one parameter.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        double	_C_call_result;
        // Specific variables
        NUMBER       nParam0;

        // Variable type check
        // Parameter 1
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &STRING_DUMMY, &nParam0);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"cos: parameter 1 should be of STATIC NUMBER type";

        // function call
        _C_call_result=(double)cos((double)nParam0);

        SetVariable(RESULT,VARIABLE_NUMBER,"",_C_call_result);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__exp CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=1)
           return (void *)": 'exp' parameters error. This fuction takes one parameter.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        double	_C_call_result;
        // Specific variables
        NUMBER       nParam0;

        // Variable type check
        // Parameter 1
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &STRING_DUMMY, &nParam0);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"exp: parameter 1 should be of STATIC NUMBER type";

        // function call
        _C_call_result=(double)exp((double)nParam0);

        SetVariable(RESULT,VARIABLE_NUMBER,"",_C_call_result);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__fabs CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=1)
           return (void *)": 'fabs' parameters error. This fuction takes one parameter.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        double	_C_call_result;
        // Specific variables
        NUMBER       nParam0;

        // Variable type check
        // Parameter 1
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &STRING_DUMMY, &nParam0);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"fabs: parameter 1 should be of STATIC NUMBER type";

        // function call
        _C_call_result=(double)fabs((double)nParam0);

        SetVariable(RESULT,VARIABLE_NUMBER,"",_C_call_result);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__floor CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=1)
           return (void *)": 'floor' parameters error. This fuction takes one parameter.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        double	_C_call_result;
        // Specific variables
        NUMBER       nParam0;

        // Variable type check
        // Parameter 1
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &STRING_DUMMY, &nParam0);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"floor: parameter 1 should be of STATIC NUMBER type";

        // function call
        _C_call_result=(double)floor((double)nParam0);

        SetVariable(RESULT,VARIABLE_NUMBER,"",_C_call_result);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__fmod CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=2)
           return (void *)": 'fmod' parameters error. This fuction takes 2 parameters.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        double	_C_call_result;
        // Specific variables
        NUMBER       nParam0;
        NUMBER       nParam1;

        // Variable type check
        // Parameter 1
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &STRING_DUMMY, &nParam0);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"fmod: parameter 1 should be of STATIC NUMBER type";
        // Parameter 2
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[1]-1], &TYPE, &STRING_DUMMY, &nParam1);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"fmod: parameter 2 should be of STATIC NUMBER type";

        // function call
        _C_call_result=(double)fmod((double)nParam0, (double)nParam1);

        SetVariable(RESULT,VARIABLE_NUMBER,"",_C_call_result);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__labs CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=1)
           return (void *)": 'labs' parameters error. This fuction takes one parameter.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        long	_C_call_result;
        // Specific variables
        NUMBER       nParam0;

        // Variable type check
        // Parameter 1
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &STRING_DUMMY, &nParam0);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"labs: parameter 1 should be of STATIC NUMBER type";

        // function call
        _C_call_result=(long)labs((long)nParam0);

        SetVariable(RESULT,VARIABLE_NUMBER,"",_C_call_result);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__ldexp CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=2)
           return (void *)": 'ldexp' parameters error. This fuction takes 2 parameters.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        double	_C_call_result;
        // Specific variables
        NUMBER       nParam0;
        NUMBER       nParam1;

        // Variable type check
        // Parameter 1
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &STRING_DUMMY, &nParam0);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"ldexp: parameter 1 should be of STATIC NUMBER type";
        // Parameter 2
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[1]-1], &TYPE, &STRING_DUMMY, &nParam1);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"ldexp: parameter 2 should be of STATIC NUMBER type";

        // function call
        _C_call_result=(double)ldexp((double)nParam0, (int)nParam1);

        SetVariable(RESULT,VARIABLE_NUMBER,"",_C_call_result);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__log CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=1)
           return (void *)": 'log' parameters error. This fuction takes one parameter.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        double	_C_call_result;
        // Specific variables
        NUMBER       nParam0;

        // Variable type check
        // Parameter 1
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &STRING_DUMMY, &nParam0);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"log: parameter 1 should be of STATIC NUMBER type";

        // function call
        _C_call_result=(double)log((double)nParam0);

        SetVariable(RESULT,VARIABLE_NUMBER,"",_C_call_result);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__log10 CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=1)
           return (void *)": 'log10' parameters error. This fuction takes one parameter.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        float	_C_call_result;
        // Specific variables
        NUMBER       nParam0;

        // Variable type check
        // Parameter 1
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &STRING_DUMMY, &nParam0);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"log10: parameter 1 should be of STATIC NUMBER type";

        // function call
        _C_call_result=(float)log10((float)nParam0);

        SetVariable(RESULT,VARIABLE_NUMBER,"",_C_call_result);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__pow CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=2)
           return (void *)": 'pow' parameters error. This fuction takes 2 parameters.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        double	_C_call_result;
        // Specific variables
        NUMBER       nParam0;
        NUMBER       nParam1;

        // Variable type check
        // Parameter 1
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &STRING_DUMMY, &nParam0);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"pow: parameter 1 should be of STATIC NUMBER type";
        // Parameter 2
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[1]-1], &TYPE, &STRING_DUMMY, &nParam1);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"pow: parameter 2 should be of STATIC NUMBER type";

        // function call
        _C_call_result=(double)pow((double)nParam0, (double)nParam1);

        SetVariable(RESULT,VARIABLE_NUMBER,"",_C_call_result);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__rand CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=0)
           return (void *)": 'rand' parameters error. This fuction takes  no parameters.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        int	_C_call_result;
        // Specific variables

        // Variable type check

        // function call
        _C_call_result=(int)rand();

        SetVariable(RESULT,VARIABLE_NUMBER,"",_C_call_result);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__sin CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=1)
           return (void *)": 'sin' parameters error. This fuction takes one parameter.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        double	_C_call_result;
        // Specific variables
        NUMBER       nParam0;

        // Variable type check
        // Parameter 1
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &STRING_DUMMY, &nParam0);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"sin: parameter 1 should be of STATIC NUMBER type";

        // function call
        _C_call_result=(double)sin((double)nParam0);

        SetVariable(RESULT,VARIABLE_NUMBER,"",_C_call_result);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__sqrt CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=1)
           return (void *)": 'sqrt' parameters error. This fuction takes one parameter.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        double	_C_call_result;
        // Specific variables
        NUMBER       nParam0;

        // Variable type check
        // Parameter 1
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &STRING_DUMMY, &nParam0);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"sqrt: parameter 1 should be of STATIC NUMBER type";

        // function call
        _C_call_result=(double)sqrt((double)nParam0);

        SetVariable(RESULT,VARIABLE_NUMBER,"",_C_call_result);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__srand CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=1)
           return (void *)": 'srand' parameters error. This fuction takes one parameter.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        // Specific variables
        NUMBER       nParam0;

        // Variable type check
        // Parameter 1
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &STRING_DUMMY, &nParam0);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"srand: parameter 1 should be of STATIC NUMBER type";

        // function call
        srand((unsigned int)nParam0);

        SetVariable(RESULT,VARIABLE_NUMBER,"",0);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__tan CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=1)
           return (void *)": 'tan' parameters error. This fuction takes one parameter.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        double	_C_call_result;
        // Specific variables
        NUMBER       nParam0;

        // Variable type check
        // Parameter 1
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &STRING_DUMMY, &nParam0);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"tan: parameter 1 should be of STATIC NUMBER type";

        // function call
        _C_call_result=(double)tan((double)nParam0);

        SetVariable(RESULT,VARIABLE_NUMBER,"",_C_call_result);
        return 0;
}
//-----------------------------------------------------------------------------------
double RoundDouble(double doValue, int nPrecision)
{
	static const double doBase = 10.0;
	double doComplete5, doComplete5i;
	
	doComplete5 = doValue * pow(doBase, (double) (nPrecision + 1));
	
	if(doValue < 0.0)
		doComplete5 -= 5.0;
	else
		doComplete5 += 5.0;
	
	doComplete5 /= doBase;
	modf(doComplete5, &doComplete5i);
	
	return doComplete5i / pow(doBase, (double) nPrecision);
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__round CONCEPT_API_PARAMETERS {
    PARAMETERS_CHECK_MIN_MAX(1,2,"round takes one or two parameters: number, digits=0");

    LOCAL_INIT;

    double number;
    int digits=0;

    GET_CHECK_NUMBER(0,number, "round: parameter 1 should be a static number");

    if (PARAMETERS_COUNT==2) {
        double dig;
        GET_CHECK_NUMBER(1,dig, "round: parameter 2 should be a static number");
        digits=(int)dig;
    }


    /*long mul = (long)pow((double)10,(double)digits);
    number*=mul;

    if(number>0)
        number+=(double)1/2;
    else
        number-=(double)1/2;

    number=(long)number;
    //number/=mul;

    //sprintf(buffer,"%.30g",d);

    RETURN_NUMBER(number);*/
    RETURN_NUMBER(RoundDouble(number, digits));
    return 0;
}
//---------------------------------------------------------------------------
AnsiString math_number_format(double d,int dec,char dec_point,char thousand_sep) {
    AnsiString result;

	char *tmpbuf,*resbuf;
	char *s,*t;  /* source, target */
	int tmplen,reslen=0;
	int count=0;
	int is_negative=0;
	
	if (d<0) {
		is_negative=1;
		d = -d;
	}
	dec = MAX(0,dec);
	tmpbuf = (char *) malloc(1+DBL_MAX_10_EXP+1+dec+1);
	
	tmplen=sprintf(tmpbuf,"%.*f",dec,d);

	if (!isdigit((int)tmpbuf[0])) {
        result=tmpbuf;
        free(tmpbuf);
		return result;
	}

	if (dec) {
		reslen = dec+1 + (tmplen-dec-1) + ((thousand_sep) ? (tmplen-1-dec-1)/3 : 0);
	} else {
		reslen = tmplen+((thousand_sep) ? (tmplen-1)/3 : 0);
	}
	if (is_negative) {
		reslen++;
	}
	resbuf = (char *) malloc(reslen+1);
	
	s = tmpbuf+tmplen-1;
	t = resbuf+reslen;
	*t-- = 0;
	
	if (dec) {
		while (isdigit((int)*s)) {
			*t-- = *s--;
		}
		*t-- = dec_point;  /* copy that dot */
		s--;
	}
	
	while(s>=tmpbuf) {
		*t-- = *s--;
		if (thousand_sep && (++count%3)==0 && s>=tmpbuf) {
			*t-- = thousand_sep;
		}
	}
	if (is_negative) {
		*t-- = '-';
	}
	free(tmpbuf);
    result = resbuf;
    free(resbuf);
	return /*resbuf*/result;
}
//---------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_number_format,4)
    T_NUMBER(0)
    T_NUMBER(1)
    T_STRING(2)
    T_STRING(3)

    char dec_point=0;
    char thousand_sep=0;

    if (PARAM(2))
        dec_point=PARAM(2)[0];

    if (PARAM(3))
        thousand_sep=PARAM(3)[0];

    RETURN_STRING(math_number_format(PARAM(0), PARAM_INT(1), dec_point, thousand_sep))
END_IMPL
//---------------------------------------------------------------------------
