#ifndef __LIBRARY_H
#define __LIBRARY_H

// user definition ...

extern "C" {
    CONCEPT_DLL_API ON_CREATE_CONTEXT MANAGEMENT_PARAMETERS;
    CONCEPT_DLL_API ON_DESTROY_CONTEXT MANAGEMENT_PARAMETERS;

    CONCEPT_FUNCTION(_PDF_activate_item)
    CONCEPT_FUNCTION(_PDF_add_bookmark)
    CONCEPT_FUNCTION(_PDF_add_bookmark2)
    CONCEPT_FUNCTION(_PDF_add_launchlink)
    CONCEPT_FUNCTION(_PDF_add_locallink)
    CONCEPT_FUNCTION(_PDF_add_nameddest)
    CONCEPT_FUNCTION(_PDF_add_note)
    CONCEPT_FUNCTION(_PDF_add_note2)
    CONCEPT_FUNCTION(_PDF_add_pdflink)
    CONCEPT_FUNCTION(_PDF_add_table_cell)
    CONCEPT_FUNCTION(_PDF_add_textflow)
    CONCEPT_FUNCTION(_PDF_add_thumbnail)
    CONCEPT_FUNCTION(_PDF_add_weblink)
    CONCEPT_FUNCTION(_PDF_arc)
    CONCEPT_FUNCTION(_PDF_arcn)
    CONCEPT_FUNCTION(_PDF_attach_file)
    CONCEPT_FUNCTION(_PDF_attach_file2)
    CONCEPT_FUNCTION(_PDF_begin_document)
    CONCEPT_FUNCTION(_PDF_begin_font)
    CONCEPT_FUNCTION(_PDF_begin_glyph)
    CONCEPT_FUNCTION(_PDF_begin_item)
    CONCEPT_FUNCTION(_PDF_begin_layer)
    CONCEPT_FUNCTION(_PDF_begin_mc)
    CONCEPT_FUNCTION(_PDF_begin_page)
    CONCEPT_FUNCTION(_PDF_begin_page_ext)
    CONCEPT_FUNCTION(_PDF_begin_pattern)
    CONCEPT_FUNCTION(_PDF_begin_template)
    CONCEPT_FUNCTION(_PDF_begin_template_ext)
    CONCEPT_FUNCTION(_PDF_boot)
    CONCEPT_FUNCTION(_PDF_check_context)
    CONCEPT_FUNCTION(_PDF_circle)
    CONCEPT_FUNCTION(_PDF_clip)
    CONCEPT_FUNCTION(_PDF_close)
    CONCEPT_FUNCTION(_PDF_close_image)
    CONCEPT_FUNCTION(_PDF_close_pdi)
    CONCEPT_FUNCTION(_PDF_close_pdi_document)
    CONCEPT_FUNCTION(_PDF_close_pdi_page)
    CONCEPT_FUNCTION(_PDF_closepath)
    CONCEPT_FUNCTION(_PDF_closepath_fill_stroke)
    CONCEPT_FUNCTION(_PDF_closepath_stroke)
    CONCEPT_FUNCTION(_PDF_concat)
    CONCEPT_FUNCTION(_PDF_continue_text)
    CONCEPT_FUNCTION(_PDF_continue_text2)
    CONCEPT_FUNCTION(_PDF_create_3dview)
    CONCEPT_FUNCTION(_PDF_create_action)
    CONCEPT_FUNCTION(_PDF_create_annotation)
    CONCEPT_FUNCTION(_PDF_create_bookmark)
    CONCEPT_FUNCTION(_PDF_create_field)
    CONCEPT_FUNCTION(_PDF_create_fieldgroup)
    CONCEPT_FUNCTION(_PDF_create_gstate)
    CONCEPT_FUNCTION(_PDF_create_pvf)
    CONCEPT_FUNCTION(_PDF_create_textflow)
    CONCEPT_FUNCTION(_PDF_curveto)
    CONCEPT_FUNCTION(_PDF_define_layer)
    CONCEPT_FUNCTION(_PDF_delete)
    CONCEPT_FUNCTION(_PDF_delete_pvf)
    CONCEPT_FUNCTION(_PDF_delete_table)
    CONCEPT_FUNCTION(_PDF_delete_textflow)
    CONCEPT_FUNCTION(_PDF_encoding_set_char)
    CONCEPT_FUNCTION(_PDF_end_document)
    CONCEPT_FUNCTION(_PDF_end_font)
    CONCEPT_FUNCTION(_PDF_end_glyph)
    CONCEPT_FUNCTION(_PDF_end_item)
    CONCEPT_FUNCTION(_PDF_end_layer)
    CONCEPT_FUNCTION(_PDF_end_mc)
    CONCEPT_FUNCTION(_PDF_end_page)
    CONCEPT_FUNCTION(_PDF_end_page_ext)
    CONCEPT_FUNCTION(_PDF_end_pattern)
    CONCEPT_FUNCTION(_PDF_end_template)
    CONCEPT_FUNCTION(_PDF_endpath)
    CONCEPT_FUNCTION(_PDF_fill)
    CONCEPT_FUNCTION(_PDF_fill_imageblock)
    CONCEPT_FUNCTION(_PDF_fill_pdfblock)
    CONCEPT_FUNCTION(_PDF_fill_stroke)
    CONCEPT_FUNCTION(_PDF_fill_textblock)
    CONCEPT_FUNCTION(_PDF_findfont)
    CONCEPT_FUNCTION(_PDF_fit_image)
    CONCEPT_FUNCTION(_PDF_fit_pdi_page)
    CONCEPT_FUNCTION(_PDF_fit_table)
    CONCEPT_FUNCTION(_PDF_fit_textflow)
    CONCEPT_FUNCTION(_PDF_fit_textline)
    CONCEPT_FUNCTION(_PDF_get_apiname)
    CONCEPT_FUNCTION(_PDF_get_buffer)
    CONCEPT_FUNCTION(_PDF_get_errmsg)
    CONCEPT_FUNCTION(_PDF_get_errnum)
    CONCEPT_FUNCTION(_PDF_get_kern_amount)
    CONCEPT_FUNCTION(_PDF_get_majorversion)
    CONCEPT_FUNCTION(_PDF_get_minorversion)
    CONCEPT_FUNCTION(_PDF_get_opaque)
    CONCEPT_FUNCTION(_PDF_get_parameter)
    CONCEPT_FUNCTION(_PDF_get_pdi_parameter)
    CONCEPT_FUNCTION(_PDF_get_pdi_value)
    CONCEPT_FUNCTION(_PDF_get_value)
    CONCEPT_FUNCTION(_PDF_info_font)
    CONCEPT_FUNCTION(_PDF_info_matchbox)
    CONCEPT_FUNCTION(_PDF_info_table)
    CONCEPT_FUNCTION(_PDF_info_textflow)
    CONCEPT_FUNCTION(_PDF_info_textline)
    CONCEPT_FUNCTION(_PDF_initgraphics)
    CONCEPT_FUNCTION(_PDF_lineto)
    CONCEPT_FUNCTION(_PDF_load_3ddata)
    CONCEPT_FUNCTION(_PDF_load_font)
    CONCEPT_FUNCTION(_PDF_load_iccprofile)
    CONCEPT_FUNCTION(_PDF_load_image)
    CONCEPT_FUNCTION(_PDF_makespotcolor)
    CONCEPT_FUNCTION(_PDF_mc_point)
    CONCEPT_FUNCTION(_PDF_moveto)
    CONCEPT_FUNCTION(_PDF_new)
    CONCEPT_FUNCTION(_PDF_open_CCITT)
    CONCEPT_FUNCTION(_PDF_open_file)
    CONCEPT_FUNCTION(_PDF_open_image)
    CONCEPT_FUNCTION(_PDF_open_image_file)
    CONCEPT_FUNCTION(_PDF_open_pdi)
    CONCEPT_FUNCTION(_PDF_open_pdi_document)
    CONCEPT_FUNCTION(_PDF_open_pdi_page)
    CONCEPT_FUNCTION(_PDF_place_image)
    CONCEPT_FUNCTION(_PDF_place_pdi_page)
    CONCEPT_FUNCTION(_PDF_process_pdi)
    CONCEPT_FUNCTION(_PDF_rcurveto)
    CONCEPT_FUNCTION(_PDF_rect)
    CONCEPT_FUNCTION(_PDF_restore)
    CONCEPT_FUNCTION(_PDF_resume_page)
    CONCEPT_FUNCTION(_PDF_rlineto)
    CONCEPT_FUNCTION(_PDF_rmoveto)
    CONCEPT_FUNCTION(_PDF_rotate)
    CONCEPT_FUNCTION(_PDF_save)
    CONCEPT_FUNCTION(_PDF_scale)
    CONCEPT_FUNCTION(_PDF_set_border_color)
    CONCEPT_FUNCTION(_PDF_set_border_dash)
    CONCEPT_FUNCTION(_PDF_set_border_style)
    CONCEPT_FUNCTION(_PDF_set_gstate)
    CONCEPT_FUNCTION(_PDF_set_info)
    CONCEPT_FUNCTION(_PDF_set_info2)
    CONCEPT_FUNCTION(_PDF_set_layer_dependency)
    CONCEPT_FUNCTION(_PDF_set_parameter)
    CONCEPT_FUNCTION(_PDF_set_text_pos)
    CONCEPT_FUNCTION(_PDF_set_value)
    CONCEPT_FUNCTION(_PDF_setcolor)
    CONCEPT_FUNCTION(_PDF_setdash)
    CONCEPT_FUNCTION(_PDF_setdashpattern)
    CONCEPT_FUNCTION(_PDF_setflat)
    CONCEPT_FUNCTION(_PDF_setfont)
    CONCEPT_FUNCTION(_PDF_setgray)
    CONCEPT_FUNCTION(_PDF_setgray_fill)
    CONCEPT_FUNCTION(_PDF_setgray_stroke)
    CONCEPT_FUNCTION(_PDF_setlinecap)
    CONCEPT_FUNCTION(_PDF_setlinejoin)
    CONCEPT_FUNCTION(_PDF_setlinewidth)
    CONCEPT_FUNCTION(_PDF_setmatrix)
    CONCEPT_FUNCTION(_PDF_setmiterlimit)
    //CONCEPT_FUNCTION(_PDF_setpolydash)
    CONCEPT_FUNCTION(_PDF_setrgbcolor)
    CONCEPT_FUNCTION(_PDF_setrgbcolor_fill)
    CONCEPT_FUNCTION(_PDF_setrgbcolor_stroke)
    CONCEPT_FUNCTION(_PDF_shading)
    CONCEPT_FUNCTION(_PDF_shading_pattern)
    CONCEPT_FUNCTION(_PDF_shfill)
    CONCEPT_FUNCTION(_PDF_show)
    CONCEPT_FUNCTION(_PDF_show2)
    CONCEPT_FUNCTION(_PDF_show_boxed)
    CONCEPT_FUNCTION(_PDF_show_boxed2)
    CONCEPT_FUNCTION(_PDF_show_xy)
    CONCEPT_FUNCTION(_PDF_show_xy2)
    CONCEPT_FUNCTION(_PDF_shutdown)
    CONCEPT_FUNCTION(_PDF_skew)
    CONCEPT_FUNCTION(_PDF_stringwidth)
    CONCEPT_FUNCTION(_PDF_stringwidth2)
    CONCEPT_FUNCTION(_PDF_stroke)
    CONCEPT_FUNCTION(_PDF_suspend_page)
    CONCEPT_FUNCTION(_PDF_translate)
    CONCEPT_FUNCTION(_PDF_utf16_to_utf8)
    CONCEPT_FUNCTION(_PDF_utf32_to_utf16)
    CONCEPT_FUNCTION(_PDF_utf8_to_utf16)
}



#endif // __LIBRARY_H
