//------------ standard header -----------------------------------//
#include "stdlibrary.h"
//------------ end of standard header ----------------------------//
#include "library.h"
#include <string.h>
#include "AnsiString.h"
extern "C" {
	#include <pdflib.h>
}


INVOKE_CALL InvokePtr=0;

//-----------------------------------------------------------------------------------
CONCEPT_DLL_API ON_CREATE_CONTEXT MANAGEMENT_PARAMETERS {
    InvokePtr=Invoke;

	DEFINE_ECONSTANT(PDFLIB_MAJORVERSION)
	DEFINE_ECONSTANT(PDFLIB_MINORVERSION)
	DEFINE_ECONSTANT(PDFLIB_REVISION)
	DEFINE_ESCONSTANT(PDFLIB_VERSIONSTRING)

	DEFINE_ECONSTANT(PDF_MemoryError)
	DEFINE_ECONSTANT(PDF_IOError)
	DEFINE_ECONSTANT(PDF_RuntimeError)
	DEFINE_ECONSTANT(PDF_IndexError)
	DEFINE_ECONSTANT(PDF_TypeError)
	DEFINE_ECONSTANT(PDF_DivisionByZero)
	DEFINE_ECONSTANT(PDF_OverflowError)
	DEFINE_ECONSTANT(PDF_SyntaxError)
	DEFINE_ECONSTANT(PDF_ValueError)
	DEFINE_ECONSTANT(PDF_SystemError)

	DEFINE_ECONSTANT(PDF_NonfatalError)
	DEFINE_ECONSTANT(PDF_UnknownError)

	DEFINE_ECONSTANT(a0_width)
	DEFINE_ECONSTANT(a0_height)
	DEFINE_ECONSTANT(a1_width)
	DEFINE_ECONSTANT(a1_height)
	DEFINE_ECONSTANT(a2_width)
	DEFINE_ECONSTANT(a2_height)
	DEFINE_ECONSTANT(a3_width)
	DEFINE_ECONSTANT(a3_height)
	DEFINE_ECONSTANT(a4_width)
	DEFINE_ECONSTANT(a4_height)
	DEFINE_ECONSTANT(a5_width)
	DEFINE_ECONSTANT(a5_height)
	DEFINE_ECONSTANT(a6_width)
	DEFINE_ECONSTANT(a6_height)
	DEFINE_ECONSTANT(b5_width)
	DEFINE_ECONSTANT(b5_height)
	DEFINE_ECONSTANT(letter_width)
	DEFINE_ECONSTANT(letter_height)
	DEFINE_ECONSTANT(legal_width)
	DEFINE_ECONSTANT(legal_height)
	DEFINE_ECONSTANT(ledger_width)
	DEFINE_ECONSTANT(ledger_height)
	DEFINE_ECONSTANT(p11x17_width)
	DEFINE_ECONSTANT(p11x17_height)

	return 0;
}
//---------------------------------------------------------------------------
CONCEPT_DLL_API ON_DESTROY_CONTEXT MANAGEMENT_PARAMETERS {
	return 0;
}
//---------------------------------------------------------------------------
// Autogenerated ...
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_activate_item,2)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // int

	PDF_activate_item((PDF*)(long)PARAM(0), (int)PARAM(1));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_add_bookmark,4)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_NUMBER(2) // int
	T_NUMBER(3) // int

	RETURN_NUMBER(PDF_add_bookmark((PDF*)(long)PARAM(0), PARAM(1), (int)PARAM(2), (int)PARAM(3)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_add_bookmark2,5)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_NUMBER(2) // int
	T_NUMBER(3) // int
	T_NUMBER(4) // int

	RETURN_NUMBER(PDF_add_bookmark2((PDF*)(long)PARAM(0), PARAM(1), (int)PARAM(2), (int)PARAM(3), (int)PARAM(4)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_add_launchlink,6)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // double
	T_NUMBER(2) // double
	T_NUMBER(3) // double
	T_NUMBER(4) // double
	T_STRING(5) // char*

	PDF_add_launchlink((PDF*)(long)PARAM(0), (double)PARAM(1), (double)PARAM(2), (double)PARAM(3), (double)PARAM(4), PARAM(5));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_add_locallink,7)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // double
	T_NUMBER(2) // double
	T_NUMBER(3) // double
	T_NUMBER(4) // double
	T_NUMBER(5) // int
	T_STRING(6) // char*

	PDF_add_locallink((PDF*)(long)PARAM(0), (double)PARAM(1), (double)PARAM(2), (double)PARAM(3), (double)PARAM(4), (int)PARAM(5), PARAM(6));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_add_nameddest,4)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_NUMBER(2) // int
	T_STRING(3) // char*

	PDF_add_nameddest((PDF*)(long)PARAM(0), PARAM(1), (int)PARAM(2), PARAM(3));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_add_note,9)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // double
	T_NUMBER(2) // double
	T_NUMBER(3) // double
	T_NUMBER(4) // double
	T_STRING(5) // char*
	T_STRING(6) // char*
	T_STRING(7) // char*
	T_NUMBER(8) // int

	PDF_add_note((PDF*)(long)PARAM(0), (double)PARAM(1), (double)PARAM(2), (double)PARAM(3), (double)PARAM(4), PARAM(5), PARAM(6), PARAM(7), (int)PARAM(8));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_add_note2,11)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // double
	T_NUMBER(2) // double
	T_NUMBER(3) // double
	T_NUMBER(4) // double
	T_STRING(5) // char*
	T_NUMBER(6) // int
	T_STRING(7) // char*
	T_NUMBER(8) // int
	T_STRING(9) // char*
	T_NUMBER(10) // int

	PDF_add_note2((PDF*)(long)PARAM(0), (double)PARAM(1), (double)PARAM(2), (double)PARAM(3), (double)PARAM(4), PARAM(5), (int)PARAM(6), PARAM(7), (int)PARAM(8), PARAM(9), (int)PARAM(10));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_add_pdflink,8)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // double
	T_NUMBER(2) // double
	T_NUMBER(3) // double
	T_NUMBER(4) // double
	T_STRING(5) // char*
	T_NUMBER(6) // int
	T_STRING(7) // char*

	PDF_add_pdflink((PDF*)(long)PARAM(0), (double)PARAM(1), (double)PARAM(2), (double)PARAM(3), (double)PARAM(4), PARAM(5), (int)PARAM(6), PARAM(7));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_add_table_cell,7)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // int
	T_NUMBER(2) // int
	T_NUMBER(3) // int
	T_STRING(4) // char*
	T_NUMBER(5) // int
	T_STRING(6) // char*

	RETURN_NUMBER(PDF_add_table_cell((PDF*)(long)PARAM(0), (int)PARAM(1), (int)PARAM(2), (int)PARAM(3), PARAM(4), (int)PARAM(5), PARAM(6)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_add_textflow,5)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // int
	T_STRING(2) // char*
	T_NUMBER(3) // int
	T_STRING(4) // char*

	RETURN_NUMBER(PDF_add_textflow((PDF*)(long)PARAM(0), (int)PARAM(1), PARAM(2), (int)PARAM(3), PARAM(4)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_add_thumbnail,2)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // int

	PDF_add_thumbnail((PDF*)(long)PARAM(0), (int)PARAM(1));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_add_weblink,6)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // double
	T_NUMBER(2) // double
	T_NUMBER(3) // double
	T_NUMBER(4) // double
	T_STRING(5) // char*

	PDF_add_weblink((PDF*)(long)PARAM(0), (double)PARAM(1), (double)PARAM(2), (double)PARAM(3), (double)PARAM(4), PARAM(5));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_arc,6)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // double
	T_NUMBER(2) // double
	T_NUMBER(3) // double
	T_NUMBER(4) // double
	T_NUMBER(5) // double

	PDF_arc((PDF*)(long)PARAM(0), (double)PARAM(1), (double)PARAM(2), (double)PARAM(3), (double)PARAM(4), (double)PARAM(5));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_arcn,6)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // double
	T_NUMBER(2) // double
	T_NUMBER(3) // double
	T_NUMBER(4) // double
	T_NUMBER(5) // double

	PDF_arcn((PDF*)(long)PARAM(0), (double)PARAM(1), (double)PARAM(2), (double)PARAM(3), (double)PARAM(4), (double)PARAM(5));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_attach_file,10)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // double
	T_NUMBER(2) // double
	T_NUMBER(3) // double
	T_NUMBER(4) // double
	T_STRING(5) // char*
	T_STRING(6) // char*
	T_STRING(7) // char*
	T_STRING(8) // char*
	T_STRING(9) // char*

	PDF_attach_file((PDF*)(long)PARAM(0), (double)PARAM(1), (double)PARAM(2), (double)PARAM(3), (double)PARAM(4), PARAM(5), PARAM(6), PARAM(7), PARAM(8), PARAM(9));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_attach_file2,13)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // double
	T_NUMBER(2) // double
	T_NUMBER(3) // double
	T_NUMBER(4) // double
	T_STRING(5) // char*
	T_NUMBER(6) // int
	T_STRING(7) // char*
	T_NUMBER(8) // int
	T_STRING(9) // char*
	T_NUMBER(10) // int
	T_STRING(11) // char*
	T_STRING(12) // char*

	PDF_attach_file2((PDF*)(long)PARAM(0), (double)PARAM(1), (double)PARAM(2), (double)PARAM(3), (double)PARAM(4), PARAM(5), (int)PARAM(6), PARAM(7), (int)PARAM(8), PARAM(9), (int)PARAM(10), PARAM(11), PARAM(12));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_begin_document,4)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_NUMBER(2) // int
	T_STRING(3) // char*

	RETURN_NUMBER(PDF_begin_document((PDF*)(long)PARAM(0), PARAM(1), (int)PARAM(2), PARAM(3)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_begin_font,10)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_NUMBER(2) // int
	T_NUMBER(3) // double
	T_NUMBER(4) // double
	T_NUMBER(5) // double
	T_NUMBER(6) // double
	T_NUMBER(7) // double
	T_NUMBER(8) // double
	T_STRING(9) // char*

	PDF_begin_font((PDF*)(long)PARAM(0), PARAM(1), (int)PARAM(2), (double)PARAM(3), (double)PARAM(4), (double)PARAM(5), (double)PARAM(6), (double)PARAM(7), (double)PARAM(8), PARAM(9));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_begin_glyph,7)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_NUMBER(2) // double
	T_NUMBER(3) // double
	T_NUMBER(4) // double
	T_NUMBER(5) // double
	T_NUMBER(6) // double

	PDF_begin_glyph((PDF*)(long)PARAM(0), PARAM(1), (double)PARAM(2), (double)PARAM(3), (double)PARAM(4), (double)PARAM(5), (double)PARAM(6));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_begin_item,3)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_STRING(2) // char*

	RETURN_NUMBER(PDF_begin_item((PDF*)(long)PARAM(0), PARAM(1), PARAM(2)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_begin_layer,2)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // int

	PDF_begin_layer((PDF*)(long)PARAM(0), (int)PARAM(1));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_begin_mc,3)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_STRING(2) // char*

	PDF_begin_mc((PDF*)(long)PARAM(0), PARAM(1), PARAM(2));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_begin_page,3)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // double
	T_NUMBER(2) // double

	PDF_begin_page((PDF*)(long)PARAM(0), (double)PARAM(1), (double)PARAM(2));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_begin_page_ext,4)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // double
	T_NUMBER(2) // double
	T_STRING(3) // char*

	PDF_begin_page_ext((PDF*)(long)PARAM(0), (double)PARAM(1), (double)PARAM(2), PARAM(3));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_begin_pattern,6)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // double
	T_NUMBER(2) // double
	T_NUMBER(3) // double
	T_NUMBER(4) // double
	T_NUMBER(5) // int

	RETURN_NUMBER(PDF_begin_pattern((PDF*)(long)PARAM(0), (double)PARAM(1), (double)PARAM(2), (double)PARAM(3), (double)PARAM(4), (int)PARAM(5)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_begin_template,3)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // double
	T_NUMBER(2) // double

	RETURN_NUMBER(PDF_begin_template((PDF*)(long)PARAM(0), (double)PARAM(1), (double)PARAM(2)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_begin_template_ext,4)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // double
	T_NUMBER(2) // double
	T_STRING(3) // char*

	RETURN_NUMBER(PDF_begin_template_ext((PDF*)(long)PARAM(0), (double)PARAM(1), (double)PARAM(2), PARAM(3)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_boot,0)

	PDF_boot();
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_check_context,1)
	T_NUMBER(0) // PDF*

	RETURN_NUMBER(PDF_check_context((PDF*)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_circle,4)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // double
	T_NUMBER(2) // double
	T_NUMBER(3) // double

	PDF_circle((PDF*)(long)PARAM(0), (double)PARAM(1), (double)PARAM(2), (double)PARAM(3));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_clip,1)
	T_NUMBER(0) // PDF*

	PDF_clip((PDF*)(long)PARAM(0));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_close,1)
	T_NUMBER(0) // PDF*

	PDF_close((PDF*)(long)PARAM(0));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_close_image,2)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // int

	PDF_close_image((PDF*)(long)PARAM(0), (int)PARAM(1));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_close_pdi,2)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // int

	PDF_close_pdi((PDF*)(long)PARAM(0), (int)PARAM(1));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_close_pdi_document,2)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // int

	PDF_close_pdi_document((PDF*)(long)PARAM(0), (int)PARAM(1));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_close_pdi_page,2)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // int

	PDF_close_pdi_page((PDF*)(long)PARAM(0), (int)PARAM(1));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_closepath,1)
	T_NUMBER(0) // PDF*

	PDF_closepath((PDF*)(long)PARAM(0));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_closepath_fill_stroke,1)
	T_NUMBER(0) // PDF*

	PDF_closepath_fill_stroke((PDF*)(long)PARAM(0));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_closepath_stroke,1)
	T_NUMBER(0) // PDF*

	PDF_closepath_stroke((PDF*)(long)PARAM(0));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_concat,7)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // double
	T_NUMBER(2) // double
	T_NUMBER(3) // double
	T_NUMBER(4) // double
	T_NUMBER(5) // double
	T_NUMBER(6) // double

	PDF_concat((PDF*)(long)PARAM(0), (double)PARAM(1), (double)PARAM(2), (double)PARAM(3), (double)PARAM(4), (double)PARAM(5), (double)PARAM(6));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_continue_text,2)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*

	PDF_continue_text((PDF*)(long)PARAM(0), PARAM(1));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_continue_text2,3)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_NUMBER(2) // int

	PDF_continue_text2((PDF*)(long)PARAM(0), PARAM(1), (int)PARAM(2));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_create_3dview,4)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_NUMBER(2) // int
	T_STRING(3) // char*

	RETURN_NUMBER(PDF_create_3dview((PDF*)(long)PARAM(0), PARAM(1), (int)PARAM(2), PARAM(3)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_create_action,3)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_STRING(2) // char*

	RETURN_NUMBER(PDF_create_action((PDF*)(long)PARAM(0), PARAM(1), PARAM(2)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_create_annotation,7)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // double
	T_NUMBER(2) // double
	T_NUMBER(3) // double
	T_NUMBER(4) // double
	T_STRING(5) // char*
	T_STRING(6) // char*

	PDF_create_annotation((PDF*)(long)PARAM(0), (double)PARAM(1), (double)PARAM(2), (double)PARAM(3), (double)PARAM(4), PARAM(5), PARAM(6));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_create_bookmark,4)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_NUMBER(2) // int
	T_STRING(3) // char*

	RETURN_NUMBER(PDF_create_bookmark((PDF*)(long)PARAM(0), PARAM(1), (int)PARAM(2), PARAM(3)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_create_field,9)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // double
	T_NUMBER(2) // double
	T_NUMBER(3) // double
	T_NUMBER(4) // double
	T_STRING(5) // char*
	T_NUMBER(6) // int
	T_STRING(7) // char*
	T_STRING(8) // char*

	PDF_create_field((PDF*)(long)PARAM(0), (double)PARAM(1), (double)PARAM(2), (double)PARAM(3), (double)PARAM(4), PARAM(5), (int)PARAM(6), PARAM(7), PARAM(8));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_create_fieldgroup,4)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_NUMBER(2) // int
	T_STRING(3) // char*

	PDF_create_fieldgroup((PDF*)(long)PARAM(0), PARAM(1), (int)PARAM(2), PARAM(3));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_create_gstate,2)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*

	RETURN_NUMBER(PDF_create_gstate((PDF*)(long)PARAM(0), PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_create_pvf,6)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_NUMBER(2) // int
	T_STRING(3) // char*
	T_NUMBER(4) // size_t
	T_STRING(5) // char*

	PDF_create_pvf((PDF*)(long)PARAM(0), PARAM(1), (int)PARAM(2), PARAM(3), (size_t)PARAM(4), PARAM(5));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_create_textflow,4)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_NUMBER(2) // int
	T_STRING(3) // char*

	RETURN_NUMBER(PDF_create_textflow((PDF*)(long)PARAM(0), PARAM(1), (int)PARAM(2), PARAM(3)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_curveto,7)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // double
	T_NUMBER(2) // double
	T_NUMBER(3) // double
	T_NUMBER(4) // double
	T_NUMBER(5) // double
	T_NUMBER(6) // double

	PDF_curveto((PDF*)(long)PARAM(0), (double)PARAM(1), (double)PARAM(2), (double)PARAM(3), (double)PARAM(4), (double)PARAM(5), (double)PARAM(6));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_define_layer,4)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_NUMBER(2) // int
	T_STRING(3) // char*

	RETURN_NUMBER(PDF_define_layer((PDF*)(long)PARAM(0), PARAM(1), (int)PARAM(2), PARAM(3)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_delete,1)
	T_NUMBER(0) // PDF*

	PDF_delete((PDF*)(long)PARAM(0));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_delete_pvf,3)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_NUMBER(2) // int

	RETURN_NUMBER(PDF_delete_pvf((PDF*)(long)PARAM(0), PARAM(1), (int)PARAM(2)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_delete_table,3)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // int
	T_STRING(2) // char*

	PDF_delete_table((PDF*)(long)PARAM(0), (int)PARAM(1), PARAM(2));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_delete_textflow,2)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // int

	PDF_delete_textflow((PDF*)(long)PARAM(0), (int)PARAM(1));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_encoding_set_char,5)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_NUMBER(2) // int
	T_STRING(3) // char*
	T_NUMBER(4) // int

	PDF_encoding_set_char((PDF*)(long)PARAM(0), PARAM(1), (int)PARAM(2), PARAM(3), (int)PARAM(4));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_end_document,2)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*

	PDF_end_document((PDF*)(long)PARAM(0), PARAM(1));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_end_font,1)
	T_NUMBER(0) // PDF*

	PDF_end_font((PDF*)(long)PARAM(0));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_end_glyph,1)
	T_NUMBER(0) // PDF*

	PDF_end_glyph((PDF*)(long)PARAM(0));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_end_item,2)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // int

	PDF_end_item((PDF*)(long)PARAM(0), (int)PARAM(1));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_end_layer,1)
	T_NUMBER(0) // PDF*

	PDF_end_layer((PDF*)(long)PARAM(0));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_end_mc,1)
	T_NUMBER(0) // PDF*

	PDF_end_mc((PDF*)(long)PARAM(0));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_end_page,1)
	T_NUMBER(0) // PDF*

	PDF_end_page((PDF*)(long)PARAM(0));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_end_page_ext,2)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*

	PDF_end_page_ext((PDF*)(long)PARAM(0), PARAM(1));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_end_pattern,1)
	T_NUMBER(0) // PDF*

	PDF_end_pattern((PDF*)(long)PARAM(0));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_end_template,1)
	T_NUMBER(0) // PDF*

	PDF_end_template((PDF*)(long)PARAM(0));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_endpath,1)
	T_NUMBER(0) // PDF*

	PDF_endpath((PDF*)(long)PARAM(0));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_fill,1)
	T_NUMBER(0) // PDF*

	PDF_fill((PDF*)(long)PARAM(0));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_fill_imageblock,5)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // int
	T_STRING(2) // char*
	T_NUMBER(3) // int
	T_STRING(4) // char*

	RETURN_NUMBER(PDF_fill_imageblock((PDF*)(long)PARAM(0), (int)PARAM(1), PARAM(2), (int)PARAM(3), PARAM(4)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_fill_pdfblock,5)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // int
	T_STRING(2) // char*
	T_NUMBER(3) // int
	T_STRING(4) // char*

	RETURN_NUMBER(PDF_fill_pdfblock((PDF*)(long)PARAM(0), (int)PARAM(1), PARAM(2), (int)PARAM(3), PARAM(4)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_fill_stroke,1)
	T_NUMBER(0) // PDF*

	PDF_fill_stroke((PDF*)(long)PARAM(0));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_fill_textblock,6)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // int
	T_STRING(2) // char*
	T_STRING(3) // char*
	T_NUMBER(4) // int
	T_STRING(5) // char*

	RETURN_NUMBER(PDF_fill_textblock((PDF*)(long)PARAM(0), (int)PARAM(1), PARAM(2), PARAM(3), (int)PARAM(4), PARAM(5)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_findfont,4)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_STRING(2) // char*
	T_NUMBER(3) // int

	RETURN_NUMBER(PDF_findfont((PDF*)(long)PARAM(0), PARAM(1), PARAM(2), (int)PARAM(3)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_fit_image,5)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // int
	T_NUMBER(2) // double
	T_NUMBER(3) // double
	T_STRING(4) // char*

	PDF_fit_image((PDF*)(long)PARAM(0), (int)PARAM(1), (double)PARAM(2), (double)PARAM(3), PARAM(4));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_fit_pdi_page,5)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // int
	T_NUMBER(2) // double
	T_NUMBER(3) // double
	T_STRING(4) // char*

	PDF_fit_pdi_page((PDF*)(long)PARAM(0), (int)PARAM(1), (double)PARAM(2), (double)PARAM(3), PARAM(4));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_fit_table,7)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // int
	T_NUMBER(2) // double
	T_NUMBER(3) // double
	T_NUMBER(4) // double
	T_NUMBER(5) // double
	T_STRING(6) // char*

	RETURN_STRING((char *)PDF_fit_table((PDF*)(long)PARAM(0), (int)PARAM(1), (double)PARAM(2), (double)PARAM(3), (double)PARAM(4), (double)PARAM(5), PARAM(6)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_fit_textflow,7)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // int
	T_NUMBER(2) // double
	T_NUMBER(3) // double
	T_NUMBER(4) // double
	T_NUMBER(5) // double
	T_STRING(6) // char*

	RETURN_STRING((char *)PDF_fit_textflow((PDF*)(long)PARAM(0), (int)PARAM(1), (double)PARAM(2), (double)PARAM(3), (double)PARAM(4), (double)PARAM(5), PARAM(6)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_fit_textline,6)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_NUMBER(2) // int
	T_NUMBER(3) // double
	T_NUMBER(4) // double
	T_STRING(5) // char*

	PDF_fit_textline((PDF*)(long)PARAM(0), PARAM(1), (int)PARAM(2), (double)PARAM(3), (double)PARAM(4), PARAM(5));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_get_apiname,1)
	T_NUMBER(0) // PDF*

	RETURN_STRING((char *)PDF_get_apiname((PDF*)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_get_buffer,2)
	T_NUMBER(0) // PDF*

	// ... parameter 1 is by reference (long*)
	long local_parameter_1;

	RETURN_BUFFER(PDF_get_buffer((PDF*)(long)PARAM(0), &local_parameter_1), local_parameter_1)
	SET_NUMBER(1, local_parameter_1);
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_get_errmsg,1)
	T_NUMBER(0) // PDF*

	RETURN_STRING((char *)PDF_get_errmsg((PDF*)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_get_errnum,1)
	T_NUMBER(0) // PDF*

	RETURN_NUMBER(PDF_get_errnum((PDF*)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_get_kern_amount,4)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // int
	T_NUMBER(2) // int
	T_NUMBER(3) // int

	RETURN_NUMBER(PDF_get_kern_amount((PDF*)(long)PARAM(0), (int)PARAM(1), (int)PARAM(2), (int)PARAM(3)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_get_majorversion,0)

	RETURN_NUMBER(PDF_get_majorversion())
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_get_minorversion,0)

	RETURN_NUMBER(PDF_get_minorversion())
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_get_opaque,1)
	T_NUMBER(0) // PDF*

	RETURN_NUMBER((long)PDF_get_opaque((PDF*)(long)PARAM(0)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_get_parameter,3)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_NUMBER(2) // double

	RETURN_STRING((char *)PDF_get_parameter((PDF*)(long)PARAM(0), PARAM(1), (double)PARAM(2)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_get_pdi_parameter,6)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_NUMBER(2) // int
	T_NUMBER(3) // int
	T_NUMBER(4) // int

	// ... parameter 5 is by reference (int*)
	int local_parameter_5;

	RETURN_BUFFER((char *)PDF_get_pdi_parameter((PDF*)(long)PARAM(0), PARAM(1), (int)PARAM(2), (int)PARAM(3), (int)PARAM(4), &local_parameter_5), local_parameter_5)
	SET_NUMBER(5, local_parameter_5);
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_get_pdi_value,5)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_NUMBER(2) // int
	T_NUMBER(3) // int
	T_NUMBER(4) // int

	RETURN_NUMBER(PDF_get_pdi_value((PDF*)(long)PARAM(0), PARAM(1), (int)PARAM(2), (int)PARAM(3), (int)PARAM(4)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_get_value,3)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_NUMBER(2) // double

	RETURN_NUMBER(PDF_get_value((PDF*)(long)PARAM(0), PARAM(1), (double)PARAM(2)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_info_font,4)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // int
	T_STRING(2) // char*
	T_STRING(3) // char*

	RETURN_NUMBER(PDF_info_font((PDF*)(long)PARAM(0), (int)PARAM(1), PARAM(2), PARAM(3)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_info_matchbox,5)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_NUMBER(2) // int
	T_NUMBER(3) // int
	T_STRING(4) // char*

	RETURN_NUMBER(PDF_info_matchbox((PDF*)(long)PARAM(0), PARAM(1), (int)PARAM(2), (int)PARAM(3), PARAM(4)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_info_table,3)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // int
	T_STRING(2) // char*

	RETURN_NUMBER(PDF_info_table((PDF*)(long)PARAM(0), (int)PARAM(1), PARAM(2)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_info_textflow,3)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // int
	T_STRING(2) // char*

	RETURN_NUMBER(PDF_info_textflow((PDF*)(long)PARAM(0), (int)PARAM(1), PARAM(2)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_info_textline,5)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_NUMBER(2) // int
	T_STRING(3) // char*
	T_STRING(4) // char*

	RETURN_NUMBER(PDF_info_textline((PDF*)(long)PARAM(0), PARAM(1), (int)PARAM(2), PARAM(3), PARAM(4)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_initgraphics,1)
	T_NUMBER(0) // PDF*

	PDF_initgraphics((PDF*)(long)PARAM(0));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_lineto,3)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // double
	T_NUMBER(2) // double

	PDF_lineto((PDF*)(long)PARAM(0), (double)PARAM(1), (double)PARAM(2));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_load_3ddata,4)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_NUMBER(2) // int
	T_STRING(3) // char*

	RETURN_NUMBER(PDF_load_3ddata((PDF*)(long)PARAM(0), PARAM(1), (int)PARAM(2), PARAM(3)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_load_font,5)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_NUMBER(2) // int
	T_STRING(3) // char*
	T_STRING(4) // char*

	RETURN_NUMBER(PDF_load_font((PDF*)(long)PARAM(0), PARAM(1), (int)PARAM(2), PARAM(3), PARAM(4)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_load_iccprofile,4)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_NUMBER(2) // int
	T_STRING(3) // char*

	RETURN_NUMBER(PDF_load_iccprofile((PDF*)(long)PARAM(0), PARAM(1), (int)PARAM(2), PARAM(3)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_load_image,5)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_STRING(2) // char*
	T_NUMBER(3) // int
	T_STRING(4) // char*

	RETURN_NUMBER(PDF_load_image((PDF*)(long)PARAM(0), PARAM(1), PARAM(2), (int)PARAM(3), PARAM(4)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_makespotcolor,3)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_NUMBER(2) // int

	RETURN_NUMBER(PDF_makespotcolor((PDF*)(long)PARAM(0), PARAM(1), (int)PARAM(2)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_mc_point,3)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_STRING(2) // char*

	PDF_mc_point((PDF*)(long)PARAM(0), PARAM(1), PARAM(2));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_moveto,3)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // double
	T_NUMBER(2) // double

	PDF_moveto((PDF*)(long)PARAM(0), (double)PARAM(1), (double)PARAM(2));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_new,0)

	RETURN_NUMBER((long)PDF_new())
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_open_CCITT,7)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_NUMBER(2) // int
	T_NUMBER(3) // int
	T_NUMBER(4) // int
	T_NUMBER(5) // int
	T_NUMBER(6) // int

	RETURN_NUMBER(PDF_open_CCITT((PDF*)(long)PARAM(0), PARAM(1), (int)PARAM(2), (int)PARAM(3), (int)PARAM(4), (int)PARAM(5), (int)PARAM(6)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_open_file,2)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*

	RETURN_NUMBER(PDF_open_file((PDF*)(long)PARAM(0), PARAM(1)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_open_image,10)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_STRING(2) // char*
	T_STRING(3) // char*
	T_NUMBER(4) // long
	T_NUMBER(5) // int
	T_NUMBER(6) // int
	T_NUMBER(7) // int
	T_NUMBER(8) // int
	T_STRING(9) // char*

	RETURN_NUMBER(PDF_open_image((PDF*)(long)PARAM(0), PARAM(1), PARAM(2), PARAM(3), (long)PARAM(4), (int)PARAM(5), (int)PARAM(6), (int)PARAM(7), (int)PARAM(8), PARAM(9)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_open_image_file,5)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_STRING(2) // char*
	T_STRING(3) // char*
	T_NUMBER(4) // int

	RETURN_NUMBER(PDF_open_image_file((PDF*)(long)PARAM(0), PARAM(1), PARAM(2), PARAM(3), (int)PARAM(4)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_open_pdi,4)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_STRING(2) // char*
	T_NUMBER(3) // int

	RETURN_NUMBER(PDF_open_pdi((PDF*)(long)PARAM(0), PARAM(1), PARAM(2), (int)PARAM(3)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_open_pdi_document,4)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_NUMBER(2) // int
	T_STRING(3) // char*

	RETURN_NUMBER(PDF_open_pdi_document((PDF*)(long)PARAM(0), PARAM(1), (int)PARAM(2), PARAM(3)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_open_pdi_page,4)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // int
	T_NUMBER(2) // int
	T_STRING(3) // char*

	RETURN_NUMBER(PDF_open_pdi_page((PDF*)(long)PARAM(0), (int)PARAM(1), (int)PARAM(2), PARAM(3)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_place_image,5)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // int
	T_NUMBER(2) // double
	T_NUMBER(3) // double
	T_NUMBER(4) // double

	PDF_place_image((PDF*)(long)PARAM(0), (int)PARAM(1), (double)PARAM(2), (double)PARAM(3), (double)PARAM(4));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_place_pdi_page,6)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // int
	T_NUMBER(2) // double
	T_NUMBER(3) // double
	T_NUMBER(4) // double
	T_NUMBER(5) // double

	PDF_place_pdi_page((PDF*)(long)PARAM(0), (int)PARAM(1), (double)PARAM(2), (double)PARAM(3), (double)PARAM(4), (double)PARAM(5));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_process_pdi,4)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // int
	T_NUMBER(2) // int
	T_STRING(3) // char*

	RETURN_NUMBER(PDF_process_pdi((PDF*)(long)PARAM(0), (int)PARAM(1), (int)PARAM(2), PARAM(3)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_rcurveto,7)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // double
	T_NUMBER(2) // double
	T_NUMBER(3) // double
	T_NUMBER(4) // double
	T_NUMBER(5) // double
	T_NUMBER(6) // double

	PDF_rcurveto((PDF*)(long)PARAM(0), (double)PARAM(1), (double)PARAM(2), (double)PARAM(3), (double)PARAM(4), (double)PARAM(5), (double)PARAM(6));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_rect,5)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // double
	T_NUMBER(2) // double
	T_NUMBER(3) // double
	T_NUMBER(4) // double

	PDF_rect((PDF*)(long)PARAM(0), (double)PARAM(1), (double)PARAM(2), (double)PARAM(3), (double)PARAM(4));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_restore,1)
	T_NUMBER(0) // PDF*

	PDF_restore((PDF*)(long)PARAM(0));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_resume_page,2)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*

	PDF_resume_page((PDF*)(long)PARAM(0), PARAM(1));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_rlineto,3)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // double
	T_NUMBER(2) // double

	PDF_rlineto((PDF*)(long)PARAM(0), (double)PARAM(1), (double)PARAM(2));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_rmoveto,3)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // double
	T_NUMBER(2) // double

	PDF_rmoveto((PDF*)(long)PARAM(0), (double)PARAM(1), (double)PARAM(2));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_rotate,2)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // double

	PDF_rotate((PDF*)(long)PARAM(0), (double)PARAM(1));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_save,1)
	T_NUMBER(0) // PDF*

	PDF_save((PDF*)(long)PARAM(0));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_scale,3)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // double
	T_NUMBER(2) // double

	PDF_scale((PDF*)(long)PARAM(0), (double)PARAM(1), (double)PARAM(2));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_set_border_color,4)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // double
	T_NUMBER(2) // double
	T_NUMBER(3) // double

	PDF_set_border_color((PDF*)(long)PARAM(0), (double)PARAM(1), (double)PARAM(2), (double)PARAM(3));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_set_border_dash,3)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // double
	T_NUMBER(2) // double

	PDF_set_border_dash((PDF*)(long)PARAM(0), (double)PARAM(1), (double)PARAM(2));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_set_border_style,3)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_NUMBER(2) // double

	PDF_set_border_style((PDF*)(long)PARAM(0), PARAM(1), (double)PARAM(2));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_set_gstate,2)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // int

	PDF_set_gstate((PDF*)(long)PARAM(0), (int)PARAM(1));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_set_info,3)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_STRING(2) // char*

	PDF_set_info((PDF*)(long)PARAM(0), PARAM(1), PARAM(2));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_set_info2,4)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_STRING(2) // char*
	T_NUMBER(3) // int

	PDF_set_info2((PDF*)(long)PARAM(0), PARAM(1), PARAM(2), (int)PARAM(3));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_set_layer_dependency,3)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_STRING(2) // char*

	PDF_set_layer_dependency((PDF*)(long)PARAM(0), PARAM(1), PARAM(2));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_set_parameter,3)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_STRING(2) // char*

	PDF_set_parameter((PDF*)(long)PARAM(0), PARAM(1), PARAM(2));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_set_text_pos,3)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // double
	T_NUMBER(2) // double

	PDF_set_text_pos((PDF*)(long)PARAM(0), (double)PARAM(1), (double)PARAM(2));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_set_value,3)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_NUMBER(2) // double

	PDF_set_value((PDF*)(long)PARAM(0), PARAM(1), (double)PARAM(2));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_setcolor,7)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_STRING(2) // char*
	T_NUMBER(3) // double
	T_NUMBER(4) // double
	T_NUMBER(5) // double
	T_NUMBER(6) // double

	PDF_setcolor((PDF*)(long)PARAM(0), PARAM(1), PARAM(2), (double)PARAM(3), (double)PARAM(4), (double)PARAM(5), (double)PARAM(6));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_setdash,3)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // double
	T_NUMBER(2) // double

	PDF_setdash((PDF*)(long)PARAM(0), (double)PARAM(1), (double)PARAM(2));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_setdashpattern,2)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*

	PDF_setdashpattern((PDF*)(long)PARAM(0), PARAM(1));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_setflat,2)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // double

	PDF_setflat((PDF*)(long)PARAM(0), (double)PARAM(1));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_setfont,3)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // int
	T_NUMBER(2) // double

	PDF_setfont((PDF*)(long)PARAM(0), (int)PARAM(1), (double)PARAM(2));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_setgray,2)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // double

	PDF_setgray((PDF*)(long)PARAM(0), (double)PARAM(1));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_setgray_fill,2)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // double

	PDF_setgray_fill((PDF*)(long)PARAM(0), (double)PARAM(1));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_setgray_stroke,2)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // double

	PDF_setgray_stroke((PDF*)(long)PARAM(0), (double)PARAM(1));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_setlinecap,2)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // int

	PDF_setlinecap((PDF*)(long)PARAM(0), (int)PARAM(1));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_setlinejoin,2)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // int

	PDF_setlinejoin((PDF*)(long)PARAM(0), (int)PARAM(1));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_setlinewidth,2)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // double

	PDF_setlinewidth((PDF*)(long)PARAM(0), (double)PARAM(1));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_setmatrix,7)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // double
	T_NUMBER(2) // double
	T_NUMBER(3) // double
	T_NUMBER(4) // double
	T_NUMBER(5) // double
	T_NUMBER(6) // double

	PDF_setmatrix((PDF*)(long)PARAM(0), (double)PARAM(1), (double)PARAM(2), (double)PARAM(3), (double)PARAM(4), (double)PARAM(5), (double)PARAM(6));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_setmiterlimit,2)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // double

	PDF_setmiterlimit((PDF*)(long)PARAM(0), (double)PARAM(1));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
/*CONCEPT_FUNCTION_IMPL(_PDF_setpolydash,3)
	T_NUMBER(0) // PDF*
	T_NUMBER(2) // int

	// ... parameter 1 is by reference (float*)
	float local_parameter_1;

	PDF_setpolydash((PDF*)(long)PARAM(0), &local_parameter_1, (int)PARAM(2));
	SET_NUMBER(1, local_parameter_1)
	RETURN_NUMBER(0)
END_IMPL*/
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_setrgbcolor,4)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // double
	T_NUMBER(2) // double
	T_NUMBER(3) // double

	PDF_setrgbcolor((PDF*)(long)PARAM(0), (double)PARAM(1), (double)PARAM(2), (double)PARAM(3));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_setrgbcolor_fill,4)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // double
	T_NUMBER(2) // double
	T_NUMBER(3) // double

	PDF_setrgbcolor_fill((PDF*)(long)PARAM(0), (double)PARAM(1), (double)PARAM(2), (double)PARAM(3));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_setrgbcolor_stroke,4)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // double
	T_NUMBER(2) // double
	T_NUMBER(3) // double

	PDF_setrgbcolor_stroke((PDF*)(long)PARAM(0), (double)PARAM(1), (double)PARAM(2), (double)PARAM(3));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_shading,11)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_NUMBER(2) // double
	T_NUMBER(3) // double
	T_NUMBER(4) // double
	T_NUMBER(5) // double
	T_NUMBER(6) // double
	T_NUMBER(7) // double
	T_NUMBER(8) // double
	T_NUMBER(9) // double
	T_STRING(10) // char*

	RETURN_NUMBER(PDF_shading((PDF*)(long)PARAM(0), PARAM(1), (double)PARAM(2), (double)PARAM(3), (double)PARAM(4), (double)PARAM(5), (double)PARAM(6), (double)PARAM(7), (double)PARAM(8), (double)PARAM(9), PARAM(10)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_shading_pattern,3)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // int
	T_STRING(2) // char*

	RETURN_NUMBER(PDF_shading_pattern((PDF*)(long)PARAM(0), (int)PARAM(1), PARAM(2)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_shfill,2)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // int

	PDF_shfill((PDF*)(long)PARAM(0), (int)PARAM(1));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_show,2)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*

	PDF_show((PDF*)(long)PARAM(0), PARAM(1));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_show2,3)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_NUMBER(2) // int

	PDF_show2((PDF*)(long)PARAM(0), PARAM(1), (int)PARAM(2));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_show_boxed,8)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_NUMBER(2) // double
	T_NUMBER(3) // double
	T_NUMBER(4) // double
	T_NUMBER(5) // double
	T_STRING(6) // char*
	T_STRING(7) // char*

	RETURN_NUMBER(PDF_show_boxed((PDF*)(long)PARAM(0), PARAM(1), (double)PARAM(2), (double)PARAM(3), (double)PARAM(4), (double)PARAM(5), PARAM(6), PARAM(7)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_show_boxed2,9)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_NUMBER(2) // int
	T_NUMBER(3) // double
	T_NUMBER(4) // double
	T_NUMBER(5) // double
	T_NUMBER(6) // double
	T_STRING(7) // char*
	T_STRING(8) // char*

	RETURN_NUMBER(PDF_show_boxed2((PDF*)(long)PARAM(0), PARAM(1), (int)PARAM(2), (double)PARAM(3), (double)PARAM(4), (double)PARAM(5), (double)PARAM(6), PARAM(7), PARAM(8)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_show_xy,4)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_NUMBER(2) // double
	T_NUMBER(3) // double

	PDF_show_xy((PDF*)(long)PARAM(0), PARAM(1), (double)PARAM(2), (double)PARAM(3));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_show_xy2,5)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_NUMBER(2) // int
	T_NUMBER(3) // double
	T_NUMBER(4) // double

	PDF_show_xy2((PDF*)(long)PARAM(0), PARAM(1), (int)PARAM(2), (double)PARAM(3), (double)PARAM(4));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_shutdown,0)

	PDF_shutdown();
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_skew,3)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // double
	T_NUMBER(2) // double

	PDF_skew((PDF*)(long)PARAM(0), (double)PARAM(1), (double)PARAM(2));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_stringwidth,4)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_NUMBER(2) // int
	T_NUMBER(3) // double

	RETURN_NUMBER(PDF_stringwidth((PDF*)(long)PARAM(0), PARAM(1), (int)PARAM(2), (double)PARAM(3)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_stringwidth2,5)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_NUMBER(2) // int
	T_NUMBER(3) // int
	T_NUMBER(4) // double

	RETURN_NUMBER(PDF_stringwidth2((PDF*)(long)PARAM(0), PARAM(1), (int)PARAM(2), (int)PARAM(3), (double)PARAM(4)))
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_stroke,1)
	T_NUMBER(0) // PDF*

	PDF_stroke((PDF*)(long)PARAM(0));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_suspend_page,2)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*

	PDF_suspend_page((PDF*)(long)PARAM(0), PARAM(1));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_translate,3)
	T_NUMBER(0) // PDF*
	T_NUMBER(1) // double
	T_NUMBER(2) // double

	PDF_translate((PDF*)(long)PARAM(0), (double)PARAM(1), (double)PARAM(2));
	RETURN_NUMBER(0)
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_utf16_to_utf8,4)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_NUMBER(2) // int

	// ... parameter 3 is by reference (int*)
	int local_parameter_3;

	RETURN_BUFFER(PDF_utf16_to_utf8((PDF*)(long)PARAM(0), PARAM(1), (int)PARAM(2), &local_parameter_3), local_parameter_3)
	SET_NUMBER(3, local_parameter_3);
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_utf32_to_utf16,5)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_NUMBER(2) // int
	T_STRING(3) // char*

	// ... parameter 4 is by reference (int*)
	int local_parameter_4;

	RETURN_BUFFER(PDF_utf32_to_utf16((PDF*)(long)PARAM(0), PARAM(1), (int)PARAM(2), PARAM(3), &local_parameter_4), local_parameter_4)
	SET_NUMBER(4, local_parameter_4);
END_IMPL
//------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_PDF_utf8_to_utf16,4)
	T_NUMBER(0) // PDF*
	T_STRING(1) // char*
	T_STRING(2) // char*

	// ... parameter 3 is by reference (int*)
	int local_parameter_3;

	RETURN_BUFFER(PDF_utf8_to_utf16((PDF*)(long)PARAM(0), PARAM(1), PARAM(2), &local_parameter_3), local_parameter_3)
	SET_NUMBER(3, local_parameter_3);
END_IMPL
//------------------------------------------------------------------------
