#ifndef __LIBRARY_H
#define __LIBRARY_H

// user definition ...

extern "C" {
        // other functions declared here
	CONCEPT_DLL_API CONCEPT_StrReplace CONCEPT_API_PARAMETERS;

	CONCEPT_DLL_API CONCEPT_NumberToBin CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT_BinToNumber CONCEPT_API_PARAMETERS;

	CONCEPT_DLL_API CONCEPT_NumberToHex CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT_HexToNumber CONCEPT_API_PARAMETERS;

	CONCEPT_DLL_API CONCEPT_NumberToOct CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT_OctToNumber CONCEPT_API_PARAMETERS;

	CONCEPT_DLL_API CONCEPT_RepeatString CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT_SubStr CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT_String CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT_StrSplit CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT_StrNumberSplit CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT_StrFrom CONCEPT_API_PARAMETERS;

	CONCEPT_DLL_API CONCEPT_chr CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT_ord CONCEPT_API_PARAMETERS;

	CONCEPT_DLL_API CONCEPT_ltrim CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT_rtrim CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT_trim CONCEPT_API_PARAMETERS;

	CONCEPT_DLL_API CONCEPT_Ext CONCEPT_API_PARAMETERS;

	CONCEPT_DLL_API CONCEPT_ToUpper CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT_ToLower CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT_ToHTML CONCEPT_API_PARAMETERS;

	CONCEPT_DLL_API CONCEPT_URIEncode CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT_URIDecode CONCEPT_API_PARAMETERS;

	CONCEPT_DLL_API CONCEPT_Pos CONCEPT_API_PARAMETERS;

    CONCEPT_FUNCTION(UTF8ToWide)
    CONCEPT_FUNCTION(WideToUTF8)
    CONCEPT_FUNCTION(UTF8Offset)
    CONCEPT_FUNCTION(UTF8Charnum)
    CONCEPT_FUNCTION(UTF8NextChar)
    CONCEPT_FUNCTION(UTF8Next)
    CONCEPT_FUNCTION(UTF8Prev)
    CONCEPT_FUNCTION(UTF8Escape)
    CONCEPT_FUNCTION(UTF8Unescape)
    CONCEPT_FUNCTION(UTF8Length)
}


#endif // __LIBRARY_H
