#ifndef __LIBRARY_H
#define __LIBRARY_H

// user definition ...

extern "C" {
	CONCEPT_DLL_API ON_CREATE_CONTEXT MANAGEMENT_PARAMETERS;
	CONCEPT_DLL_API ON_DESTROY_CONTEXT MANAGEMENT_PARAMETERS;

	// other functions declared here
	CONCEPT_DLL_API CONCEPT__xmlReaderForFile CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlReaderForMemory CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlTextReaderRead CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlFreeTextReader CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlTextReaderConstName CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlTextReaderConstValue CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlTextReaderDepth CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlTextReaderNodeType CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlTextReaderIsEmptyElement CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlTextReaderHasValue CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlTextReaderIsValid CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlTextReaderPreservePattern CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlCleanupParser CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlMemoryDump CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlTextReaderCurrentDoc CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlParseFile CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlParseMemory CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlDocGetRootElement CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlFreeDoc CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT_xmlGetNodeArray CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlReadFile CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlReadDoc CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlNewDoc CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlNodeSetContent CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlNodeSetName CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlNodeSetLang CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlNodeSetBase CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlRemoveProp CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlNodeGetContent CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlNodeGetLang CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlNodeGetBase CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlNewProp CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlNewNode CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlDocDumpFormatMemory CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlDocDumpFormatMemoryEnc CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlDocSetRootElement CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlAddChild CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlAddChildList CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlAddNextSibling CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlAddPrevSibling CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlAddSibling CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlGetNodePath CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlGetNsList CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlGetNsProp CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlGetProp CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlHasNsProp CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlHasProp CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlIsBlankNode CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlNewChild CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlNewComment CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlNewDocComment CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlNewDocNode CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlNewDocRawNode CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlNewDocText CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlNewGlobalNs CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlNewNs CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlNewNsProp CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlNewText CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlNewTextChild CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlNodeAddContent CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlSaveFile CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlSearchNs CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlSearchNsByHref CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlSetNsProp CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlSetProp CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlSetTreeDoc CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlNewPI CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlNewReference CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlNewDocPI CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlReadMemory CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__xmlNodeIsText CONCEPT_API_PARAMETERS;

	CONCEPT_DLL_API CONCEPT__xmlGetPath CONCEPT_API_PARAMETERS;

	CONCEPT_DLL_API CONCEPT__xmlEncodeEntitiesReentrant CONCEPT_API_PARAMETERS;
	CONCEPT_FUNCTION(_xmlCopyNode)

	// html functions


	CONCEPT_FUNCTION(_htmlCreateMemoryParserCtxt)
	CONCEPT_FUNCTION(_htmlCtxtReadDoc)
	CONCEPT_FUNCTION(_htmlCtxtReadFile)
	CONCEPT_FUNCTION(_htmlCtxtReadMemory)
	CONCEPT_FUNCTION(_htmlCtxtReset)
	CONCEPT_FUNCTION(_htmlCtxtUseOptions)
	CONCEPT_FUNCTION(_htmlElementAllowedHere)
	CONCEPT_FUNCTION(_htmlElementStatusHere)
	CONCEPT_FUNCTION(_htmlFreeParserCtxt)
	CONCEPT_FUNCTION(_htmlHandleOmittedElem)
	CONCEPT_FUNCTION(_htmlIsAutoClosed)
	CONCEPT_FUNCTION(_htmlIsScriptAttribute)
	//CONCEPT_FUNCTION(_htmlNewParserCtxt)
	CONCEPT_FUNCTION(_htmlNodeStatus)
	CONCEPT_FUNCTION(_htmlParseCharRef)
	CONCEPT_FUNCTION(_htmlParseChunk)
	CONCEPT_FUNCTION(_htmlParseDoc)
	CONCEPT_FUNCTION(_htmlParseDocument)
	CONCEPT_FUNCTION(_htmlParseElement)
	CONCEPT_FUNCTION(_htmlParseFile)
	CONCEPT_FUNCTION(_htmlReadDoc)
	CONCEPT_FUNCTION(_htmlReadFile)
	CONCEPT_FUNCTION(_htmlReadMemory)
	CONCEPT_FUNCTION(_htmlDocDumpMemory)
	CONCEPT_FUNCTION(_htmlGetMetaEncoding)
	CONCEPT_FUNCTION(_htmlIsBooleanAttr)
	CONCEPT_FUNCTION(_htmlNewDoc)
	CONCEPT_FUNCTION(_htmlNewDocNoDtD)
	CONCEPT_FUNCTION(_htmlSaveFile)
	CONCEPT_FUNCTION(_htmlSaveFileEnc)
	CONCEPT_FUNCTION(_htmlSaveFileFormat)
	CONCEPT_FUNCTION(_htmlSetMetaEncoding)

	CONCEPT_FUNCTION(_htmlElemDescArray)
	CONCEPT_FUNCTION(_htmlEntityDescArray)

	CONCEPT_FUNCTION(xmlTextReaderSetErrorHandler)
	CONCEPT_FUNCTION(xmlSetGenericErrorFunc)
	CONCEPT_FUNCTION(xmlSetStructuredErrorFunc)

	CONCEPT_FUNCTION(xmlURIEscapeStr)
	CONCEPT_FUNCTION(xmlURIUnescapeString)

	CONCEPT_FUNCTION(xmlFreeNode)
}



#endif // __LIBRARY_H
