#ifndef __LIBRARY_H
#define __LIBRARY_H

#include "stdlibrary.h"

extern "C" {
	    CONCEPT_DLL_API ON_CREATE_CONTEXT MANAGEMENT_PARAMETERS;
	    CONCEPT_DLL_API ON_DESTROY_CONTEXT MANAGEMENT_PARAMETERS;

        CONCEPT_DLL_API CONCEPT__curl_global_init CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT__curl_global_cleanup CONCEPT_API_PARAMETERS;

        CONCEPT_DLL_API CONCEPT__curl_easy_getinfo CONCEPT_API_PARAMETERS;

        CONCEPT_DLL_API CONCEPT__curl_easy_init CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT__curl_easy_cleanup CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT__curl_easy_reset CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT__curl_easy_duphandle CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT__curl_easy_strerror CONCEPT_API_PARAMETERS;

        CONCEPT_DLL_API CONCEPT__curl_easy_perform CONCEPT_API_PARAMETERS;

        CONCEPT_DLL_API CONCEPT__curl_easy_setopt CONCEPT_API_PARAMETERS;

        CONCEPT_DLL_API CONCEPT__curl_version CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT__curl_getenv CONCEPT_API_PARAMETERS;

        CONCEPT_DLL_API CONCEPT__curl_escape CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT__curl_unescape CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT__curl_strequal CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT__curl_strnequal CONCEPT_API_PARAMETERS;

        CONCEPT_DLL_API CONCEPT__curl_easy_escape CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT__curl_easy_unescape CONCEPT_API_PARAMETERS;

        CONCEPT_DLL_API CONCEPT__curl_getdate CONCEPT_API_PARAMETERS;

        CONCEPT_FUNCTION(_curl_formnew)
        CONCEPT_FUNCTION(_curl_formfree)
}


#endif // __LIBRARY_H
