#include "stdlibrary.h"

extern "C" {
    CONCEPT_DLL_API ON_CREATE_CONTEXT MANAGEMENT_PARAMETERS;

    CONCEPT_FUNCTION(purple_list_to_array)
    CONCEPT_FUNCTION(purple_loop)
    CONCEPT_FUNCTION(purple_quit)

    CONCEPT_FUNCTION(PURPLE_STRING)
    CONCEPT_FUNCTION(PURPLE_CONV_IM)
    CONCEPT_FUNCTION(purple_xfer_set_request_denied_fnc)

    CONCEPT_FUNCTION(purple_debug_set_enabled)
    CONCEPT_FUNCTION(purple_account_new)
    CONCEPT_FUNCTION(purple_account_destroy)
    CONCEPT_FUNCTION(purple_account_connect)
    CONCEPT_FUNCTION(purple_account_set_register_callback)
    CONCEPT_FUNCTION(purple_account_register)
    CONCEPT_FUNCTION(purple_account_unregister)
    CONCEPT_FUNCTION(purple_account_disconnect)
    CONCEPT_FUNCTION(purple_account_notify_added)
    CONCEPT_FUNCTION(purple_account_request_add)
    CONCEPT_FUNCTION(purple_account_request_authorization)
    CONCEPT_FUNCTION(purple_account_request_close_with_account)
    CONCEPT_FUNCTION(purple_account_request_close)
    CONCEPT_FUNCTION(purple_account_request_password)
    CONCEPT_FUNCTION(purple_account_request_change_password)
    CONCEPT_FUNCTION(purple_account_request_change_user_info)
    CONCEPT_FUNCTION(purple_account_set_password)
    CONCEPT_FUNCTION(purple_account_set_alias)
    CONCEPT_FUNCTION(purple_account_set_user_info)
    CONCEPT_FUNCTION(purple_account_set_buddy_icon_path)
    CONCEPT_FUNCTION(purple_account_set_protocol_id)
    CONCEPT_FUNCTION(purple_account_set_connection)
    CONCEPT_FUNCTION(purple_account_set_remember_password)
    CONCEPT_FUNCTION(purple_account_set_check_mail)
    CONCEPT_FUNCTION(purple_account_set_enabled)
    CONCEPT_FUNCTION(purple_account_set_proxy_info)
    CONCEPT_FUNCTION(purple_account_set_status_types)
    CONCEPT_FUNCTION(purple_account_set_status)
    CONCEPT_FUNCTION(purple_account_set_status_list)
    CONCEPT_FUNCTION(purple_account_clear_settings)
    CONCEPT_FUNCTION(purple_account_remove_setting)
    CONCEPT_FUNCTION(purple_account_set_int)
    CONCEPT_FUNCTION(purple_account_set_string)
    CONCEPT_FUNCTION(purple_account_set_bool)
    CONCEPT_FUNCTION(purple_account_set_ui_int)
    CONCEPT_FUNCTION(purple_account_set_ui_string)
    CONCEPT_FUNCTION(purple_account_set_ui_bool)
    CONCEPT_FUNCTION(purple_account_is_connected)
    CONCEPT_FUNCTION(purple_account_is_connecting)
    CONCEPT_FUNCTION(purple_account_is_disconnected)
    CONCEPT_FUNCTION(purple_account_get_username)
    CONCEPT_FUNCTION(purple_account_get_password)
    CONCEPT_FUNCTION(purple_account_get_alias)
    CONCEPT_FUNCTION(purple_account_get_user_info)
    CONCEPT_FUNCTION(purple_account_get_buddy_icon_path)
    CONCEPT_FUNCTION(purple_account_get_protocol_id)
    CONCEPT_FUNCTION(purple_account_get_protocol_name)
    CONCEPT_FUNCTION(purple_account_get_connection)
    CONCEPT_FUNCTION(purple_account_get_remember_password)
    CONCEPT_FUNCTION(purple_account_get_check_mail)
    CONCEPT_FUNCTION(purple_account_get_enabled)
    CONCEPT_FUNCTION(purple_account_get_proxy_info)
    CONCEPT_FUNCTION(purple_account_get_active_status)
    CONCEPT_FUNCTION(purple_account_get_status)
    CONCEPT_FUNCTION(purple_account_get_status_type)
    CONCEPT_FUNCTION(purple_account_get_status_type_with_primitive)
    CONCEPT_FUNCTION(purple_account_get_presence)
    CONCEPT_FUNCTION(purple_account_is_status_active)
    CONCEPT_FUNCTION(purple_account_get_status_types)
    CONCEPT_FUNCTION(purple_account_get_int)
    CONCEPT_FUNCTION(purple_account_get_string)
    CONCEPT_FUNCTION(purple_account_get_bool)
    CONCEPT_FUNCTION(purple_account_get_ui_int)
    CONCEPT_FUNCTION(purple_account_get_ui_string)
    CONCEPT_FUNCTION(purple_account_get_ui_bool)
    CONCEPT_FUNCTION(purple_account_get_log)
    CONCEPT_FUNCTION(purple_account_destroy_log)
    CONCEPT_FUNCTION(purple_account_add_buddy)
    CONCEPT_FUNCTION(purple_account_add_buddies)
    CONCEPT_FUNCTION(purple_account_remove_buddy)
    CONCEPT_FUNCTION(purple_account_remove_buddies)
    CONCEPT_FUNCTION(purple_account_remove_group)
    CONCEPT_FUNCTION(purple_account_change_password)
    CONCEPT_FUNCTION(purple_account_supports_offline_message)
    CONCEPT_FUNCTION(purple_account_get_current_error)
    CONCEPT_FUNCTION(purple_account_clear_current_error)
    CONCEPT_FUNCTION(purple_accounts_add)
    CONCEPT_FUNCTION(purple_accounts_remove)
    CONCEPT_FUNCTION(purple_accounts_delete)
    CONCEPT_FUNCTION(purple_accounts_reorder)
    CONCEPT_FUNCTION(purple_accounts_get_all)
    CONCEPT_FUNCTION(purple_accounts_get_all_active)
    CONCEPT_FUNCTION(purple_accounts_find)
    CONCEPT_FUNCTION(purple_accounts_restore_current_statuses)
    CONCEPT_FUNCTION(purple_accounts_set_ui_ops)
    CONCEPT_FUNCTION(purple_accounts_get_ui_ops)
    CONCEPT_FUNCTION(purple_accounts_get_handle)
    CONCEPT_FUNCTION(purple_accounts_init)
    CONCEPT_FUNCTION(purple_accounts_uninit)
    CONCEPT_FUNCTION(purple_account_option_destroy)
    CONCEPT_FUNCTION(purple_account_option_set_default_bool)
    CONCEPT_FUNCTION(purple_account_option_set_default_int)
    CONCEPT_FUNCTION(purple_account_option_set_default_string)
    CONCEPT_FUNCTION(purple_account_option_set_masked)
    CONCEPT_FUNCTION(purple_account_option_set_list)
    CONCEPT_FUNCTION(purple_account_option_add_list_item)
    CONCEPT_FUNCTION(purple_account_option_get_type)
    CONCEPT_FUNCTION(purple_account_option_get_text)
    CONCEPT_FUNCTION(purple_account_option_get_setting)
    CONCEPT_FUNCTION(purple_account_option_get_default_bool)
    CONCEPT_FUNCTION(purple_account_option_get_default_int)
    CONCEPT_FUNCTION(purple_account_option_get_default_string)
    CONCEPT_FUNCTION(purple_account_option_get_default_list_value)
    CONCEPT_FUNCTION(purple_account_option_get_masked)
    CONCEPT_FUNCTION(purple_account_option_get_list)
    CONCEPT_FUNCTION(purple_account_user_split_new)
    CONCEPT_FUNCTION(purple_account_user_split_destroy)
    CONCEPT_FUNCTION(purple_account_user_split_get_text)
    CONCEPT_FUNCTION(purple_account_user_split_get_default_value)
    CONCEPT_FUNCTION(purple_account_user_split_get_separator)
    CONCEPT_FUNCTION(purple_account_user_split_get_reverse)
    CONCEPT_FUNCTION(purple_account_user_split_set_reverse)
    CONCEPT_FUNCTION(purple_blist_new)
    CONCEPT_FUNCTION(purple_set_blist)
    CONCEPT_FUNCTION(purple_get_blist)
    CONCEPT_FUNCTION(purple_blist_get_root)
    CONCEPT_FUNCTION(purple_blist_get_buddies)
    CONCEPT_FUNCTION(purple_blist_get_ui_data)
    CONCEPT_FUNCTION(purple_blist_set_ui_data)
    CONCEPT_FUNCTION(purple_blist_node_next)
    CONCEPT_FUNCTION(purple_blist_node_get_parent)
    CONCEPT_FUNCTION(purple_blist_node_get_first_child)
    CONCEPT_FUNCTION(purple_blist_node_get_sibling_next)
    CONCEPT_FUNCTION(purple_blist_node_get_sibling_prev)
    CONCEPT_FUNCTION(purple_blist_node_get_ui_data)
    CONCEPT_FUNCTION(purple_blist_node_set_ui_data)
    CONCEPT_FUNCTION(purple_blist_show)
    CONCEPT_FUNCTION(purple_blist_destroy)
    CONCEPT_FUNCTION(purple_blist_set_visible)
    CONCEPT_FUNCTION(purple_blist_update_buddy_status)
    CONCEPT_FUNCTION(purple_blist_update_node_icon)
    CONCEPT_FUNCTION(purple_blist_rename_buddy)
    CONCEPT_FUNCTION(purple_blist_alias_contact)
    CONCEPT_FUNCTION(purple_blist_alias_buddy)
    CONCEPT_FUNCTION(purple_blist_server_alias_buddy)
    CONCEPT_FUNCTION(purple_blist_alias_chat)
    CONCEPT_FUNCTION(purple_blist_rename_group)
    CONCEPT_FUNCTION(purple_chat_new)
    CONCEPT_FUNCTION(purple_chat_destroy)
    CONCEPT_FUNCTION(purple_blist_add_chat)
    CONCEPT_FUNCTION(purple_buddy_new)
    CONCEPT_FUNCTION(purple_buddy_destroy)
    CONCEPT_FUNCTION(purple_buddy_set_icon)
    CONCEPT_FUNCTION(purple_buddy_get_account)
    CONCEPT_FUNCTION(purple_buddy_get_name)
    CONCEPT_FUNCTION(purple_buddy_get_icon)
    CONCEPT_FUNCTION(purple_buddy_get_protocol_data)
    CONCEPT_FUNCTION(purple_buddy_set_protocol_data)
    CONCEPT_FUNCTION(purple_buddy_get_contact)
    CONCEPT_FUNCTION(purple_buddy_get_presence)
    CONCEPT_FUNCTION(purple_blist_add_buddy)
    CONCEPT_FUNCTION(purple_group_new)
    CONCEPT_FUNCTION(purple_group_destroy)
    CONCEPT_FUNCTION(purple_blist_add_group)
    CONCEPT_FUNCTION(purple_contact_new)
    CONCEPT_FUNCTION(purple_contact_destroy)
    CONCEPT_FUNCTION(purple_blist_add_contact)
    CONCEPT_FUNCTION(purple_blist_merge_contact)
    CONCEPT_FUNCTION(purple_contact_get_priority_buddy)
    CONCEPT_FUNCTION(purple_contact_get_alias)
    CONCEPT_FUNCTION(purple_contact_on_account)
    CONCEPT_FUNCTION(purple_contact_invalidate_priority_buddy)
    CONCEPT_FUNCTION(purple_blist_remove_buddy)
    CONCEPT_FUNCTION(purple_blist_remove_contact)
    CONCEPT_FUNCTION(purple_blist_remove_chat)
    CONCEPT_FUNCTION(purple_blist_remove_group)
    CONCEPT_FUNCTION(purple_buddy_get_alias_only)
    CONCEPT_FUNCTION(purple_buddy_get_server_alias)
    CONCEPT_FUNCTION(purple_buddy_get_contact_alias)
    CONCEPT_FUNCTION(purple_buddy_get_alias)
    CONCEPT_FUNCTION(purple_buddy_get_local_buddy_alias)
    CONCEPT_FUNCTION(purple_chat_get_name)
    CONCEPT_FUNCTION(purple_find_buddy)
    CONCEPT_FUNCTION(purple_find_buddy_in_group)
    CONCEPT_FUNCTION(purple_find_buddies)
    CONCEPT_FUNCTION(purple_find_group)
    CONCEPT_FUNCTION(purple_blist_find_chat)
    CONCEPT_FUNCTION(purple_chat_get_group)
    CONCEPT_FUNCTION(purple_chat_get_account)
    CONCEPT_FUNCTION(purple_chat_get_components)
    CONCEPT_FUNCTION(purple_buddy_get_group)
    CONCEPT_FUNCTION(purple_group_get_accounts)
    CONCEPT_FUNCTION(purple_group_on_account)
    CONCEPT_FUNCTION(purple_group_get_name)
    CONCEPT_FUNCTION(purple_blist_add_account)
    CONCEPT_FUNCTION(purple_blist_remove_account)
    CONCEPT_FUNCTION(purple_blist_get_group_size)
    CONCEPT_FUNCTION(purple_blist_get_group_online_count)
    CONCEPT_FUNCTION(purple_blist_load)
    CONCEPT_FUNCTION(purple_blist_schedule_save)
    CONCEPT_FUNCTION(purple_blist_request_add_buddy)
    CONCEPT_FUNCTION(purple_blist_request_add_chat)
    CONCEPT_FUNCTION(purple_blist_request_add_group)
    CONCEPT_FUNCTION(purple_blist_node_set_bool)
    CONCEPT_FUNCTION(purple_blist_node_get_bool)
    CONCEPT_FUNCTION(purple_blist_node_set_int)
    CONCEPT_FUNCTION(purple_blist_node_get_int)
    CONCEPT_FUNCTION(purple_blist_node_set_string)
    CONCEPT_FUNCTION(purple_blist_node_get_string)
    CONCEPT_FUNCTION(purple_blist_node_remove_setting)
    CONCEPT_FUNCTION(purple_blist_node_set_flags)
    CONCEPT_FUNCTION(purple_blist_node_get_flags)
    CONCEPT_FUNCTION(purple_blist_node_get_type)
    CONCEPT_FUNCTION(purple_blist_node_get_extended_menu)
    CONCEPT_FUNCTION(purple_blist_set_ui_ops)
    CONCEPT_FUNCTION(purple_blist_get_ui_ops)
    CONCEPT_FUNCTION(purple_blist_get_handle)
    CONCEPT_FUNCTION(purple_blist_init)
    CONCEPT_FUNCTION(purple_blist_uninit)
    CONCEPT_FUNCTION(purple_buddy_icon_new)
    CONCEPT_FUNCTION(purple_buddy_icon_ref)
    CONCEPT_FUNCTION(purple_buddy_icon_unref)
    CONCEPT_FUNCTION(purple_buddy_icon_update)
    CONCEPT_FUNCTION(purple_buddy_icon_set_data)
    CONCEPT_FUNCTION(purple_buddy_icon_get_account)
    CONCEPT_FUNCTION(purple_buddy_icon_get_username)
    CONCEPT_FUNCTION(purple_buddy_icon_get_checksum)
    CONCEPT_FUNCTION(purple_buddy_icon_get_data)
    CONCEPT_FUNCTION(purple_buddy_icon_get_extension)
    CONCEPT_FUNCTION(purple_buddy_icon_get_full_path)
    CONCEPT_FUNCTION(purple_buddy_icons_set_for_user)
    CONCEPT_FUNCTION(purple_buddy_icons_get_checksum_for_user)
    CONCEPT_FUNCTION(purple_buddy_icons_find)
    CONCEPT_FUNCTION(purple_buddy_icons_find_account_icon)
    CONCEPT_FUNCTION(purple_buddy_icons_set_account_icon)
    CONCEPT_FUNCTION(purple_buddy_icons_get_account_icon_timestamp)
    CONCEPT_FUNCTION(purple_buddy_icons_node_has_custom_icon)
    CONCEPT_FUNCTION(purple_buddy_icons_node_find_custom_icon)
    CONCEPT_FUNCTION(purple_buddy_icons_node_set_custom_icon)
    CONCEPT_FUNCTION(purple_buddy_icons_node_set_custom_icon_from_file)
    CONCEPT_FUNCTION(purple_buddy_icons_set_caching)
    CONCEPT_FUNCTION(purple_buddy_icons_is_caching)
    CONCEPT_FUNCTION(purple_buddy_icons_set_cache_dir)
    CONCEPT_FUNCTION(purple_buddy_icons_get_cache_dir)
    CONCEPT_FUNCTION(purple_buddy_icons_get_handle)
    CONCEPT_FUNCTION(purple_buddy_icons_init)
    CONCEPT_FUNCTION(purple_buddy_icons_uninit)
    CONCEPT_FUNCTION(purple_buddy_icon_get_scale_size)
    CONCEPT_FUNCTION(purple_certificate_verify)
    CONCEPT_FUNCTION(purple_certificate_verify_complete)
    CONCEPT_FUNCTION(purple_certificate_copy)
    CONCEPT_FUNCTION(purple_certificate_copy_list)
    CONCEPT_FUNCTION(purple_certificate_destroy)
    CONCEPT_FUNCTION(purple_certificate_destroy_list)
    CONCEPT_FUNCTION(purple_certificate_signed_by)
    CONCEPT_FUNCTION(purple_certificate_check_signature_chain_with_failing)
    CONCEPT_FUNCTION(purple_certificate_check_signature_chain)
    CONCEPT_FUNCTION(purple_certificate_import)
    CONCEPT_FUNCTION(purple_certificate_export)
    CONCEPT_FUNCTION(purple_certificate_get_fingerprint_sha1)
    CONCEPT_FUNCTION(purple_certificate_get_unique_id)
    CONCEPT_FUNCTION(purple_certificate_get_issuer_unique_id)
    CONCEPT_FUNCTION(purple_certificate_get_subject_name)
    CONCEPT_FUNCTION(purple_certificate_check_subject_name)
    CONCEPT_FUNCTION(purple_certificate_get_times)
    CONCEPT_FUNCTION(purple_certificate_pool_mkpath)
    CONCEPT_FUNCTION(purple_certificate_pool_usable)
    CONCEPT_FUNCTION(purple_certificate_pool_get_scheme)
    CONCEPT_FUNCTION(purple_certificate_pool_contains)
    CONCEPT_FUNCTION(purple_certificate_pool_retrieve)
    CONCEPT_FUNCTION(purple_certificate_pool_store)
    CONCEPT_FUNCTION(purple_certificate_pool_delete)
    CONCEPT_FUNCTION(purple_certificate_pool_get_idlist)
    CONCEPT_FUNCTION(purple_certificate_pool_destroy_idlist)
    CONCEPT_FUNCTION(purple_certificate_init)
    CONCEPT_FUNCTION(purple_certificate_uninit)
    CONCEPT_FUNCTION(purple_certificate_get_handle)
    CONCEPT_FUNCTION(purple_certificate_find_scheme)
    CONCEPT_FUNCTION(purple_certificate_get_schemes)
    CONCEPT_FUNCTION(purple_certificate_register_scheme)
    CONCEPT_FUNCTION(purple_certificate_unregister_scheme)
    CONCEPT_FUNCTION(purple_certificate_find_verifier)
    CONCEPT_FUNCTION(purple_certificate_get_verifiers)
    CONCEPT_FUNCTION(purple_certificate_register_verifier)
    CONCEPT_FUNCTION(purple_certificate_unregister_verifier)
    CONCEPT_FUNCTION(purple_certificate_find_pool)
    CONCEPT_FUNCTION(purple_certificate_get_pools)
    CONCEPT_FUNCTION(purple_certificate_register_pool)
    CONCEPT_FUNCTION(purple_certificate_unregister_pool)
    CONCEPT_FUNCTION(purple_certificate_display_x509)
    CONCEPT_FUNCTION(purple_certificate_add_ca_search_path)
    CONCEPT_FUNCTION(purple_cipher_get_name)
    CONCEPT_FUNCTION(purple_cipher_get_capabilities)
    CONCEPT_FUNCTION(purple_cipher_digest_region)
    CONCEPT_FUNCTION(purple_ciphers_find_cipher)
    CONCEPT_FUNCTION(purple_ciphers_register_cipher)
    CONCEPT_FUNCTION(purple_ciphers_unregister_cipher)
    CONCEPT_FUNCTION(purple_ciphers_get_ciphers)
    CONCEPT_FUNCTION(purple_ciphers_get_handle)
    CONCEPT_FUNCTION(purple_ciphers_init)
    CONCEPT_FUNCTION(purple_ciphers_uninit)
    CONCEPT_FUNCTION(purple_cipher_context_set_option)
    CONCEPT_FUNCTION(purple_cipher_context_get_option)
    CONCEPT_FUNCTION(purple_cipher_context_new)
    CONCEPT_FUNCTION(purple_cipher_context_new_by_name)
    CONCEPT_FUNCTION(purple_cipher_context_reset)
    CONCEPT_FUNCTION(purple_cipher_context_destroy)
    CONCEPT_FUNCTION(purple_cipher_context_set_iv)
    CONCEPT_FUNCTION(purple_cipher_context_append)
    CONCEPT_FUNCTION(purple_cipher_context_digest)
    CONCEPT_FUNCTION(purple_cipher_context_digest_to_str)
    CONCEPT_FUNCTION(purple_cipher_context_encrypt)
    CONCEPT_FUNCTION(purple_cipher_context_decrypt)
    CONCEPT_FUNCTION(purple_cipher_context_set_salt)
    CONCEPT_FUNCTION(purple_cipher_context_get_salt_size)
    CONCEPT_FUNCTION(purple_cipher_context_set_key)
    CONCEPT_FUNCTION(purple_cipher_context_get_key_size)
    CONCEPT_FUNCTION(purple_cipher_context_set_batch_mode)
    CONCEPT_FUNCTION(purple_cipher_context_get_batch_mode)
    CONCEPT_FUNCTION(purple_cipher_context_get_block_size)
    CONCEPT_FUNCTION(purple_cipher_context_set_key_with_len)
    CONCEPT_FUNCTION(purple_cipher_context_set_data)
    CONCEPT_FUNCTION(purple_cipher_context_get_data)
    CONCEPT_FUNCTION(purple_cipher_http_digest_calculate_session_key)
    CONCEPT_FUNCTION(purple_cipher_http_digest_calculate_response)
    CONCEPT_FUNCTION(purple_cmd_register)
    CONCEPT_FUNCTION(purple_cmd_unregister)
    CONCEPT_FUNCTION(purple_cmd_do_command)
    CONCEPT_FUNCTION(purple_cmd_list)
    CONCEPT_FUNCTION(purple_cmd_help)
    CONCEPT_FUNCTION(purple_cmds_get_handle)
    CONCEPT_FUNCTION(purple_cmds_init)
    CONCEPT_FUNCTION(purple_cmds_uninit)
    CONCEPT_FUNCTION(purple_connection_set_state)
    CONCEPT_FUNCTION(purple_connection_set_account)
    CONCEPT_FUNCTION(purple_connection_set_display_name)
    CONCEPT_FUNCTION(purple_connection_set_protocol_data)
    CONCEPT_FUNCTION(purple_connection_get_state)
    CONCEPT_FUNCTION(purple_connection_get_account)
    CONCEPT_FUNCTION(purple_connection_get_prpl)
    CONCEPT_FUNCTION(purple_connection_get_password)
    CONCEPT_FUNCTION(purple_connection_get_display_name)
    CONCEPT_FUNCTION(purple_connection_get_protocol_data)
    CONCEPT_FUNCTION(purple_connection_update_progress)
    CONCEPT_FUNCTION(purple_connection_notice)
    CONCEPT_FUNCTION(purple_connection_error)
    CONCEPT_FUNCTION(purple_connection_error_reason)
    CONCEPT_FUNCTION(purple_connection_ssl_error)
    CONCEPT_FUNCTION(purple_connection_error_is_fatal)
    CONCEPT_FUNCTION(purple_connections_disconnect_all)
    CONCEPT_FUNCTION(purple_connections_get_all)
    CONCEPT_FUNCTION(purple_connections_get_connecting)
    CONCEPT_FUNCTION(purple_connections_set_ui_ops)
    CONCEPT_FUNCTION(purple_connections_get_ui_ops)
    CONCEPT_FUNCTION(purple_connections_init)
    CONCEPT_FUNCTION(purple_connections_uninit)
    CONCEPT_FUNCTION(purple_connections_get_handle)
    CONCEPT_FUNCTION(purple_conversation_new)
    CONCEPT_FUNCTION(purple_conversation_destroy)
    CONCEPT_FUNCTION(purple_conversation_present)
    CONCEPT_FUNCTION(purple_conversation_get_type)
    CONCEPT_FUNCTION(purple_conversation_set_ui_ops)
    CONCEPT_FUNCTION(purple_conversations_set_ui_ops)
    CONCEPT_FUNCTION(purple_conversation_get_ui_ops)
    CONCEPT_FUNCTION(purple_conversation_set_account)
    CONCEPT_FUNCTION(purple_conversation_get_account)
    CONCEPT_FUNCTION(purple_conversation_get_gc)
    CONCEPT_FUNCTION(purple_conversation_set_title)
    CONCEPT_FUNCTION(purple_conversation_get_title)
    CONCEPT_FUNCTION(purple_conversation_autoset_title)
    CONCEPT_FUNCTION(purple_conversation_set_name)
    CONCEPT_FUNCTION(purple_conversation_get_name)
    CONCEPT_FUNCTION(purple_conversation_set_logging)
    CONCEPT_FUNCTION(purple_conversation_is_logging)
    CONCEPT_FUNCTION(purple_conversation_close_logs)
    CONCEPT_FUNCTION(purple_conversation_get_im_data)
    CONCEPT_FUNCTION(purple_conversation_get_chat_data)
    CONCEPT_FUNCTION(purple_conversation_set_data)
    CONCEPT_FUNCTION(purple_conversation_get_data)
    CONCEPT_FUNCTION(purple_get_conversations)
    CONCEPT_FUNCTION(purple_get_ims)
    CONCEPT_FUNCTION(purple_get_chats)
    CONCEPT_FUNCTION(purple_find_conversation_with_account)
    CONCEPT_FUNCTION(purple_conversation_write)
    CONCEPT_FUNCTION(purple_conversation_set_features)
    CONCEPT_FUNCTION(purple_conversation_get_features)
    CONCEPT_FUNCTION(purple_conversation_has_focus)
    CONCEPT_FUNCTION(purple_conversation_update)
    CONCEPT_FUNCTION(purple_conversation_get_message_history)
    CONCEPT_FUNCTION(purple_conversation_clear_message_history)
    CONCEPT_FUNCTION(purple_conversation_message_get_sender)
    CONCEPT_FUNCTION(purple_conversation_message_get_message)
    CONCEPT_FUNCTION(purple_conversation_message_get_flags)
    CONCEPT_FUNCTION(purple_conversation_message_get_timestamp)
    CONCEPT_FUNCTION(purple_conv_im_get_conversation)
    CONCEPT_FUNCTION(purple_conv_im_set_icon)
    CONCEPT_FUNCTION(purple_conv_im_get_icon)
    CONCEPT_FUNCTION(purple_conv_im_set_typing_state)
    CONCEPT_FUNCTION(purple_conv_im_get_typing_state)
    CONCEPT_FUNCTION(purple_conv_im_start_typing_timeout)
    CONCEPT_FUNCTION(purple_conv_im_stop_typing_timeout)
    CONCEPT_FUNCTION(purple_conv_im_get_typing_timeout)
    CONCEPT_FUNCTION(purple_conv_im_set_type_again)
    CONCEPT_FUNCTION(purple_conv_im_get_type_again)
    CONCEPT_FUNCTION(purple_conv_im_start_send_typed_timeout)
    CONCEPT_FUNCTION(purple_conv_im_stop_send_typed_timeout)
    CONCEPT_FUNCTION(purple_conv_im_get_send_typed_timeout)
    CONCEPT_FUNCTION(purple_conv_im_update_typing)
    CONCEPT_FUNCTION(purple_conv_im_write)
    CONCEPT_FUNCTION(purple_conv_present_error)
    CONCEPT_FUNCTION(purple_conv_im_send)
    CONCEPT_FUNCTION(purple_conv_send_confirm)
    CONCEPT_FUNCTION(purple_conv_im_send_with_flags)
    CONCEPT_FUNCTION(purple_conv_custom_smiley_add)
    CONCEPT_FUNCTION(purple_conv_custom_smiley_write)
    CONCEPT_FUNCTION(purple_conv_custom_smiley_close)
    CONCEPT_FUNCTION(purple_conv_chat_get_conversation)
    CONCEPT_FUNCTION(purple_conv_chat_set_users)
    CONCEPT_FUNCTION(purple_conv_chat_get_users)
    CONCEPT_FUNCTION(purple_conv_chat_ignore)
    CONCEPT_FUNCTION(purple_conv_chat_unignore)
    CONCEPT_FUNCTION(purple_conv_chat_set_ignored)
    CONCEPT_FUNCTION(purple_conv_chat_get_ignored)
    CONCEPT_FUNCTION(purple_conv_chat_get_ignored_user)
    CONCEPT_FUNCTION(purple_conv_chat_is_user_ignored)
    CONCEPT_FUNCTION(purple_conv_chat_set_topic)
    CONCEPT_FUNCTION(purple_conv_chat_get_topic)
    CONCEPT_FUNCTION(purple_conv_chat_set_id)
    CONCEPT_FUNCTION(purple_conv_chat_get_id)
    CONCEPT_FUNCTION(purple_conv_chat_write)
    CONCEPT_FUNCTION(purple_conv_chat_send)
    CONCEPT_FUNCTION(purple_conv_chat_send_with_flags)
    CONCEPT_FUNCTION(purple_conv_chat_add_user)
    CONCEPT_FUNCTION(purple_conv_chat_add_users)
    CONCEPT_FUNCTION(purple_conv_chat_rename_user)
    CONCEPT_FUNCTION(purple_conv_chat_remove_user)
    CONCEPT_FUNCTION(purple_conv_chat_remove_users)
    CONCEPT_FUNCTION(purple_conv_chat_find_user)
    CONCEPT_FUNCTION(purple_conv_chat_user_set_flags)
    CONCEPT_FUNCTION(purple_conv_chat_user_get_flags)
    CONCEPT_FUNCTION(purple_conv_chat_clear_users)
    CONCEPT_FUNCTION(purple_conv_chat_set_nick)
    CONCEPT_FUNCTION(purple_conv_chat_get_nick)
    CONCEPT_FUNCTION(purple_find_chat)
    CONCEPT_FUNCTION(purple_conv_chat_left)
    CONCEPT_FUNCTION(purple_conv_chat_invite_user)
    CONCEPT_FUNCTION(purple_conv_chat_has_left)
    CONCEPT_FUNCTION(purple_conv_chat_cb_new)
    CONCEPT_FUNCTION(purple_conv_chat_cb_find)
    CONCEPT_FUNCTION(purple_conv_chat_cb_get_name)
    CONCEPT_FUNCTION(purple_conv_chat_cb_destroy)
    CONCEPT_FUNCTION(purple_conversation_get_extended_menu)
    CONCEPT_FUNCTION(purple_conversation_do_command)
    CONCEPT_FUNCTION(purple_conversations_get_handle)
    CONCEPT_FUNCTION(purple_conversations_init)
    CONCEPT_FUNCTION(purple_conversations_uninit)
    CONCEPT_FUNCTION(purple_core_init)
    CONCEPT_FUNCTION(purple_core_quit)
    CONCEPT_FUNCTION(purple_core_quit_cb)
    CONCEPT_FUNCTION(purple_core_get_version)
    CONCEPT_FUNCTION(purple_core_get_ui)
    CONCEPT_FUNCTION(purple_get_core)
    CONCEPT_FUNCTION(purple_core_set_ui_ops)
    CONCEPT_FUNCTION(purple_core_get_ui_ops)
    CONCEPT_FUNCTION(purple_core_migrate)
    CONCEPT_FUNCTION(purple_core_ensure_single_instance)
    CONCEPT_FUNCTION(purple_core_get_ui_info)
    CONCEPT_FUNCTION(purple_desktop_item_new_from_file)
    CONCEPT_FUNCTION(purple_desktop_item_get_entry_type)
    CONCEPT_FUNCTION(purple_desktop_item_get_string)
    CONCEPT_FUNCTION(purple_desktop_item_copy)
    CONCEPT_FUNCTION(purple_desktop_item_unref)
    CONCEPT_FUNCTION(purple_timeout_add)
    CONCEPT_FUNCTION(purple_timeout_add_seconds)
    CONCEPT_FUNCTION(purple_timeout_remove)
    CONCEPT_FUNCTION(purple_input_add)
    CONCEPT_FUNCTION(purple_input_remove)
    CONCEPT_FUNCTION(purple_input_get_error)
    CONCEPT_FUNCTION(purple_eventloop_set_ui_ops)
    CONCEPT_FUNCTION(purple_eventloop_get_ui_ops)
    CONCEPT_FUNCTION(purple_xfer_new)
    CONCEPT_FUNCTION(purple_xfers_get_all)
    CONCEPT_FUNCTION(purple_xfer_ref)
    CONCEPT_FUNCTION(purple_xfer_unref)
    CONCEPT_FUNCTION(purple_xfer_request)
    CONCEPT_FUNCTION(purple_xfer_request_accepted)
    CONCEPT_FUNCTION(purple_xfer_request_denied)
    CONCEPT_FUNCTION(purple_xfer_get_type)
    CONCEPT_FUNCTION(purple_xfer_get_account)
    CONCEPT_FUNCTION(purple_xfer_get_remote_user)
    CONCEPT_FUNCTION(purple_xfer_get_status)
    CONCEPT_FUNCTION(purple_xfer_is_canceled)
    CONCEPT_FUNCTION(purple_xfer_is_completed)
    CONCEPT_FUNCTION(purple_xfer_get_filename)
    CONCEPT_FUNCTION(purple_xfer_get_local_filename)
    CONCEPT_FUNCTION(purple_xfer_get_bytes_sent)
    CONCEPT_FUNCTION(purple_xfer_get_bytes_remaining)
    CONCEPT_FUNCTION(purple_xfer_get_size)
    CONCEPT_FUNCTION(purple_xfer_get_progress)
    CONCEPT_FUNCTION(purple_xfer_get_local_port)
    CONCEPT_FUNCTION(purple_xfer_get_remote_ip)
    CONCEPT_FUNCTION(purple_xfer_get_remote_port)
    CONCEPT_FUNCTION(purple_xfer_get_start_time)
    CONCEPT_FUNCTION(purple_xfer_get_end_time)
    CONCEPT_FUNCTION(purple_xfer_set_completed)
    CONCEPT_FUNCTION(purple_xfer_set_message)
    CONCEPT_FUNCTION(purple_xfer_set_filename)
    CONCEPT_FUNCTION(purple_xfer_set_local_filename)
    CONCEPT_FUNCTION(purple_xfer_set_size)
    CONCEPT_FUNCTION(purple_xfer_set_bytes_sent)
    CONCEPT_FUNCTION(purple_xfer_get_ui_ops)
    CONCEPT_FUNCTION(purple_xfer_read)
    CONCEPT_FUNCTION(purple_xfer_write)
    CONCEPT_FUNCTION(purple_xfer_start)
    CONCEPT_FUNCTION(purple_xfer_end)
    CONCEPT_FUNCTION(purple_xfer_add)
    CONCEPT_FUNCTION(purple_xfer_cancel_local)
    CONCEPT_FUNCTION(purple_xfer_cancel_remote)
    CONCEPT_FUNCTION(purple_xfer_error)
    CONCEPT_FUNCTION(purple_xfer_update_progress)
    CONCEPT_FUNCTION(purple_xfer_conversation_write)
    CONCEPT_FUNCTION(purple_xfer_ui_ready)
    CONCEPT_FUNCTION(purple_xfer_prpl_ready)
    CONCEPT_FUNCTION(purple_xfers_get_handle)
    CONCEPT_FUNCTION(purple_xfers_init)
    CONCEPT_FUNCTION(purple_xfers_uninit)
    CONCEPT_FUNCTION(purple_xfers_set_ui_ops)
    CONCEPT_FUNCTION(purple_xfers_get_ui_ops)
    CONCEPT_FUNCTION(purple_idle_touch)
    CONCEPT_FUNCTION(purple_idle_set)
    CONCEPT_FUNCTION(purple_idle_set_ui_ops)
    CONCEPT_FUNCTION(purple_idle_get_ui_ops)
    CONCEPT_FUNCTION(purple_idle_init)
    CONCEPT_FUNCTION(purple_idle_uninit)
    CONCEPT_FUNCTION(purple_imgstore_add)
    CONCEPT_FUNCTION(purple_imgstore_new_from_file)
    CONCEPT_FUNCTION(purple_imgstore_add_with_id)
    CONCEPT_FUNCTION(purple_imgstore_find_by_id)
    CONCEPT_FUNCTION(purple_imgstore_get_data)
    CONCEPT_FUNCTION(purple_imgstore_get_size)
    CONCEPT_FUNCTION(purple_imgstore_get_filename)
    CONCEPT_FUNCTION(purple_imgstore_get_extension)
    CONCEPT_FUNCTION(purple_imgstore_ref)
    CONCEPT_FUNCTION(purple_imgstore_unref)
    CONCEPT_FUNCTION(purple_imgstore_ref_by_id)
    CONCEPT_FUNCTION(purple_imgstore_unref_by_id)
    CONCEPT_FUNCTION(purple_imgstore_get_handle)
    CONCEPT_FUNCTION(purple_imgstore_init)
    CONCEPT_FUNCTION(purple_imgstore_uninit)
    CONCEPT_FUNCTION(purple_log_new)
    CONCEPT_FUNCTION(purple_log_free)
    CONCEPT_FUNCTION(purple_log_write)
    CONCEPT_FUNCTION(purple_log_read)
    CONCEPT_FUNCTION(purple_log_get_logs)
    CONCEPT_FUNCTION(purple_log_get_log_sets)
    CONCEPT_FUNCTION(purple_log_get_system_logs)
    CONCEPT_FUNCTION(purple_log_get_size)
    CONCEPT_FUNCTION(purple_log_get_total_size)
    CONCEPT_FUNCTION(purple_log_get_activity_score)
    CONCEPT_FUNCTION(purple_log_is_deletable)
    CONCEPT_FUNCTION(purple_log_delete)
    CONCEPT_FUNCTION(purple_log_get_log_dir)
    CONCEPT_FUNCTION(purple_log_compare)
    CONCEPT_FUNCTION(purple_log_set_compare)
    CONCEPT_FUNCTION(purple_log_set_free)
    CONCEPT_FUNCTION(purple_log_common_writer)
    CONCEPT_FUNCTION(purple_log_common_lister)
    CONCEPT_FUNCTION(purple_log_common_total_sizer)
    CONCEPT_FUNCTION(purple_log_common_sizer)
    CONCEPT_FUNCTION(purple_log_common_deleter)
    CONCEPT_FUNCTION(purple_log_common_is_deletable)
    CONCEPT_FUNCTION(purple_log_logger_new)
    CONCEPT_FUNCTION(purple_log_logger_free)
    CONCEPT_FUNCTION(purple_log_logger_add)
    CONCEPT_FUNCTION(purple_log_logger_remove)
    CONCEPT_FUNCTION(purple_log_logger_set)
    CONCEPT_FUNCTION(purple_log_logger_get)
    CONCEPT_FUNCTION(purple_log_logger_get_options)
    CONCEPT_FUNCTION(purple_log_init)
    CONCEPT_FUNCTION(purple_log_get_handle)
    CONCEPT_FUNCTION(purple_log_uninit)
    CONCEPT_FUNCTION(purple_media_session_type_get_type)
    CONCEPT_FUNCTION(purple_media_candidate_type_get_type)
    CONCEPT_FUNCTION(purple_media_network_protocol_get_type)
    CONCEPT_FUNCTION(purple_media_get_type)
    CONCEPT_FUNCTION(purple_media_state_changed_get_type)
    CONCEPT_FUNCTION(purple_media_info_type_get_type)
    CONCEPT_FUNCTION(purple_media_candidate_get_type)
    CONCEPT_FUNCTION(purple_media_candidate_new)
    CONCEPT_FUNCTION(purple_media_candidate_list_copy)
    CONCEPT_FUNCTION(purple_media_candidate_list_free)
    CONCEPT_FUNCTION(purple_media_candidate_get_foundation)
    CONCEPT_FUNCTION(purple_media_candidate_get_component_id)
    CONCEPT_FUNCTION(purple_media_candidate_get_ip)
    CONCEPT_FUNCTION(purple_media_candidate_get_port)
    CONCEPT_FUNCTION(purple_media_candidate_get_base_ip)
    CONCEPT_FUNCTION(purple_media_candidate_get_base_port)
    CONCEPT_FUNCTION(purple_media_candidate_get_protocol)
    CONCEPT_FUNCTION(purple_media_candidate_get_priority)
    CONCEPT_FUNCTION(purple_media_candidate_get_candidate_type)
    CONCEPT_FUNCTION(purple_media_candidate_get_username)
    CONCEPT_FUNCTION(purple_media_candidate_get_password)
    CONCEPT_FUNCTION(purple_media_candidate_get_ttl)
    CONCEPT_FUNCTION(purple_media_codec_get_type)
    CONCEPT_FUNCTION(purple_media_codec_new)
    CONCEPT_FUNCTION(purple_media_codec_get_id)
    CONCEPT_FUNCTION(purple_media_codec_get_encoding_name)
    CONCEPT_FUNCTION(purple_media_codec_get_clock_rate)
    CONCEPT_FUNCTION(purple_media_codec_get_channels)
    CONCEPT_FUNCTION(purple_media_codec_get_optional_parameters)
    CONCEPT_FUNCTION(purple_media_codec_to_string)
    CONCEPT_FUNCTION(purple_media_codec_add_optional_parameter)
    CONCEPT_FUNCTION(purple_media_codec_remove_optional_parameter)
    CONCEPT_FUNCTION(purple_media_codec_get_optional_parameter)
    CONCEPT_FUNCTION(purple_media_codec_list_copy)
    CONCEPT_FUNCTION(purple_media_codec_list_free)
    CONCEPT_FUNCTION(purple_media_get_session_ids)
    CONCEPT_FUNCTION(purple_media_get_account)
    CONCEPT_FUNCTION(purple_media_get_prpl_data)
    CONCEPT_FUNCTION(purple_media_set_prpl_data)
    CONCEPT_FUNCTION(purple_media_error)
    CONCEPT_FUNCTION(purple_media_end)
    CONCEPT_FUNCTION(purple_media_stream_info)
    CONCEPT_FUNCTION(purple_media_add_stream)
    CONCEPT_FUNCTION(purple_media_get_session_type)
    CONCEPT_FUNCTION(purple_media_get_manager)
    CONCEPT_FUNCTION(purple_media_get_codecs)
    CONCEPT_FUNCTION(purple_media_add_remote_candidates)
    CONCEPT_FUNCTION(purple_media_get_local_candidates)
    CONCEPT_FUNCTION(purple_media_set_remote_codecs)
    CONCEPT_FUNCTION(purple_media_candidates_prepared)
    CONCEPT_FUNCTION(purple_media_set_send_codec)
    CONCEPT_FUNCTION(purple_media_codecs_ready)
    CONCEPT_FUNCTION(purple_media_is_initiator)
    CONCEPT_FUNCTION(purple_media_accepted)
    CONCEPT_FUNCTION(purple_media_set_input_volume)
    CONCEPT_FUNCTION(purple_media_set_output_volume)
    CONCEPT_FUNCTION(purple_media_set_output_window)
    CONCEPT_FUNCTION(purple_media_remove_output_windows)
    CONCEPT_FUNCTION(purple_media_element_type_get_type)
    CONCEPT_FUNCTION(purple_media_element_info_get_type)
    CONCEPT_FUNCTION(purple_media_get_src)
    CONCEPT_FUNCTION(purple_media_get_tee)
    CONCEPT_FUNCTION(purple_media_manager_get_pipeline)
    CONCEPT_FUNCTION(purple_media_manager_get_element)
    CONCEPT_FUNCTION(purple_media_manager_get_type)
    CONCEPT_FUNCTION(purple_media_manager_get)
    CONCEPT_FUNCTION(purple_media_manager_create_media)
    CONCEPT_FUNCTION(purple_media_manager_get_media)
    CONCEPT_FUNCTION(purple_media_manager_get_media_by_account)
    CONCEPT_FUNCTION(purple_media_manager_remove_media)
    CONCEPT_FUNCTION(purple_media_manager_create_output_window)
    CONCEPT_FUNCTION(purple_media_manager_set_output_window)
    CONCEPT_FUNCTION(purple_media_manager_remove_output_window)
    CONCEPT_FUNCTION(purple_media_manager_remove_output_windows)
    CONCEPT_FUNCTION(purple_media_manager_set_ui_caps)
    CONCEPT_FUNCTION(purple_media_manager_get_ui_caps)
    CONCEPT_FUNCTION(purple_mime_document_new)
    CONCEPT_FUNCTION(purple_mime_document_free)
    CONCEPT_FUNCTION(purple_mime_document_parse)
    CONCEPT_FUNCTION(purple_mime_document_parsen)
    CONCEPT_FUNCTION(purple_mime_document_write)
    CONCEPT_FUNCTION(purple_mime_document_get_fields)
    CONCEPT_FUNCTION(purple_mime_document_get_field)
    CONCEPT_FUNCTION(purple_mime_document_set_field)
    CONCEPT_FUNCTION(purple_mime_document_get_parts)
    CONCEPT_FUNCTION(purple_mime_part_new)
    CONCEPT_FUNCTION(purple_mime_part_get_fields)
    CONCEPT_FUNCTION(purple_mime_part_get_field)
    CONCEPT_FUNCTION(purple_mime_part_get_field_decoded)
    CONCEPT_FUNCTION(purple_mime_part_set_field)
    CONCEPT_FUNCTION(purple_mime_part_get_data)
    CONCEPT_FUNCTION(purple_mime_part_get_data_decoded)
    CONCEPT_FUNCTION(purple_mime_part_get_length)
    CONCEPT_FUNCTION(purple_mime_part_set_data)
    CONCEPT_FUNCTION(purple_pmp_init)
    CONCEPT_FUNCTION(purple_pmp_get_public_ip)
    CONCEPT_FUNCTION(purple_pmp_create_map)
    CONCEPT_FUNCTION(purple_pmp_destroy_map)
    CONCEPT_FUNCTION(purple_network_ip_atoi)
    CONCEPT_FUNCTION(purple_network_set_public_ip)
    CONCEPT_FUNCTION(purple_network_get_public_ip)
    CONCEPT_FUNCTION(purple_network_get_local_system_ip)
    CONCEPT_FUNCTION(purple_network_get_my_ip)
    CONCEPT_FUNCTION(purple_network_listen_map_external)
    CONCEPT_FUNCTION(purple_network_listen)
    CONCEPT_FUNCTION(purple_network_listen_range)
    CONCEPT_FUNCTION(purple_network_listen_cancel)
    CONCEPT_FUNCTION(purple_network_get_port_from_fd)
    CONCEPT_FUNCTION(purple_network_is_available)
    CONCEPT_FUNCTION(purple_network_force_online)
    CONCEPT_FUNCTION(purple_network_get_handle)
    CONCEPT_FUNCTION(purple_network_set_stun_server)
    CONCEPT_FUNCTION(purple_network_get_stun_ip)
    CONCEPT_FUNCTION(purple_network_set_turn_server)
    CONCEPT_FUNCTION(purple_network_get_turn_ip)
    CONCEPT_FUNCTION(purple_network_remove_port_mapping)
    CONCEPT_FUNCTION(purple_network_convert_idn_to_ascii)
    CONCEPT_FUNCTION(purple_network_init)
    CONCEPT_FUNCTION(purple_network_uninit)
    CONCEPT_FUNCTION(purple_notify_searchresults)
    CONCEPT_FUNCTION(purple_notify_searchresults_free)
    CONCEPT_FUNCTION(purple_notify_searchresults_new_rows)
    CONCEPT_FUNCTION(purple_notify_searchresults_button_add)
    CONCEPT_FUNCTION(purple_notify_searchresults_button_add_labeled)
    CONCEPT_FUNCTION(purple_notify_searchresults_new)
    CONCEPT_FUNCTION(purple_notify_searchresults_column_new)
    CONCEPT_FUNCTION(purple_notify_searchresults_column_add)
    CONCEPT_FUNCTION(purple_notify_searchresults_row_add)
    CONCEPT_FUNCTION(purple_notify_message)
    CONCEPT_FUNCTION(purple_notify_email)
    CONCEPT_FUNCTION(purple_notify_emails)
    CONCEPT_FUNCTION(purple_notify_formatted)
    CONCEPT_FUNCTION(purple_notify_userinfo)
    CONCEPT_FUNCTION(purple_notify_user_info_new)
    CONCEPT_FUNCTION(purple_notify_user_info_destroy)
    CONCEPT_FUNCTION(purple_notify_user_info_get_entries)
    CONCEPT_FUNCTION(purple_notify_user_info_get_text_with_newline)
    CONCEPT_FUNCTION(purple_notify_user_info_add_pair)
    CONCEPT_FUNCTION(purple_notify_user_info_prepend_pair)
    CONCEPT_FUNCTION(purple_notify_user_info_entry_new)
    CONCEPT_FUNCTION(purple_notify_user_info_add_section_break)
    CONCEPT_FUNCTION(purple_notify_user_info_prepend_section_break)
    CONCEPT_FUNCTION(purple_notify_user_info_add_section_header)
    CONCEPT_FUNCTION(purple_notify_user_info_prepend_section_header)
    CONCEPT_FUNCTION(purple_notify_user_info_remove_last_item)
    CONCEPT_FUNCTION(purple_notify_user_info_entry_get_label)
    CONCEPT_FUNCTION(purple_notify_user_info_entry_set_label)
    CONCEPT_FUNCTION(purple_notify_user_info_entry_get_value)
    CONCEPT_FUNCTION(purple_notify_user_info_entry_set_value)
    CONCEPT_FUNCTION(purple_notify_user_info_entry_get_type)
    CONCEPT_FUNCTION(purple_notify_user_info_entry_set_type)
    CONCEPT_FUNCTION(purple_notify_uri)
    CONCEPT_FUNCTION(purple_notify_close)
    CONCEPT_FUNCTION(purple_notify_close_with_handle)
    CONCEPT_FUNCTION(purple_notify_set_ui_ops)
    CONCEPT_FUNCTION(purple_notify_get_ui_ops)
    CONCEPT_FUNCTION(purple_notify_get_handle)
    CONCEPT_FUNCTION(purple_notify_init)
    CONCEPT_FUNCTION(purple_notify_uninit)
    CONCEPT_FUNCTION(purple_ntlm_gen_type1)
    CONCEPT_FUNCTION(purple_ntlm_parse_type2)
    CONCEPT_FUNCTION(purple_ntlm_gen_type3)
    CONCEPT_FUNCTION(purple_plugin_new)
    CONCEPT_FUNCTION(purple_plugin_probe)
    CONCEPT_FUNCTION(purple_plugin_register)
    CONCEPT_FUNCTION(purple_plugin_load)
    CONCEPT_FUNCTION(purple_plugin_unload)
    CONCEPT_FUNCTION(purple_plugin_disable)
    CONCEPT_FUNCTION(purple_plugin_reload)
    CONCEPT_FUNCTION(purple_plugin_destroy)
    CONCEPT_FUNCTION(purple_plugin_is_loaded)
    CONCEPT_FUNCTION(purple_plugin_is_unloadable)
    CONCEPT_FUNCTION(purple_plugin_get_id)
    CONCEPT_FUNCTION(purple_plugin_get_name)
    CONCEPT_FUNCTION(purple_plugin_get_version)
    CONCEPT_FUNCTION(purple_plugin_get_summary)
    CONCEPT_FUNCTION(purple_plugin_get_description)
    CONCEPT_FUNCTION(purple_plugin_get_author)
    CONCEPT_FUNCTION(purple_plugin_get_homepage)
    CONCEPT_FUNCTION(purple_plugin_ipc_register)
    CONCEPT_FUNCTION(purple_plugin_ipc_unregister)
    CONCEPT_FUNCTION(purple_plugin_ipc_unregister_all)
    CONCEPT_FUNCTION(purple_plugin_ipc_get_params)
    CONCEPT_FUNCTION(purple_plugin_ipc_call)
    CONCEPT_FUNCTION(purple_plugins_add_search_path)
    CONCEPT_FUNCTION(purple_plugins_get_search_paths)
    CONCEPT_FUNCTION(purple_plugins_unload_all)
    CONCEPT_FUNCTION(purple_plugins_unload)
    CONCEPT_FUNCTION(purple_plugins_destroy_all)
    CONCEPT_FUNCTION(purple_plugins_save_loaded)
    CONCEPT_FUNCTION(purple_plugins_load_saved)
    CONCEPT_FUNCTION(purple_plugins_probe)
    CONCEPT_FUNCTION(purple_plugins_enabled)
    CONCEPT_FUNCTION(purple_plugins_find_with_name)
    CONCEPT_FUNCTION(purple_plugins_find_with_filename)
    CONCEPT_FUNCTION(purple_plugins_find_with_basename)
    CONCEPT_FUNCTION(purple_plugins_find_with_id)
    CONCEPT_FUNCTION(purple_plugins_get_loaded)
    CONCEPT_FUNCTION(purple_plugins_get_protocols)
    CONCEPT_FUNCTION(purple_plugins_get_all)
    CONCEPT_FUNCTION(purple_plugins_get_handle)
    CONCEPT_FUNCTION(purple_plugins_init)
    CONCEPT_FUNCTION(purple_plugins_uninit)
    CONCEPT_FUNCTION(purple_plugin_action_free)
    CONCEPT_FUNCTION(purple_plugin_pref_frame_new)
    CONCEPT_FUNCTION(purple_plugin_pref_frame_destroy)
    CONCEPT_FUNCTION(purple_plugin_pref_frame_add)
    CONCEPT_FUNCTION(purple_plugin_pref_frame_get_prefs)
    CONCEPT_FUNCTION(purple_plugin_pref_new)
    CONCEPT_FUNCTION(purple_plugin_pref_new_with_name)
    CONCEPT_FUNCTION(purple_plugin_pref_new_with_label)
    CONCEPT_FUNCTION(purple_plugin_pref_new_with_name_and_label)
    CONCEPT_FUNCTION(purple_plugin_pref_destroy)
    CONCEPT_FUNCTION(purple_plugin_pref_set_name)
    CONCEPT_FUNCTION(purple_plugin_pref_get_name)
    CONCEPT_FUNCTION(purple_plugin_pref_set_label)
    CONCEPT_FUNCTION(purple_plugin_pref_get_label)
    CONCEPT_FUNCTION(purple_plugin_pref_set_bounds)
    CONCEPT_FUNCTION(purple_plugin_pref_get_bounds)
    CONCEPT_FUNCTION(purple_plugin_pref_set_type)
    CONCEPT_FUNCTION(purple_plugin_pref_get_type)
    CONCEPT_FUNCTION(purple_plugin_pref_add_choice)
    CONCEPT_FUNCTION(purple_plugin_pref_get_choices)
    CONCEPT_FUNCTION(purple_plugin_pref_set_max_length)
    CONCEPT_FUNCTION(purple_plugin_pref_get_max_length)
    CONCEPT_FUNCTION(purple_plugin_pref_set_masked)
    CONCEPT_FUNCTION(purple_plugin_pref_get_masked)
    CONCEPT_FUNCTION(purple_plugin_pref_set_format_type)
    CONCEPT_FUNCTION(purple_plugin_pref_get_format_type)
    CONCEPT_FUNCTION(purple_pounce_new)
    CONCEPT_FUNCTION(purple_pounce_destroy)
    CONCEPT_FUNCTION(purple_pounce_destroy_all_by_account)
    CONCEPT_FUNCTION(purple_pounce_set_events)
    CONCEPT_FUNCTION(purple_pounce_set_options)
    CONCEPT_FUNCTION(purple_pounce_set_pouncer)
    CONCEPT_FUNCTION(purple_pounce_set_pouncee)
    CONCEPT_FUNCTION(purple_pounce_set_save)
    CONCEPT_FUNCTION(purple_pounce_action_register)
    CONCEPT_FUNCTION(purple_pounce_action_set_enabled)
    CONCEPT_FUNCTION(purple_pounce_action_set_attribute)
    CONCEPT_FUNCTION(purple_pounce_set_data)
    CONCEPT_FUNCTION(purple_pounce_get_events)
    CONCEPT_FUNCTION(purple_pounce_get_options)
    CONCEPT_FUNCTION(purple_pounce_get_pouncer)
    CONCEPT_FUNCTION(purple_pounce_get_pouncee)
    CONCEPT_FUNCTION(purple_pounce_get_save)
    CONCEPT_FUNCTION(purple_pounce_action_is_enabled)
    CONCEPT_FUNCTION(purple_pounce_action_get_attribute)
    CONCEPT_FUNCTION(purple_pounce_get_data)
    CONCEPT_FUNCTION(purple_pounce_execute)
    CONCEPT_FUNCTION(purple_find_pounce)
    CONCEPT_FUNCTION(purple_pounces_load)
    CONCEPT_FUNCTION(purple_pounces_unregister_handler)
    CONCEPT_FUNCTION(purple_pounces_get_all)
    CONCEPT_FUNCTION(purple_pounces_get_all_for_ui)
    CONCEPT_FUNCTION(purple_pounces_get_handle)
    CONCEPT_FUNCTION(purple_pounces_init)
    CONCEPT_FUNCTION(purple_pounces_uninit)
    CONCEPT_FUNCTION(purple_prefs_get_handle)
    CONCEPT_FUNCTION(purple_prefs_init)
    CONCEPT_FUNCTION(purple_prefs_uninit)
    CONCEPT_FUNCTION(purple_prefs_add_none)
    CONCEPT_FUNCTION(purple_prefs_add_bool)
    CONCEPT_FUNCTION(purple_prefs_add_int)
    CONCEPT_FUNCTION(purple_prefs_add_string)
    CONCEPT_FUNCTION(purple_prefs_add_string_list)
    CONCEPT_FUNCTION(purple_prefs_add_path)
    CONCEPT_FUNCTION(purple_prefs_add_path_list)
    CONCEPT_FUNCTION(purple_prefs_remove)
    CONCEPT_FUNCTION(purple_prefs_rename)
    CONCEPT_FUNCTION(purple_prefs_rename_boolean_toggle)
    CONCEPT_FUNCTION(purple_prefs_destroy)
    CONCEPT_FUNCTION(purple_prefs_set_generic)
    CONCEPT_FUNCTION(purple_prefs_set_bool)
    CONCEPT_FUNCTION(purple_prefs_set_int)
    CONCEPT_FUNCTION(purple_prefs_set_string)
    CONCEPT_FUNCTION(purple_prefs_set_string_list)
    CONCEPT_FUNCTION(purple_prefs_set_path)
    CONCEPT_FUNCTION(purple_prefs_set_path_list)
    CONCEPT_FUNCTION(purple_prefs_exists)
    CONCEPT_FUNCTION(purple_prefs_get_type)
    CONCEPT_FUNCTION(purple_prefs_get_bool)
    CONCEPT_FUNCTION(purple_prefs_get_int)
    CONCEPT_FUNCTION(purple_prefs_get_string)
    CONCEPT_FUNCTION(purple_prefs_get_string_list)
    CONCEPT_FUNCTION(purple_prefs_get_path)
    CONCEPT_FUNCTION(purple_prefs_get_path_list)
    CONCEPT_FUNCTION(purple_prefs_get_children_names)
    CONCEPT_FUNCTION(purple_prefs_connect_callback)
    CONCEPT_FUNCTION(purple_prefs_disconnect_callback)
    CONCEPT_FUNCTION(purple_prefs_disconnect_by_handle)
    CONCEPT_FUNCTION(purple_prefs_trigger_callback)
    CONCEPT_FUNCTION(purple_prefs_load)
    CONCEPT_FUNCTION(purple_prefs_update_old)
    CONCEPT_FUNCTION(purple_privacy_permit_add)
    CONCEPT_FUNCTION(purple_privacy_permit_remove)
    CONCEPT_FUNCTION(purple_privacy_deny_add)
    CONCEPT_FUNCTION(purple_privacy_deny_remove)
    CONCEPT_FUNCTION(purple_privacy_allow)
    CONCEPT_FUNCTION(purple_privacy_deny)
    CONCEPT_FUNCTION(purple_privacy_check)
    CONCEPT_FUNCTION(purple_privacy_set_ui_ops)
    CONCEPT_FUNCTION(purple_privacy_get_ui_ops)
    CONCEPT_FUNCTION(purple_privacy_init)
    CONCEPT_FUNCTION(purple_proxy_info_new)
    CONCEPT_FUNCTION(purple_proxy_info_destroy)
    CONCEPT_FUNCTION(purple_proxy_info_set_type)
    CONCEPT_FUNCTION(purple_proxy_info_set_host)
    CONCEPT_FUNCTION(purple_proxy_info_set_port)
    CONCEPT_FUNCTION(purple_proxy_info_set_username)
    CONCEPT_FUNCTION(purple_proxy_info_set_password)
    CONCEPT_FUNCTION(purple_proxy_info_get_type)
    CONCEPT_FUNCTION(purple_proxy_info_get_host)
    CONCEPT_FUNCTION(purple_proxy_info_get_port)
    CONCEPT_FUNCTION(purple_proxy_info_get_username)
    CONCEPT_FUNCTION(purple_proxy_info_get_password)
    CONCEPT_FUNCTION(purple_global_proxy_get_info)
    CONCEPT_FUNCTION(purple_global_proxy_set_info)
    CONCEPT_FUNCTION(purple_proxy_get_handle)
    CONCEPT_FUNCTION(purple_proxy_init)
    CONCEPT_FUNCTION(purple_proxy_uninit)
    CONCEPT_FUNCTION(purple_proxy_get_setup)
    CONCEPT_FUNCTION(purple_proxy_connect)
    CONCEPT_FUNCTION(purple_proxy_connect_udp)
    CONCEPT_FUNCTION(purple_proxy_connect_socks5)
    CONCEPT_FUNCTION(purple_proxy_connect_cancel)
    CONCEPT_FUNCTION(purple_proxy_connect_cancel_with_handle)
    CONCEPT_FUNCTION(purple_attention_type_new)
    CONCEPT_FUNCTION(purple_attention_type_set_name)
    CONCEPT_FUNCTION(purple_attention_type_set_incoming_desc)
    CONCEPT_FUNCTION(purple_attention_type_set_outgoing_desc)
    CONCEPT_FUNCTION(purple_attention_type_set_icon_name)
    CONCEPT_FUNCTION(purple_attention_type_set_unlocalized_name)
    CONCEPT_FUNCTION(purple_attention_type_get_name)
    CONCEPT_FUNCTION(purple_attention_type_get_incoming_desc)
    CONCEPT_FUNCTION(purple_attention_type_get_outgoing_desc)
    CONCEPT_FUNCTION(purple_attention_type_get_icon_name)
    CONCEPT_FUNCTION(purple_attention_type_get_unlocalized_name)
    CONCEPT_FUNCTION(purple_prpl_got_account_idle)
    CONCEPT_FUNCTION(purple_prpl_got_account_login_time)
    CONCEPT_FUNCTION(purple_prpl_got_account_status)
    CONCEPT_FUNCTION(purple_prpl_got_account_actions)
    CONCEPT_FUNCTION(purple_prpl_got_user_idle)
    CONCEPT_FUNCTION(purple_prpl_got_user_login_time)
    CONCEPT_FUNCTION(purple_prpl_got_user_status)
    CONCEPT_FUNCTION(purple_prpl_got_user_status_deactive)
    CONCEPT_FUNCTION(purple_prpl_change_account_status)
    CONCEPT_FUNCTION(purple_prpl_get_statuses)
    CONCEPT_FUNCTION(purple_prpl_send_attention)
    CONCEPT_FUNCTION(purple_prpl_got_attention)
    CONCEPT_FUNCTION(purple_prpl_got_attention_in_chat)
    CONCEPT_FUNCTION(purple_prpl_get_media_caps)
    CONCEPT_FUNCTION(purple_prpl_initiate_media)
    CONCEPT_FUNCTION(purple_find_prpl)
    CONCEPT_FUNCTION(purple_init)
    CONCEPT_FUNCTION(purple_request_fields_new)
    CONCEPT_FUNCTION(purple_request_fields_destroy)
    CONCEPT_FUNCTION(purple_request_fields_add_group)
    CONCEPT_FUNCTION(purple_request_fields_get_groups)
    CONCEPT_FUNCTION(purple_request_fields_exists)
    CONCEPT_FUNCTION(purple_request_fields_get_required)
    CONCEPT_FUNCTION(purple_request_fields_is_field_required)
    CONCEPT_FUNCTION(purple_request_fields_all_required_filled)
    CONCEPT_FUNCTION(purple_request_fields_get_field)
    CONCEPT_FUNCTION(purple_request_fields_get_string)
    CONCEPT_FUNCTION(purple_request_fields_get_integer)
    CONCEPT_FUNCTION(purple_request_fields_get_bool)
    CONCEPT_FUNCTION(purple_request_fields_get_choice)
    CONCEPT_FUNCTION(purple_request_fields_get_account)
    CONCEPT_FUNCTION(purple_request_field_group_new)
    CONCEPT_FUNCTION(purple_request_field_group_destroy)
    CONCEPT_FUNCTION(purple_request_field_group_add_field)
    CONCEPT_FUNCTION(purple_request_field_group_get_title)
    CONCEPT_FUNCTION(purple_request_field_group_get_fields)
    CONCEPT_FUNCTION(purple_request_field_new)
    CONCEPT_FUNCTION(purple_request_field_destroy)
    CONCEPT_FUNCTION(purple_request_field_set_label)
    CONCEPT_FUNCTION(purple_request_field_set_visible)
    CONCEPT_FUNCTION(purple_request_field_set_type_hint)
    CONCEPT_FUNCTION(purple_request_field_set_required)
    CONCEPT_FUNCTION(purple_request_field_get_type)
    CONCEPT_FUNCTION(purple_request_field_get_group)
    CONCEPT_FUNCTION(purple_request_field_get_id)
    CONCEPT_FUNCTION(purple_request_field_get_label)
    CONCEPT_FUNCTION(purple_request_field_is_visible)
    CONCEPT_FUNCTION(purple_request_field_get_type_hint)
    CONCEPT_FUNCTION(purple_request_field_is_required)
    CONCEPT_FUNCTION(purple_request_field_get_ui_data)
    CONCEPT_FUNCTION(purple_request_field_set_ui_data)
    CONCEPT_FUNCTION(purple_request_field_string_new)
    CONCEPT_FUNCTION(purple_request_field_string_set_default_value)
    CONCEPT_FUNCTION(purple_request_field_string_set_value)
    CONCEPT_FUNCTION(purple_request_field_string_set_masked)
    CONCEPT_FUNCTION(purple_request_field_string_set_editable)
    CONCEPT_FUNCTION(purple_request_field_string_get_default_value)
    CONCEPT_FUNCTION(purple_request_field_string_get_value)
    CONCEPT_FUNCTION(purple_request_field_string_is_multiline)
    CONCEPT_FUNCTION(purple_request_field_string_is_masked)
    CONCEPT_FUNCTION(purple_request_field_string_is_editable)
    CONCEPT_FUNCTION(purple_request_field_int_new)
    CONCEPT_FUNCTION(purple_request_field_int_set_default_value)
    CONCEPT_FUNCTION(purple_request_field_int_set_value)
    CONCEPT_FUNCTION(purple_request_field_int_get_default_value)
    CONCEPT_FUNCTION(purple_request_field_int_get_value)
    CONCEPT_FUNCTION(purple_request_field_bool_new)
    CONCEPT_FUNCTION(purple_request_field_bool_set_default_value)
    CONCEPT_FUNCTION(purple_request_field_bool_set_value)
    CONCEPT_FUNCTION(purple_request_field_bool_get_default_value)
    CONCEPT_FUNCTION(purple_request_field_bool_get_value)
    CONCEPT_FUNCTION(purple_request_field_choice_new)
    CONCEPT_FUNCTION(purple_request_field_choice_add)
    CONCEPT_FUNCTION(purple_request_field_choice_set_default_value)
    CONCEPT_FUNCTION(purple_request_field_choice_set_value)
    CONCEPT_FUNCTION(purple_request_field_choice_get_default_value)
    CONCEPT_FUNCTION(purple_request_field_choice_get_value)
    CONCEPT_FUNCTION(purple_request_field_choice_get_labels)
    CONCEPT_FUNCTION(purple_request_field_list_new)
    CONCEPT_FUNCTION(purple_request_field_list_set_multi_select)
    CONCEPT_FUNCTION(purple_request_field_list_get_multi_select)
    CONCEPT_FUNCTION(purple_request_field_list_get_data)
    CONCEPT_FUNCTION(purple_request_field_list_add)
    CONCEPT_FUNCTION(purple_request_field_list_add_selected)
    CONCEPT_FUNCTION(purple_request_field_list_clear_selected)
    CONCEPT_FUNCTION(purple_request_field_list_set_selected)
    CONCEPT_FUNCTION(purple_request_field_list_is_selected)
    CONCEPT_FUNCTION(purple_request_field_list_get_selected)
    CONCEPT_FUNCTION(purple_request_field_list_get_items)
    CONCEPT_FUNCTION(purple_request_field_label_new)
    CONCEPT_FUNCTION(purple_request_field_image_new)
    CONCEPT_FUNCTION(purple_request_field_image_set_scale)
    CONCEPT_FUNCTION(purple_request_field_image_get_buffer)
    CONCEPT_FUNCTION(purple_request_field_image_get_size)
    CONCEPT_FUNCTION(purple_request_field_image_get_scale_x)
    CONCEPT_FUNCTION(purple_request_field_image_get_scale_y)
    CONCEPT_FUNCTION(purple_request_field_account_new)
    CONCEPT_FUNCTION(purple_request_field_account_set_default_value)
    CONCEPT_FUNCTION(purple_request_field_account_set_value)
    CONCEPT_FUNCTION(purple_request_field_account_set_show_all)
    CONCEPT_FUNCTION(purple_request_field_account_set_filter)
    CONCEPT_FUNCTION(purple_request_field_account_get_default_value)
    CONCEPT_FUNCTION(purple_request_field_account_get_value)
    CONCEPT_FUNCTION(purple_request_field_account_get_show_all)
    CONCEPT_FUNCTION(purple_request_field_account_get_filter)
    CONCEPT_FUNCTION(purple_request_input)
    CONCEPT_FUNCTION(purple_request_choice)
    CONCEPT_FUNCTION(purple_request_choice_varg)
    CONCEPT_FUNCTION(purple_request_action)
    CONCEPT_FUNCTION(purple_request_action_varg)
    CONCEPT_FUNCTION(purple_request_fields)
    CONCEPT_FUNCTION(purple_request_close)
    CONCEPT_FUNCTION(purple_request_close_with_handle)
    CONCEPT_FUNCTION(purple_request_file)
    CONCEPT_FUNCTION(purple_request_folder)
    CONCEPT_FUNCTION(purple_request_set_ui_ops)
    CONCEPT_FUNCTION(purple_request_get_ui_ops)
    CONCEPT_FUNCTION(purple_roomlist_show_with_account)
    CONCEPT_FUNCTION(purple_roomlist_new)
    CONCEPT_FUNCTION(purple_roomlist_ref)
    CONCEPT_FUNCTION(purple_roomlist_unref)
    CONCEPT_FUNCTION(purple_roomlist_set_fields)
    CONCEPT_FUNCTION(purple_roomlist_set_in_progress)
    CONCEPT_FUNCTION(purple_roomlist_get_in_progress)
    CONCEPT_FUNCTION(purple_roomlist_room_add)
    CONCEPT_FUNCTION(purple_roomlist_get_list)
    CONCEPT_FUNCTION(purple_roomlist_cancel_get_list)
    CONCEPT_FUNCTION(purple_roomlist_expand_category)
    CONCEPT_FUNCTION(purple_roomlist_get_fields)
    CONCEPT_FUNCTION(purple_roomlist_room_new)
    CONCEPT_FUNCTION(purple_roomlist_room_add_field)
    CONCEPT_FUNCTION(purple_roomlist_room_join)
    CONCEPT_FUNCTION(purple_roomlist_room_get_type)
    CONCEPT_FUNCTION(purple_roomlist_room_get_name)
    CONCEPT_FUNCTION(purple_roomlist_room_get_parent)
    CONCEPT_FUNCTION(purple_roomlist_room_get_fields)
    CONCEPT_FUNCTION(purple_roomlist_field_new)
    CONCEPT_FUNCTION(purple_roomlist_field_get_type)
    CONCEPT_FUNCTION(purple_roomlist_field_get_label)
    CONCEPT_FUNCTION(purple_roomlist_field_get_hidden)
    CONCEPT_FUNCTION(purple_roomlist_set_ui_ops)
    CONCEPT_FUNCTION(purple_roomlist_get_ui_ops)
    CONCEPT_FUNCTION(purple_savedstatus_new)
    CONCEPT_FUNCTION(purple_savedstatus_set_title)
    CONCEPT_FUNCTION(purple_savedstatus_set_type)
    CONCEPT_FUNCTION(purple_savedstatus_set_message)
    CONCEPT_FUNCTION(purple_savedstatus_set_substatus)
    CONCEPT_FUNCTION(purple_savedstatus_unset_substatus)
    CONCEPT_FUNCTION(purple_savedstatus_delete)
    CONCEPT_FUNCTION(purple_savedstatus_delete_by_status)
    CONCEPT_FUNCTION(purple_savedstatuses_get_all)
    CONCEPT_FUNCTION(purple_savedstatuses_get_popular)
    CONCEPT_FUNCTION(purple_savedstatus_get_current)
    CONCEPT_FUNCTION(purple_savedstatus_get_default)
    CONCEPT_FUNCTION(purple_savedstatus_get_idleaway)
    CONCEPT_FUNCTION(purple_savedstatus_is_idleaway)
    CONCEPT_FUNCTION(purple_savedstatus_set_idleaway)
    CONCEPT_FUNCTION(purple_savedstatus_get_startup)
    CONCEPT_FUNCTION(purple_savedstatus_find)
    CONCEPT_FUNCTION(purple_savedstatus_find_by_creation_time)
    CONCEPT_FUNCTION(purple_savedstatus_find_transient_by_type_and_message)
    CONCEPT_FUNCTION(purple_savedstatus_is_transient)
    CONCEPT_FUNCTION(purple_savedstatus_get_title)
    CONCEPT_FUNCTION(purple_savedstatus_get_type)
    CONCEPT_FUNCTION(purple_savedstatus_get_message)
    CONCEPT_FUNCTION(purple_savedstatus_get_creation_time)
    CONCEPT_FUNCTION(purple_savedstatus_has_substatuses)
    CONCEPT_FUNCTION(purple_savedstatus_get_substatus)
    CONCEPT_FUNCTION(purple_savedstatus_substatus_get_type)
    CONCEPT_FUNCTION(purple_savedstatus_substatus_get_message)
    CONCEPT_FUNCTION(purple_savedstatus_activate)
    CONCEPT_FUNCTION(purple_savedstatus_activate_for_account)
    CONCEPT_FUNCTION(purple_savedstatuses_get_handle)
    CONCEPT_FUNCTION(purple_savedstatuses_init)
    CONCEPT_FUNCTION(purple_savedstatuses_uninit)
    CONCEPT_FUNCTION(serv_send_typing)
    CONCEPT_FUNCTION(serv_move_buddy)
    CONCEPT_FUNCTION(serv_send_im)
    CONCEPT_FUNCTION(purple_get_attention_type_from_code)
    CONCEPT_FUNCTION(serv_send_attention)
    CONCEPT_FUNCTION(serv_got_attention)
    CONCEPT_FUNCTION(serv_get_info)
    CONCEPT_FUNCTION(serv_set_info)
    CONCEPT_FUNCTION(serv_add_permit)
    CONCEPT_FUNCTION(serv_add_deny)
    CONCEPT_FUNCTION(serv_rem_permit)
    CONCEPT_FUNCTION(serv_rem_deny)
    CONCEPT_FUNCTION(serv_set_permit_deny)
    CONCEPT_FUNCTION(serv_chat_invite)
    CONCEPT_FUNCTION(serv_chat_leave)
    CONCEPT_FUNCTION(serv_chat_whisper)
    CONCEPT_FUNCTION(serv_chat_send)
    CONCEPT_FUNCTION(serv_alias_buddy)
    CONCEPT_FUNCTION(serv_got_alias)
    CONCEPT_FUNCTION(purple_serv_got_private_alias)
    CONCEPT_FUNCTION(serv_got_typing)
    CONCEPT_FUNCTION(serv_got_typing_stopped)
    CONCEPT_FUNCTION(serv_got_im)
    CONCEPT_FUNCTION(serv_join_chat)
    CONCEPT_FUNCTION(serv_reject_chat)
    CONCEPT_FUNCTION(serv_got_chat_invite)
    CONCEPT_FUNCTION(serv_got_joined_chat)
    CONCEPT_FUNCTION(purple_serv_got_join_chat_failed)
    CONCEPT_FUNCTION(serv_got_chat_left)
    CONCEPT_FUNCTION(serv_got_chat_in)
    CONCEPT_FUNCTION(serv_send_file)
    CONCEPT_FUNCTION(purple_signal_register)
    CONCEPT_FUNCTION(purple_signal_unregister)
    CONCEPT_FUNCTION(purple_signals_unregister_by_instance)
    CONCEPT_FUNCTION(purple_signal_get_values)
    CONCEPT_FUNCTION(purple_signal_connect_priority)
    CONCEPT_FUNCTION(purple_signal_connect)
    CONCEPT_FUNCTION(purple_signal_connect2)
    CONCEPT_FUNCTION(purple_signal_connect3)
    CONCEPT_FUNCTION(purple_signal_connect4)
    CONCEPT_FUNCTION(purple_signal_connect_priority_vargs)
    CONCEPT_FUNCTION(purple_signal_connect_vargs)
    CONCEPT_FUNCTION(purple_signal_disconnect)
    CONCEPT_FUNCTION(purple_signals_disconnect_by_handle)
    CONCEPT_FUNCTION(purple_signal_emit)
    CONCEPT_FUNCTION(purple_signal_emit_vargs)
    CONCEPT_FUNCTION(purple_signal_emit_return_1)
    CONCEPT_FUNCTION(purple_signal_emit_vargs_return_1)
    CONCEPT_FUNCTION(purple_signals_init)
    CONCEPT_FUNCTION(purple_signals_uninit)
    CONCEPT_FUNCTION(purple_smiley_get_type)
    CONCEPT_FUNCTION(purple_smiley_new)
    CONCEPT_FUNCTION(purple_smiley_new_from_file)
    CONCEPT_FUNCTION(purple_smiley_delete)
    CONCEPT_FUNCTION(purple_smiley_set_shortcut)
    CONCEPT_FUNCTION(purple_smiley_set_data)
    CONCEPT_FUNCTION(purple_smiley_get_shortcut)
    CONCEPT_FUNCTION(purple_smiley_get_checksum)
    CONCEPT_FUNCTION(purple_smiley_get_stored_image)
    CONCEPT_FUNCTION(purple_smiley_get_data)
    CONCEPT_FUNCTION(purple_smiley_get_extension)
    CONCEPT_FUNCTION(purple_smiley_get_full_path)
    CONCEPT_FUNCTION(purple_smileys_get_all)
    CONCEPT_FUNCTION(purple_smileys_find_by_shortcut)
    CONCEPT_FUNCTION(purple_smileys_find_by_checksum)
    CONCEPT_FUNCTION(purple_smileys_get_storing_dir)
    CONCEPT_FUNCTION(purple_smileys_init)
    CONCEPT_FUNCTION(purple_smileys_uninit)
    CONCEPT_FUNCTION(purple_sound_play_file)
    CONCEPT_FUNCTION(purple_sound_play_event)
    CONCEPT_FUNCTION(purple_sound_set_ui_ops)
    CONCEPT_FUNCTION(purple_sound_get_ui_ops)
    CONCEPT_FUNCTION(purple_sound_init)
    CONCEPT_FUNCTION(purple_sound_uninit)
    CONCEPT_FUNCTION(purple_sounds_get_handle)
    CONCEPT_FUNCTION(purple_sound_theme_get_type)
    CONCEPT_FUNCTION(purple_sound_theme_get_file)
    CONCEPT_FUNCTION(purple_sound_theme_get_file_full)
    CONCEPT_FUNCTION(purple_sound_theme_set_file)
    CONCEPT_FUNCTION(purple_ssl_is_supported)
    CONCEPT_FUNCTION(purple_ssl_strerror)
    CONCEPT_FUNCTION(purple_ssl_connect)
    CONCEPT_FUNCTION(purple_ssl_connect_with_ssl_cn)
    CONCEPT_FUNCTION(purple_ssl_connect_with_host_fd)
    CONCEPT_FUNCTION(purple_ssl_input_add)
    CONCEPT_FUNCTION(purple_ssl_close)
    CONCEPT_FUNCTION(purple_ssl_read)
    CONCEPT_FUNCTION(purple_ssl_write)
    CONCEPT_FUNCTION(purple_ssl_get_peer_certificates)
    CONCEPT_FUNCTION(purple_ssl_set_ops)
    CONCEPT_FUNCTION(purple_ssl_get_ops)
    CONCEPT_FUNCTION(purple_ssl_init)
    CONCEPT_FUNCTION(purple_ssl_uninit)
    CONCEPT_FUNCTION(purple_primitive_get_id_from_type)
    CONCEPT_FUNCTION(purple_primitive_get_name_from_type)
    CONCEPT_FUNCTION(purple_primitive_get_type_from_id)
    CONCEPT_FUNCTION(purple_status_type_new_full)
    CONCEPT_FUNCTION(purple_status_type_new)
    CONCEPT_FUNCTION(purple_status_type_new_with_attrs)
    CONCEPT_FUNCTION(purple_status_type_destroy)
    CONCEPT_FUNCTION(purple_status_type_get_primitive)
    CONCEPT_FUNCTION(purple_status_type_get_id)
    CONCEPT_FUNCTION(purple_status_type_get_name)
    CONCEPT_FUNCTION(purple_status_type_is_saveable)
    CONCEPT_FUNCTION(purple_status_type_is_user_settable)
    CONCEPT_FUNCTION(purple_status_type_is_independent)
    CONCEPT_FUNCTION(purple_status_type_is_exclusive)
    CONCEPT_FUNCTION(purple_status_type_is_available)
    CONCEPT_FUNCTION(purple_status_type_get_attr)
    CONCEPT_FUNCTION(purple_status_type_get_attrs)
    CONCEPT_FUNCTION(purple_status_type_find_with_id)
    CONCEPT_FUNCTION(purple_status_attr_new)
    CONCEPT_FUNCTION(purple_status_attr_destroy)
    CONCEPT_FUNCTION(purple_status_attr_get_id)
    CONCEPT_FUNCTION(purple_status_attr_get_name)
    CONCEPT_FUNCTION(purple_status_attr_get_value)
    CONCEPT_FUNCTION(purple_status_new)
    CONCEPT_FUNCTION(purple_status_destroy)
    CONCEPT_FUNCTION(purple_status_set_active)
    CONCEPT_FUNCTION(purple_status_set_active_with_attrs)
    CONCEPT_FUNCTION(purple_status_set_active_with_attrs_list)
    CONCEPT_FUNCTION(purple_status_get_type)
    CONCEPT_FUNCTION(purple_status_get_presence)
    CONCEPT_FUNCTION(purple_status_get_id)
    CONCEPT_FUNCTION(purple_status_get_name)
    CONCEPT_FUNCTION(purple_status_is_independent)
    CONCEPT_FUNCTION(purple_status_is_exclusive)
    CONCEPT_FUNCTION(purple_status_is_available)
    CONCEPT_FUNCTION(purple_status_is_active)
    CONCEPT_FUNCTION(purple_status_is_online)
    CONCEPT_FUNCTION(purple_status_get_attr_value)
    CONCEPT_FUNCTION(purple_status_get_attr_boolean)
    CONCEPT_FUNCTION(purple_status_get_attr_int)
    CONCEPT_FUNCTION(purple_status_get_attr_string)
    CONCEPT_FUNCTION(purple_status_compare)
    CONCEPT_FUNCTION(purple_presence_new)
    CONCEPT_FUNCTION(purple_presence_new_for_account)
    CONCEPT_FUNCTION(purple_presence_new_for_conv)
    CONCEPT_FUNCTION(purple_presence_new_for_buddy)
    CONCEPT_FUNCTION(purple_presence_destroy)
    CONCEPT_FUNCTION(purple_presence_set_status_active)
    CONCEPT_FUNCTION(purple_presence_switch_status)
    CONCEPT_FUNCTION(purple_presence_set_idle)
    CONCEPT_FUNCTION(purple_presence_set_login_time)
    CONCEPT_FUNCTION(purple_presence_get_context)
    CONCEPT_FUNCTION(purple_presence_get_account)
    CONCEPT_FUNCTION(purple_presence_get_conversation)
    CONCEPT_FUNCTION(purple_presence_get_chat_user)
    CONCEPT_FUNCTION(purple_presence_get_buddy)
    CONCEPT_FUNCTION(purple_presence_get_statuses)
    CONCEPT_FUNCTION(purple_presence_get_status)
    CONCEPT_FUNCTION(purple_presence_get_active_status)
    CONCEPT_FUNCTION(purple_presence_is_available)
    CONCEPT_FUNCTION(purple_presence_is_online)
    CONCEPT_FUNCTION(purple_presence_is_status_active)
    CONCEPT_FUNCTION(purple_presence_is_status_primitive_active)
    CONCEPT_FUNCTION(purple_presence_is_idle)
    CONCEPT_FUNCTION(purple_presence_get_idle_time)
    CONCEPT_FUNCTION(purple_presence_get_login_time)
    CONCEPT_FUNCTION(purple_presence_compare)
    CONCEPT_FUNCTION(purple_status_get_handle)
    CONCEPT_FUNCTION(purple_status_init)
    CONCEPT_FUNCTION(purple_status_uninit)
    CONCEPT_FUNCTION(purple_theme_get_type)
    CONCEPT_FUNCTION(purple_theme_get_name)
    CONCEPT_FUNCTION(purple_theme_set_name)
    CONCEPT_FUNCTION(purple_theme_get_description)
    CONCEPT_FUNCTION(purple_theme_set_description)
    CONCEPT_FUNCTION(purple_theme_get_author)
    CONCEPT_FUNCTION(purple_theme_set_author)
    CONCEPT_FUNCTION(purple_theme_get_type_string)
    CONCEPT_FUNCTION(purple_theme_get_dir)
    CONCEPT_FUNCTION(purple_theme_set_dir)
    CONCEPT_FUNCTION(purple_theme_get_image)
    CONCEPT_FUNCTION(purple_theme_get_image_full)
    CONCEPT_FUNCTION(purple_theme_set_image)
    CONCEPT_FUNCTION(purple_theme_loader_get_type)
    CONCEPT_FUNCTION(purple_theme_loader_get_type_string)
    CONCEPT_FUNCTION(purple_theme_loader_build)
    CONCEPT_FUNCTION(purple_theme_manager_get_type)
    CONCEPT_FUNCTION(purple_theme_manager_init)
    CONCEPT_FUNCTION(purple_theme_manager_uninit)
    CONCEPT_FUNCTION(purple_theme_manager_refresh)
    CONCEPT_FUNCTION(purple_theme_manager_find_theme)
    CONCEPT_FUNCTION(purple_theme_manager_add_theme)
    CONCEPT_FUNCTION(purple_theme_manager_remove_theme)
    CONCEPT_FUNCTION(purple_theme_manager_register_type)
    CONCEPT_FUNCTION(purple_theme_manager_unregister_type)
    CONCEPT_FUNCTION(purple_theme_manager_for_each_theme)
    CONCEPT_FUNCTION(purple_theme_manager_load_theme)
    CONCEPT_FUNCTION(purple_upnp_init)
    CONCEPT_FUNCTION(purple_upnp_discover)
    CONCEPT_FUNCTION(purple_upnp_get_public_ip)
    CONCEPT_FUNCTION(purple_upnp_cancel_port_mapping)
    CONCEPT_FUNCTION(purple_upnp_set_port_mapping)
    CONCEPT_FUNCTION(purple_upnp_remove_port_mapping)
    CONCEPT_FUNCTION(purple_menu_action_new)
    CONCEPT_FUNCTION(purple_menu_action_free)
    CONCEPT_FUNCTION(purple_util_set_current_song)
    CONCEPT_FUNCTION(purple_util_format_song_info)
    CONCEPT_FUNCTION(purple_util_init)
    CONCEPT_FUNCTION(purple_util_uninit)
    CONCEPT_FUNCTION(purple_base16_encode)
    CONCEPT_FUNCTION(purple_base16_decode)
    CONCEPT_FUNCTION(purple_base16_encode_chunked)
    CONCEPT_FUNCTION(purple_base64_encode)
    CONCEPT_FUNCTION(purple_base64_decode)
    CONCEPT_FUNCTION(purple_quotedp_decode)
    CONCEPT_FUNCTION(purple_mime_decode_field)
    CONCEPT_FUNCTION(purple_utf8_strftime)
    CONCEPT_FUNCTION(purple_get_tzoff_str)
    CONCEPT_FUNCTION(purple_date_format_short)
    CONCEPT_FUNCTION(purple_date_format_long)
    CONCEPT_FUNCTION(purple_date_format_full)
    CONCEPT_FUNCTION(purple_time_format)
    CONCEPT_FUNCTION(purple_time_build)
    CONCEPT_FUNCTION(purple_str_to_time)
    CONCEPT_FUNCTION(purple_markup_escape_text)
    CONCEPT_FUNCTION(purple_markup_find_tag)
    CONCEPT_FUNCTION(purple_markup_extract_info_field)
    CONCEPT_FUNCTION(purple_markup_html_to_xhtml)
    CONCEPT_FUNCTION(purple_markup_strip_html)
    CONCEPT_FUNCTION(purple_markup_linkify)
    CONCEPT_FUNCTION(purple_unescape_html)
    CONCEPT_FUNCTION(purple_markup_slice)
    CONCEPT_FUNCTION(purple_markup_get_tag_name)
    CONCEPT_FUNCTION(purple_markup_unescape_entity)
    CONCEPT_FUNCTION(purple_markup_get_css_property)
    CONCEPT_FUNCTION(purple_markup_is_rtl)
    CONCEPT_FUNCTION(purple_home_dir)
    CONCEPT_FUNCTION(purple_user_dir)
    CONCEPT_FUNCTION(purple_util_set_user_dir)
    CONCEPT_FUNCTION(purple_build_dir)
    CONCEPT_FUNCTION(purple_util_write_data_to_file)
    CONCEPT_FUNCTION(purple_util_write_data_to_file_absolute)
    CONCEPT_FUNCTION(purple_util_read_xml_from_file)
    CONCEPT_FUNCTION(purple_mkstemp)
    CONCEPT_FUNCTION(purple_util_get_image_extension)
    CONCEPT_FUNCTION(purple_util_get_image_checksum)
    CONCEPT_FUNCTION(purple_util_get_image_filename)
    CONCEPT_FUNCTION(purple_program_is_valid)
    CONCEPT_FUNCTION(purple_running_gnome)
    CONCEPT_FUNCTION(purple_running_kde)
    CONCEPT_FUNCTION(purple_running_osx)
    CONCEPT_FUNCTION(purple_fd_get_ip)
    CONCEPT_FUNCTION(purple_strequal)
    CONCEPT_FUNCTION(purple_normalize)
    CONCEPT_FUNCTION(purple_normalize_nocase)
    CONCEPT_FUNCTION(purple_str_has_prefix)
    CONCEPT_FUNCTION(purple_str_has_suffix)
    CONCEPT_FUNCTION(purple_strdup_withhtml)
    CONCEPT_FUNCTION(purple_str_add_cr)
    CONCEPT_FUNCTION(purple_str_strip_char)
    CONCEPT_FUNCTION(purple_util_chrreplace)
    CONCEPT_FUNCTION(purple_strreplace)
    CONCEPT_FUNCTION(purple_utf8_ncr_encode)
    CONCEPT_FUNCTION(purple_utf8_ncr_decode)
    CONCEPT_FUNCTION(purple_strcasereplace)
    CONCEPT_FUNCTION(purple_strcasestr)
    CONCEPT_FUNCTION(purple_str_size_to_units)
    CONCEPT_FUNCTION(purple_str_seconds_to_string)
    CONCEPT_FUNCTION(purple_str_binary_to_ascii)
    CONCEPT_FUNCTION(purple_got_protocol_handler_uri)
    CONCEPT_FUNCTION(purple_url_parse)
    CONCEPT_FUNCTION(purple_util_fetch_url_request)
    CONCEPT_FUNCTION(purple_util_fetch_url_request_len)
    CONCEPT_FUNCTION(purple_util_fetch_url_request_len_with_account)
    CONCEPT_FUNCTION(purple_util_fetch_url_cancel)
    CONCEPT_FUNCTION(purple_url_decode)
    CONCEPT_FUNCTION(purple_url_encode)
    CONCEPT_FUNCTION(purple_email_is_valid)
    CONCEPT_FUNCTION(purple_ip_address_is_valid)
    CONCEPT_FUNCTION(purple_ipv4_address_is_valid)
    CONCEPT_FUNCTION(purple_ipv6_address_is_valid)
    CONCEPT_FUNCTION(purple_uri_list_extract_uris)
    CONCEPT_FUNCTION(purple_uri_list_extract_filenames)
    CONCEPT_FUNCTION(purple_utf8_try_convert)
    CONCEPT_FUNCTION(purple_utf8_salvage)
    CONCEPT_FUNCTION(purple_utf8_strip_unprintables)
    CONCEPT_FUNCTION(purple_gai_strerror)
    CONCEPT_FUNCTION(purple_utf8_strcasecmp)
    CONCEPT_FUNCTION(purple_utf8_has_word)
    CONCEPT_FUNCTION(purple_print_utf8_to_console)
    CONCEPT_FUNCTION(purple_message_meify)
    CONCEPT_FUNCTION(purple_text_strip_mnemonic)
    CONCEPT_FUNCTION(purple_unescape_filename)
    CONCEPT_FUNCTION(purple_escape_filename)
    CONCEPT_FUNCTION(_purple_oscar_convert)
    CONCEPT_FUNCTION(purple_restore_default_signal_handlers)
    CONCEPT_FUNCTION(purple_get_host_name)
    CONCEPT_FUNCTION(purple_value_new)
    CONCEPT_FUNCTION(purple_value_new_outgoing)
    CONCEPT_FUNCTION(purple_value_destroy)
    CONCEPT_FUNCTION(purple_value_dup)
    CONCEPT_FUNCTION(purple_value_get_type)
    CONCEPT_FUNCTION(purple_value_get_subtype)
    CONCEPT_FUNCTION(purple_value_get_specific_type)
    CONCEPT_FUNCTION(purple_value_is_outgoing)
    CONCEPT_FUNCTION(purple_value_set_char)
    CONCEPT_FUNCTION(purple_value_set_uchar)
    CONCEPT_FUNCTION(purple_value_set_boolean)
    CONCEPT_FUNCTION(purple_value_set_short)
    CONCEPT_FUNCTION(purple_value_set_ushort)
    CONCEPT_FUNCTION(purple_value_set_int)
    CONCEPT_FUNCTION(purple_value_set_uint)
    CONCEPT_FUNCTION(purple_value_set_long)
    CONCEPT_FUNCTION(purple_value_set_ulong)
    CONCEPT_FUNCTION(purple_value_set_int64)
    CONCEPT_FUNCTION(purple_value_set_uint64)
    CONCEPT_FUNCTION(purple_value_set_string)
    CONCEPT_FUNCTION(purple_value_set_object)
    CONCEPT_FUNCTION(purple_value_set_pointer)
    CONCEPT_FUNCTION(purple_value_set_enum)
    CONCEPT_FUNCTION(purple_value_set_boxed)
    CONCEPT_FUNCTION(purple_value_get_char)
    CONCEPT_FUNCTION(purple_value_get_uchar)
    CONCEPT_FUNCTION(purple_value_get_boolean)
    CONCEPT_FUNCTION(purple_value_get_short)
    CONCEPT_FUNCTION(purple_value_get_ushort)
    CONCEPT_FUNCTION(purple_value_get_int)
    CONCEPT_FUNCTION(purple_value_get_uint)
    CONCEPT_FUNCTION(purple_value_get_long)
    CONCEPT_FUNCTION(purple_value_get_ulong)
    CONCEPT_FUNCTION(purple_value_get_int64)
    CONCEPT_FUNCTION(purple_value_get_uint64)
    CONCEPT_FUNCTION(purple_value_get_string)
    CONCEPT_FUNCTION(purple_value_get_object)
    CONCEPT_FUNCTION(purple_value_get_pointer)
    CONCEPT_FUNCTION(purple_value_get_enum)
    CONCEPT_FUNCTION(purple_value_get_boxed)
}
