//------------ standard header -----------------------------------//
#include "stdlibrary.h"
//------------ end of standard header ----------------------------//
#include "library.h"
#include "AnsiString.h"
#include <string.h>
//extern "C" {
	#include <curl/curl.h>
//}
#include "twitcurl.h"

//=====================================================================================//
INVOKE_CALL InvokePtr=0;
//=====================================================================================//
CONCEPT_DLL_API ON_CREATE_CONTEXT MANAGEMENT_PARAMETERS {
    InvokePtr=Invoke;
	return 0;
}
//=====================================================================================//
CONCEPT_DLL_API ON_DESTROY_CONTEXT MANAGEMENT_PARAMETERS {
	return 0;
}
//=====================================================================================//
CONCEPT_FUNCTION_IMPL(Twitter_Auth,4)
    T_HANDLE2(0,twitCurl*)
    T_STRING(1) // public key file
    T_STRING(2) // private key file
    T_STRING(3) // twitter provided pin

    twitCurl *twitterObj=PARAM(0);
    /* OAuth flow begins */
    /* Step 0: Set OAuth related params. These are got by registering your app at twitter.com */
    twitterObj->getOAuth().setConsumerKey( std::string( "vlC5S1NCMHHg8mD1ghPRkA" ) );
    twitterObj->getOAuth().setConsumerSecret( std::string( "3w4cIrHyI3IYUZW5O2ppcFXmsACDaENzFdLIKmEU84" ) );

    /* Step 1: Check if we alredy have OAuth access token from a previous run */
    //char szKey[1024];
    std::string myOAuthAccessTokenKey("");
    std::string myOAuthAccessTokenSecret("");
    //ifstream oAuthTokenKeyIn;
    //ifstream oAuthTokenSecretIn;

    //oAuthTokenKeyIn.open( PARAM(1) );
    //oAuthTokenSecretIn.open( PARAM(2) );

    //memset( szKey, 0, 1024 );
    //oAuthTokenKeyIn >> szKey;
    //myOAuthAccessTokenKey = szKey;

    //memset( szKey, 0, 1024 );
    //oAuthTokenSecretIn >> szKey;
    myOAuthAccessTokenKey = PARAM(1);
    myOAuthAccessTokenSecret = PARAM(2);

    //oAuthTokenKeyIn.close();
    //oAuthTokenSecretIn.close();
    
    if( myOAuthAccessTokenKey.size() && myOAuthAccessTokenSecret.size() )
    {
        twitterObj->getOAuth().setOAuthTokenKey( myOAuthAccessTokenKey );
        twitterObj->getOAuth().setOAuthTokenSecret( myOAuthAccessTokenSecret );
    }
    else
    {
        std::string tmpStr( "" );
        /* Step 2: Get request token key and secret */
        twitterObj->oAuthRequestToken( tmpStr );

        /* Step 3: Ask user to visit web link and get PIN */
        //char szOAuthVerifierPin[1024];
        //memset( szOAuthVerifierPin, 0, 1024 );
        tmpStr = PARAM(3);
        twitterObj->getOAuth().setOAuthPin( tmpStr );

        /* Step 4: Exchange request token with access token */
        twitterObj->oAuthAccessToken();

        /* Step 5: Now, save this access token key and secret for future use without PIN */
        twitterObj->getOAuth().getOAuthTokenKey( myOAuthAccessTokenKey );
        twitterObj->getOAuth().getOAuthTokenSecret( myOAuthAccessTokenSecret );

        /* Step 6: Save these keys in a file or wherever */
        /*ofstream oAuthTokenKeyOut;
        ofstream oAuthTokenSecretOut;

        oAuthTokenKeyOut.open( PARAM(1) );
        oAuthTokenSecretOut.open( PARAM(2) );

        oAuthTokenKeyOut.clear();
        oAuthTokenSecretOut.clear();

        oAuthTokenKeyOut << myOAuthAccessTokenKey.c_str();
        oAuthTokenSecretOut << myOAuthAccessTokenSecret.c_str();

        oAuthTokenKeyOut.close();
        oAuthTokenSecretOut.close();*/
    }
    /* OAuth flow ends */
    RETURN_NUMBER(0)
END_IMPL
//=====================================================================================//
CONCEPT_FUNCTION_IMPL(Twitter_Create,0)
    twitCurl *inst=new twitCurl();
    RETURN_NUMBER((long)inst);
END_IMPL
//=====================================================================================//
CONCEPT_FUNCTION_IMPL(Twitter_Destroy,1)
    T_HANDLE2(0,twitCurl*)
    twitCurl *inst=PARAM(0);
    delete inst;
    RETURN_NUMBER(0);
END_IMPL
//=====================================================================================//
CONCEPT_FUNCTION_IMPL(Twitter_getTwitterUsername,1)
    T_HANDLE2(0,twitCurl*)
    twitCurl *inst=PARAM(0);

    RETURN_STRING(inst->getTwitterUsername().c_str());
END_IMPL
//=====================================================================================//
CONCEPT_FUNCTION_IMPL(Twitter_getTwitterPassword,1)
    T_HANDLE2(0,twitCurl*)
    twitCurl *inst=PARAM(0);

    RETURN_STRING(inst->getTwitterPassword().c_str());
END_IMPL
//=====================================================================================//
CONCEPT_FUNCTION_IMPL(Twitter_setTwitterUsername,2)
    T_HANDLE2(0,twitCurl*)
    T_STRING(1)
    twitCurl *inst=PARAM(0);
    std::string tmp=PARAM(1);

    inst->setTwitterUsername(tmp);
    RETURN_NUMBER(0);
END_IMPL
//=====================================================================================//
CONCEPT_FUNCTION_IMPL(Twitter_setTwitterPassword,2)
    T_HANDLE2(0,twitCurl*)
    T_STRING(1)
    twitCurl *inst=PARAM(0);
    std::string tmp=PARAM(1);

    inst->setTwitterPassword(tmp);
    RETURN_NUMBER(0);
END_IMPL
//=====================================================================================//
CONCEPT_FUNCTION_IMPL(Twitter_search,2)
    T_HANDLE2(0,twitCurl*)
    T_STRING(1)
    twitCurl *inst=PARAM(0);
    std::string tmp=PARAM(1);

    RETURN_NUMBER(inst->search(tmp));
END_IMPL
//=====================================================================================//
CONCEPT_FUNCTION_IMPL(Twitter_statusUpdate,2)
    T_HANDLE2(0,twitCurl*)
    T_STRING(1)
    twitCurl *inst=PARAM(0);
    std::string tmp=PARAM(1);

    RETURN_NUMBER(inst->statusUpdate(tmp));
END_IMPL
//=====================================================================================//
CONCEPT_FUNCTION_IMPL(Twitter_statusShowById,2)
    T_HANDLE2(0,twitCurl*)
    T_STRING(1)
    std::string tmp=PARAM(1);
    twitCurl *inst=PARAM(0);

    RETURN_NUMBER(inst->statusShowById(tmp));
END_IMPL
//=====================================================================================//
CONCEPT_FUNCTION_IMPL(Twitter_statusDestroyById,2)
    T_HANDLE2(0,twitCurl*)
    T_STRING(1)
    twitCurl *inst=PARAM(0);
    std::string tmp=PARAM(1);

    RETURN_NUMBER(inst->statusDestroyById(tmp));
END_IMPL
//=====================================================================================//
CONCEPT_FUNCTION_IMPL(Twitter_timelinePublicGet,1)
    T_HANDLE2(0,twitCurl*)
    twitCurl *inst=PARAM(0);

    RETURN_NUMBER(inst->timelinePublicGet());
END_IMPL
//=====================================================================================//
CONCEPT_FUNCTION_IMPL(Twitter_timelineFriendsGet,1)
    T_HANDLE2(0,twitCurl*)
    twitCurl *inst=PARAM(0);

    RETURN_NUMBER(inst->timelineFriendsGet());
END_IMPL
//=====================================================================================//
CONCEPT_FUNCTION_IMPL(Twitter_timelineUserGet,3)
    T_HANDLE2(0,twitCurl*)
    T_STRING(1)
    T_NUMBER(2)
    std::string tmp=PARAM(1);
    twitCurl *inst=PARAM(0);

    RETURN_NUMBER(inst->timelineUserGet(tmp, PARAM_INT(2)));
END_IMPL
//=====================================================================================//
CONCEPT_FUNCTION_IMPL(Twitter_featuredUsersGet,1)
    T_HANDLE2(0,twitCurl*)
    twitCurl *inst=PARAM(0);

    RETURN_NUMBER(inst->featuredUsersGet());
END_IMPL
//=====================================================================================//
CONCEPT_FUNCTION_IMPL(Twitter_mentionsGet,1)
    T_HANDLE2(0,twitCurl*)
    twitCurl *inst=PARAM(0);

    RETURN_NUMBER(inst->mentionsGet());
END_IMPL
//=====================================================================================//
CONCEPT_FUNCTION_IMPL(Twitter_userGet,3)
    T_HANDLE2(0,twitCurl*)
    twitCurl *inst=PARAM(0);
    T_STRING(1)
    T_NUMBER(2)
    std::string tmp=PARAM(1);

    RETURN_NUMBER(inst->userGet(tmp, PARAM_INT(2)));
END_IMPL
//=====================================================================================//
CONCEPT_FUNCTION_IMPL(Twitter_friendsGet,3)
    T_HANDLE2(0,twitCurl*)
    twitCurl *inst=PARAM(0);
    T_STRING(1)
    T_NUMBER(2)
    std::string tmp=PARAM(1);

    RETURN_NUMBER(inst->friendsGet(tmp, PARAM_INT(2)));
END_IMPL
//=====================================================================================//
CONCEPT_FUNCTION_IMPL(Twitter_followersGet,3)
    T_HANDLE2(0,twitCurl*)
    twitCurl *inst=PARAM(0);
    T_STRING(1)
    T_NUMBER(2)
    std::string tmp=PARAM(1);

    RETURN_NUMBER(inst->followersGet(tmp, PARAM_INT(2)));
END_IMPL
//=====================================================================================//
CONCEPT_FUNCTION_IMPL(Twitter_directMessageGet,1)
    T_HANDLE2(0,twitCurl*)
    twitCurl *inst=PARAM(0);

    RETURN_NUMBER(inst->directMessageGet());
END_IMPL
//=====================================================================================//
CONCEPT_FUNCTION_IMPL(Twitter_directMessageSend,4)
    T_HANDLE2(0,twitCurl*)
    twitCurl *inst=PARAM(0);
    T_STRING(1)
    std::string tmp=PARAM(1);
    T_STRING(2)
    std::string tmp2=PARAM(2);
    T_NUMBER(3)

    RETURN_NUMBER(inst->directMessageSend(tmp, tmp2, PARAM_INT(3)));
END_IMPL
//=====================================================================================//
CONCEPT_FUNCTION_IMPL(Twitter_directMessageGetSent,1)
    T_HANDLE2(0,twitCurl*)
    twitCurl *inst=PARAM(0);

    RETURN_NUMBER(inst->directMessageGetSent());
END_IMPL
//=====================================================================================//
CONCEPT_FUNCTION_IMPL(Twitter_directMessageDestroyById,2)
    T_HANDLE2(0,twitCurl*)
    twitCurl *inst=PARAM(0);
    T_STRING(1)
    std::string tmp=PARAM(1);

    RETURN_NUMBER(inst->directMessageDestroyById(tmp));
END_IMPL
//=====================================================================================//
CONCEPT_FUNCTION_IMPL(Twitter_friendshipCreate,3)
    T_HANDLE2(0,twitCurl*)
    twitCurl *inst=PARAM(0);
    T_STRING(1)
    T_NUMBER(2)
    std::string tmp=PARAM(1);

    RETURN_NUMBER(inst->friendshipCreate(tmp, PARAM_INT(2)));
END_IMPL
//=====================================================================================//
CONCEPT_FUNCTION_IMPL(Twitter_friendshipDestroy,3)
    T_HANDLE2(0,twitCurl*)
    twitCurl *inst=PARAM(0);
    T_STRING(1)
    T_NUMBER(2)
    std::string tmp=PARAM(1);

    RETURN_NUMBER(inst->friendshipDestroy(tmp, PARAM_INT(2)));
END_IMPL
//=====================================================================================//
CONCEPT_FUNCTION_IMPL(Twitter_friendshipShow,3)
    T_HANDLE2(0,twitCurl*)
    twitCurl *inst=PARAM(0);
    T_STRING(1)
    T_NUMBER(2)
    std::string tmp=PARAM(1);

    RETURN_NUMBER(inst->friendshipShow(tmp, PARAM_INT(2)));
END_IMPL
//=====================================================================================//
CONCEPT_FUNCTION_IMPL(Twitter_friendsIdsGet,3)
    T_HANDLE2(0,twitCurl*)
    twitCurl *inst=PARAM(0);
    T_STRING(1)
    T_NUMBER(2)
    std::string tmp=PARAM(1);

    RETURN_NUMBER(inst->friendsIdsGet(tmp, PARAM_INT(2)));
END_IMPL
//=====================================================================================//
CONCEPT_FUNCTION_IMPL(Twitter_followersIdsGet,3)
    T_HANDLE2(0,twitCurl*)
    twitCurl *inst=PARAM(0);
    T_STRING(1)
    T_NUMBER(2)
    std::string tmp=PARAM(1);

    RETURN_NUMBER(inst->followersIdsGet(tmp, PARAM_INT(2)));
END_IMPL
//=====================================================================================//
CONCEPT_FUNCTION_IMPL(Twitter_accountRateLimitGet,1)
    T_HANDLE2(0,twitCurl*)
    twitCurl *inst=PARAM(0);

    RETURN_NUMBER(inst->accountRateLimitGet());
END_IMPL
//=====================================================================================//
CONCEPT_FUNCTION_IMPL(Twitter_favoriteGet,1)
    T_HANDLE2(0,twitCurl*)
    twitCurl *inst=PARAM(0);

    RETURN_NUMBER(inst->favoriteGet());
END_IMPL
//=====================================================================================//
CONCEPT_FUNCTION_IMPL(Twitter_favoriteCreate,2)
    T_HANDLE2(0,twitCurl*)
    twitCurl *inst=PARAM(0);
    T_STRING(1)
    std::string tmp=PARAM(1);

    RETURN_NUMBER(inst->favoriteCreate(tmp));
END_IMPL
//=====================================================================================//
CONCEPT_FUNCTION_IMPL(Twitter_favoriteDestroy,2)
    T_HANDLE2(0,twitCurl*)
    twitCurl *inst=PARAM(0);
    T_STRING(1)
    std::string tmp=PARAM(1);

    RETURN_NUMBER(inst->favoriteDestroy(tmp));
END_IMPL
//=====================================================================================//
CONCEPT_FUNCTION_IMPL(Twitter_blockCreate,2)
    T_HANDLE2(0,twitCurl*)
    twitCurl *inst=PARAM(0);
    T_STRING(1)
    std::string tmp=PARAM(1);

    RETURN_NUMBER(inst->blockCreate(tmp));
END_IMPL
//=====================================================================================//
CONCEPT_FUNCTION_IMPL(Twitter_blockDestroy,2)
    T_HANDLE2(0,twitCurl*)
    twitCurl *inst=PARAM(0);
    T_STRING(1)
    std::string tmp=PARAM(1);

    RETURN_NUMBER(inst->blockDestroy(tmp));
END_IMPL
//=====================================================================================//
CONCEPT_FUNCTION_IMPL(Twitter_savedSearchGet,1)
    T_HANDLE2(0,twitCurl*)
    twitCurl *inst=PARAM(0);

    RETURN_NUMBER(inst->savedSearchGet());
END_IMPL
//=====================================================================================//
CONCEPT_FUNCTION_IMPL(Twitter_savedSearchCreate,2)
    T_HANDLE2(0,twitCurl*)
    twitCurl *inst=PARAM(0);
    T_STRING(1)
    std::string tmp=PARAM(1);

    RETURN_NUMBER(inst->savedSearchCreate(tmp));
END_IMPL
//=====================================================================================//
CONCEPT_FUNCTION_IMPL(Twitter_savedSearchShow,2)
    T_HANDLE2(0,twitCurl*)
    twitCurl *inst=PARAM(0);
    T_STRING(1)
    std::string tmp=PARAM(1);

    RETURN_NUMBER(inst->savedSearchShow(tmp));
END_IMPL
//=====================================================================================//
CONCEPT_FUNCTION_IMPL(Twitter_savedSearchDestroy,2)
    T_HANDLE2(0,twitCurl*)
    twitCurl *inst=PARAM(0);
    T_STRING(1)
    std::string tmp=PARAM(1);

    RETURN_NUMBER(inst->savedSearchDestroy(tmp));
END_IMPL
//=====================================================================================//
CONCEPT_FUNCTION_IMPL(Twitter_isCurlInit,1)
    T_HANDLE2(0,twitCurl*)
    twitCurl *inst=PARAM(0);

    RETURN_NUMBER(inst->isCurlInit());
END_IMPL
//=====================================================================================//
CONCEPT_FUNCTION_IMPL(Twitter_getLastWebResponse,1)
    T_HANDLE2(0,twitCurl*)
    twitCurl *inst=PARAM(0);
    std::string tmp;

    inst->getLastWebResponse(tmp);
    RETURN_BUFFER(tmp.c_str(), tmp.length())
END_IMPL
//=====================================================================================//
CONCEPT_FUNCTION_IMPL(Twitter_getLastCurlError,1)
    T_HANDLE2(0,twitCurl*)
    twitCurl *inst=PARAM(0);
    std::string tmp;

    inst->getLastCurlError(tmp);
    RETURN_BUFFER(tmp.c_str(), tmp.length())
END_IMPL
//=====================================================================================//
CONCEPT_FUNCTION_IMPL(Twitter_getProxyServerIp,1)
    T_HANDLE2(0,twitCurl*)
    twitCurl *inst=PARAM(0);

    RETURN_STRING((inst->getProxyServerIp().c_str()));
END_IMPL
//=====================================================================================//
CONCEPT_FUNCTION_IMPL(Twitter_getProxyServerPort,1)
    T_HANDLE2(0,twitCurl*)
    twitCurl *inst=PARAM(0);

    RETURN_STRING((inst->getProxyServerPort().c_str()));
END_IMPL
//=====================================================================================//
CONCEPT_FUNCTION_IMPL(Twitter_getProxyUserName,1)
    T_HANDLE2(0,twitCurl*)
    twitCurl *inst=PARAM(0);

    RETURN_STRING((inst->getProxyUserName().c_str()));
END_IMPL
//=====================================================================================//
CONCEPT_FUNCTION_IMPL(Twitter_getProxyPassword,1)
    T_HANDLE2(0,twitCurl*)
    twitCurl *inst=PARAM(0);

    RETURN_STRING((inst->getProxyPassword().c_str()));
END_IMPL
//=====================================================================================//
CONCEPT_FUNCTION_IMPL(Twitter_setProxyServerIp,2)
    T_HANDLE2(0,twitCurl*)
    twitCurl *inst=PARAM(0);
    T_STRING(1)
    std::string tmp=PARAM(1);

    inst->setProxyServerIp(tmp);

    RETURN_NUMBER(0);
END_IMPL
//=====================================================================================//
CONCEPT_FUNCTION_IMPL(Twitter_setProxyServerPort,2)
    T_HANDLE2(0,twitCurl*)
    twitCurl *inst=PARAM(0);
    T_STRING(1)
    std::string tmp=PARAM(1);

    inst->setProxyServerPort(tmp);

    RETURN_NUMBER(0);
END_IMPL
//=====================================================================================//
CONCEPT_FUNCTION_IMPL(Twitter_setProxyUserName,2)
    T_HANDLE2(0,twitCurl*)
    twitCurl *inst=PARAM(0);
    T_STRING(1)
    std::string tmp=PARAM(1);

    inst->setProxyUserName(tmp);

    RETURN_NUMBER(0);
END_IMPL
//=====================================================================================//
CONCEPT_FUNCTION_IMPL(Twitter_setProxyPassword,2)
    T_HANDLE2(0,twitCurl*)
    twitCurl *inst=PARAM(0);
    T_STRING(1)
    std::string tmp=PARAM(1);

    inst->setProxyPassword(tmp);

    RETURN_NUMBER(0);
END_IMPL
//=====================================================================================//
