#ifndef __LIBRARY_H
#define __LIBRARY_H

// user definition ...

extern "C" {
		CONCEPT_DLL_API ON_CREATE_CONTEXT MANAGEMENT_PARAMETERS;
		CONCEPT_DLL_API ON_DESTROY_CONTEXT MANAGEMENT_PARAMETERS;

        // other functions declared here
        CONCEPT_DLL_API CONCEPT_SessionStart CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_WebVar CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_SessionDestroy CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_ContentType CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_SessionVar CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_SetSessionVar CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_SessionDone CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_GetSessionID CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_SessionTimeout CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_ServerVar CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_SetCookie CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_RemoveCookie CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_CookieVar CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_WebFree CONCEPT_API_PARAMETERS;

        CONCEPT_FUNCTION(_PutString)

        CONCEPT_FUNCTION(_POST)
        CONCEPT_FUNCTION(_GET)
        CONCEPT_FUNCTION(_COOKIE)
        CONCEPT_FUNCTION(_VARS)

		CONCEPT_FUNCTION(SetHeader)

        // events
        //CONCEPT_DLL_API ON_DESTROY_CONTEXT(INTEGER LOAD_ADDR);
}


#endif // __LIBRARY_H
