#ifndef __LIBRARY_H
#define __LIBRARY_H

// user definition ...

extern "C" {
    CONCEPT_DLL_API ON_CREATE_CONTEXT MANAGEMENT_PARAMETERS;
    CONCEPT_DLL_API ON_DESTROY_CONTEXT MANAGEMENT_PARAMETERS;

        // other functions declared here
	CONCEPT_DLL_API CONCEPT__FreeImage_Initialise CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__FreeImage_DeInitialise CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__FreeImage_GetVersion CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__FreeImage_GetCopyrightMessage CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__FreeImage_Allocate CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__FreeImage_AllocateT CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__FreeImage_Load CONCEPT_API_PARAMETERS;
	//CONCEPT_DLL_API CONCEPT__FreeImage_LoadU CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__FreeImage_Save CONCEPT_API_PARAMETERS;
	//CONCEPT_DLL_API CONCEPT__FreeImage_SaveU CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__FreeImage_Unload CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__FreeImage_Clone CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__FreeImage_SetPixelColor CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__FreeImage_GetPixelColor CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__FreeImage_GetImageType CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__FreeImage_GetColorsUsed CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__FreeImage_GetBPP CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__FreeImage_GetWidth CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__FreeImage_GetHeight CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__FreeImage_GetLine CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__FreeImage_GetPitch CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__FreeImage_GetDIBSize CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__FreeImage_GetDotsPerMeterX CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__FreeImage_GetDotsPerMeterY CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__FreeImage_SetDotsPerMeterX CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__FreeImage_SetDotsPerMeterY CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__FreeImage_GetColorType CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__FreeImage_GetRedMask CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__FreeImage_GetGreenMask CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__FreeImage_GetBlueMask CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__FreeImage_GetTransparencyCount CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__FreeImage_SetTransparent CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__FreeImage_IsTransparent CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__FreeImage_GetFileType CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__FreeImage_HasBackgroundColor CONCEPT_API_PARAMETERS;

	CONCEPT_DLL_API CONCEPT__FreeImage_Rescale CONCEPT_API_PARAMETERS;
	CONCEPT_DLL_API CONCEPT__FreeImage_Copy CONCEPT_API_PARAMETERS;
}


#endif // __LIBRARY_H
