//------------ standard header -----------------------------------//
#include "stdlibrary.h"
//------------ end of standard header ----------------------------//
#include "library.h"
//-----------------------------------------------------------------------------------
#ifdef _WIN64
    #define __SIZEOF_POINTER__ 8
#endif

#ifdef __x86_64
    #define __SIZEOF_POINTER__ 8
#endif

#ifdef _M_IA64
    #define __SIZEOF_POINTER__ 8
#endif

#ifdef _LP64
    #define __SIZEOF_POINTER__ 8
#endif

#ifdef __LP64__
    #define __SIZEOF_POINTER__ 8
#endif
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__int8 CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=1)
           return (void *)": '_int8' parameters error. This fuction takes one parameter.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        NUMBER _C_call_result;
        // Specific variables
        NUMBER       nParam0;

        // Variable type check
        // Parameter 1
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &STRING_DUMMY, &nParam0);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"_int8: parameter 1 should be of STATIC NUMBER type";

        // function call
        _C_call_result=(char)nParam0;

        SetVariable(RESULT,VARIABLE_NUMBER,"",_C_call_result);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__int16 CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=1)
           return (void *)": '_int16' parameters error. This fuction takes one parameter.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        NUMBER _C_call_result;
        // Specific variables
        NUMBER       nParam0;

        // Variable type check
        // Parameter 1
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &STRING_DUMMY, &nParam0);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"_int16: parameter 1 should be of STATIC NUMBER type";

        // function call
        _C_call_result=(short int)nParam0;

        SetVariable(RESULT,VARIABLE_NUMBER,"",_C_call_result);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__int32 CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=1)
           return (void *)": '_int32' parameters error. This fuction takes one parameter.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        NUMBER _C_call_result;
        // Specific variables
        NUMBER       nParam0;

        // Variable type check
        // Parameter 1
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &STRING_DUMMY, &nParam0);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"_int32: parameter 1 should be of STATIC NUMBER type";

        // function call
        _C_call_result=(int)nParam0;

        SetVariable(RESULT,VARIABLE_NUMBER,"",_C_call_result);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__float CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=1)
           return (void *)": '_float' parameters error. This fuction takes one parameter.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        NUMBER _C_call_result;
        // Specific variables
        NUMBER       nParam0;

        // Variable type check
        // Parameter 1
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &STRING_DUMMY, &nParam0);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"_float: parameter 1 should be of STATIC NUMBER type";

        // function call
        _C_call_result=(float)nParam0;

        SetVariable(RESULT,VARIABLE_NUMBER,"",_C_call_result);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__int64 CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=1)
           return (void *)": '_int64' parameters error. This fuction takes one parameter.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        NUMBER _C_call_result;
        // Specific variables
        NUMBER       nParam0;

        // Variable type check
        // Parameter 1
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &STRING_DUMMY, &nParam0);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"_int64: parameter 1 should be of STATIC NUMBER type";

        // function call
#if __SIZEOF_POINTER__ == 8
        _C_call_result=(long)nParam0;
#else
        _C_call_result=(long long)nParam0;
#endif

        SetVariable(RESULT,VARIABLE_NUMBER,"",_C_call_result);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__uint8 CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=1)
           return (void *)": '_uint8' parameters error. This fuction takes one parameter.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        NUMBER _C_call_result;
        // Specific variables
        NUMBER       nParam0;

        // Variable type check
        // Parameter 1
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &STRING_DUMMY, &nParam0);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"_uint8: parameter 1 should be of STATIC NUMBER type";

        // function call
        _C_call_result=(unsigned char)nParam0;

        SetVariable(RESULT,VARIABLE_NUMBER,"",_C_call_result);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__uint16 CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=1)
           return (void *)": '_uint16' parameters error. This fuction takes one parameter.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        NUMBER _C_call_result;
        // Specific variables
        NUMBER       nParam0;

        // Variable type check
        // Parameter 1
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &STRING_DUMMY, &nParam0);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"_uint16: parameter 1 should be of STATIC NUMBER type";

        // function call
        _C_call_result=(unsigned short int)nParam0;

        SetVariable(RESULT,VARIABLE_NUMBER,"",_C_call_result);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__uint32 CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=1)
           return (void *)": '_uint32' parameters error. This fuction takes one parameter.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        NUMBER _C_call_result;
        // Specific variables
        NUMBER       nParam0;

        // Variable type check
        // Parameter 1
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &STRING_DUMMY, &nParam0);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"_uint32: parameter 1 should be of STATIC NUMBER type";

        // function call
        _C_call_result=(unsigned int)nParam0;

        SetVariable(RESULT,VARIABLE_NUMBER,"",_C_call_result);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__uint64 CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=1)
           return (void *)": '_uint64' parameters error. This fuction takes one parameter.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        NUMBER _C_call_result;
        // Specific variables
        NUMBER       nParam0;

        // Variable type check
        // Parameter 1
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &STRING_DUMMY, &nParam0);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"_uint64: parameter 1 should be of STATIC NUMBER type";

        // function call
#if __SIZEOF_POINTER__ == 8
        _C_call_result=(unsigned long)nParam0;
#else
        _C_call_result=(unsigned long long)nParam0;
#endif

        SetVariable(RESULT,VARIABLE_NUMBER,"",_C_call_result);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_tobin, 2)
    T_NUMBER(0, _tobin)
    T_NUMBER(1, _tobin)

    char vint8=(char)PARAM_INT(0);
    short int vint16=(short int )PARAM_INT(0);
    int vint32=(int)PARAM_INT(0);
    long long vint64=(long long)PARAM_INT(0);
    switch (PARAM_INT(1)) {
        case 8:
            RETURN_BUFFER((char *)&vint8, sizeof(vint8));
            break;
        case 16:
            RETURN_BUFFER((char *)&vint16, sizeof(vint16));
            break;
        case 32:
            RETURN_BUFFER((char *)&vint32, sizeof(vint32));
            break;
        case 64:
            RETURN_BUFFER((char *)&vint64, sizeof(vint64));
            break;
        default:
            RETURN_STRING("");
            return (void*)"_tobin: bits must be 8, 16, 32, 64";
            break;
    }
END_IMPL
//-----------------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_toubin, 2)
    T_NUMBER(0, _toubin)
    T_NUMBER(1, _toubin)

    unsigned char vint8=(unsigned char)PARAM_INT(0);
    unsigned short int vint16=(unsigned short int )PARAM_INT(0);
    unsigned int vint32=(unsigned int)PARAM_INT(0);
    unsigned long long vint64=(unsigned long long)PARAM_INT(0);
    switch (PARAM_INT(1)) {
        case 8:
            RETURN_BUFFER((char *)&vint8, sizeof(vint8));
            break;
        case 16:
            RETURN_BUFFER((char *)&vint16, sizeof(vint16));
            break;
        case 32:
            RETURN_BUFFER((char *)&vint32, sizeof(vint32));
            break;
        case 64:
            RETURN_BUFFER((char *)&vint64, sizeof(vint64));
            break;
        default:
            RETURN_STRING("");
            return (void*)"_toubin: bits must be 8, 16, 32, 64";
            break;
    }
END_IMPL
//-----------------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_tounumber, 2)
    T_STRING(0, _tounumber)
    T_NUMBER(1, _tounumber)
    switch (PARAM_INT(1)) {
        case 8: 
            {
                if (PARAM_LEN(0)<sizeof(char))
                    return (void *)"_tounumber: invalid buffer size (must be at least 1)";

                RETURN_NUMBER(*(unsigned char *)PARAM(0))
            }
            break;
        case 16: 
            {
                if (PARAM_LEN(0)<sizeof(short int))
                    return (void *)"_tounumber: invalid buffer size (must be at least 2)";

                RETURN_NUMBER(*(unsigned short int *)PARAM(0))
            }
            break;
        case 32: 
            {
                if (PARAM_LEN(0)<sizeof(int))
                    return (void *)"_tounumber: invalid buffer size (must be at least 4)";

                RETURN_NUMBER(*(unsigned int *)PARAM(0))
            }
            break;
        case 64: 
            {
                if (PARAM_LEN(0)<sizeof(long long))
                    return (void *)"_tounumber: invalid buffer size (must be at least 8)";

                RETURN_NUMBER(*(unsigned long long *)PARAM(0))
            }
            break;
        default:
            RETURN_NUMBER(0);
            return (void*)"_tounumber: bits must be 8, 16, 32, 64";
            break;
    }
END_IMPL
//-----------------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(_tonumber, 2)
    T_STRING(0, _tonumber)
    T_NUMBER(1, _tonumber)
    switch (PARAM_INT(1)) {
        case 8: 
            {
                if (PARAM_LEN(0)<sizeof(char))
                    return (void *)"_tonumber: invalid buffer size (must be at least 1)";

                RETURN_NUMBER(*(char *)PARAM(0))
            }
            break;
        case 16: 
            {
                if (PARAM_LEN(0)<sizeof(short int))
                    return (void *)"_tonumber: invalid buffer size (must be at least 2)";

                RETURN_NUMBER(*(short int *)PARAM(0))
            }
            break;
        case 32: 
            {
                if (PARAM_LEN(0)<sizeof(int))
                    return (void *)"_tonumber: invalid buffer size (must be at least 4)";

                RETURN_NUMBER(*(int *)PARAM(0))
            }
            break;
        case 64: 
            {
                if (PARAM_LEN(0)<sizeof(long long))
                    return (void *)"_tonumber: invalid buffer size (must be at least 8)";

                RETURN_NUMBER(*(long long *)PARAM(0))
            }
            break;
        default:
            RETURN_NUMBER(0);
            return (void*)"_tonumber: bits must be 8, 16, 32, 64";
            break;
    }
END_IMPL
//-----------------------------------------------------------------------------------
