//------------ standard header -----------------------------------//
#include "stdlibrary.h"
//------------ end of standard header ----------------------------//
#include "library.h"
#include "AnsiString.h"
#include <time.h>
#include <locale.h>
//---------------------------------------------------------------------------
INVOKE_CALL InvokePtr=0;
//---------------------------------------------------------------------------
void Get_TM(void *arr, struct tm *mytime) {
    INTEGER type=0;
    char *str=0;
    NUMBER nr=0;

    if (!InvokePtr)
        return;

    InvokePtr(INVOKE_GET_ARRAY_ELEMENT_BY_KEY, arr, "tm_hour", &type, &str, &nr);
    if (type==VARIABLE_NUMBER)
        mytime->tm_hour=nr;
    else
        mytime->tm_hour=0;

    InvokePtr(INVOKE_GET_ARRAY_ELEMENT_BY_KEY, arr, "tm_isdst", &type, &str, &nr);
    if (type==VARIABLE_NUMBER)
        mytime->tm_isdst=nr;
    else
        mytime->tm_isdst=0;

    InvokePtr(INVOKE_GET_ARRAY_ELEMENT_BY_KEY, arr, "tm_mday", &type, &str, &nr);
    if (type==VARIABLE_NUMBER)
        mytime->tm_mday=nr;

    InvokePtr(INVOKE_GET_ARRAY_ELEMENT_BY_KEY, arr, "tm_min", &type, &str, &nr);
    if (type==VARIABLE_NUMBER)
        mytime->tm_min=nr;
    else
        mytime->tm_min=0;

    InvokePtr(INVOKE_GET_ARRAY_ELEMENT_BY_KEY, arr, "tm_mon", &type, &str, &nr);
    if (type==VARIABLE_NUMBER)
        mytime->tm_mon=nr;
    else
        mytime->tm_mon=0;

    InvokePtr(INVOKE_GET_ARRAY_ELEMENT_BY_KEY, arr, "tm_sec", &type, &str, &nr);
    if (type==VARIABLE_NUMBER)
        mytime->tm_sec=nr;
    else
        mytime->tm_sec=0;

    InvokePtr(INVOKE_GET_ARRAY_ELEMENT_BY_KEY, arr, "tm_wday", &type, &str, &nr);
    if (type==VARIABLE_NUMBER)
        mytime->tm_wday=nr;
    else
        mytime->tm_wday=0;

    InvokePtr(INVOKE_GET_ARRAY_ELEMENT_BY_KEY, arr, "tm_yday", &type, &str, &nr);
    if (type==VARIABLE_NUMBER)
        mytime->tm_yday=nr;
    else
        mytime->tm_yday=0;

    InvokePtr(INVOKE_GET_ARRAY_ELEMENT_BY_KEY, arr, "tm_year", &type, &str, &nr);
    if (type==VARIABLE_NUMBER)
        mytime->tm_year=nr;
    else
        mytime->tm_year=0;
}
//---------------------------------------------------------------------------
CONCEPT_DLL_API ON_CREATE_CONTEXT MANAGEMENT_PARAMETERS {
    InvokePtr=Invoke;

	DEFINE_ECONSTANT(CLOCKS_PER_SEC)
	DEFINE_ECONSTANT(LC_ALL)
	DEFINE_ECONSTANT(LC_COLLATE)
	DEFINE_ECONSTANT(LC_CTYPE)
	DEFINE_ECONSTANT(LC_MONETARY)
	DEFINE_ECONSTANT(LC_NUMERIC)
	DEFINE_ECONSTANT(LC_TIME)

    return 0;
}
//---------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__clock CONCEPT_API_PARAMETERS {
    if (PARAMETERS->COUNT!=0)
        return (void *)"clock() takes no parameters";

    SetVariable(RESULT,VARIABLE_NUMBER,"",(INTEGER)clock());
    return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__asctime CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=1)
           return (void *)": 'asctime' parameters error. This fuction takes one parameter.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        char*	_C_call_result;
        // Specific variables
        NUMBER       nParam0;

        // Variable type check
        // Parameter 1
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &STRING_DUMMY, &nParam0);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"asctime: parameter 1 should be of STATIC NUMBER type";

        // function call
        time_t timevar=(time_t)nParam0;
        struct tm *ptm=gmtime(&timevar);
        _C_call_result=(char*)asctime(ptm);

        SetVariable(RESULT,VARIABLE_STRING,_C_call_result,0);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__ctime CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=1)
           return (void *)": 'ctime' parameters error. This fuction takes one parameter.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        char*	_C_call_result;
        // Specific variables
        NUMBER       nParam0;

        // Variable type check
        // Parameter 1
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &STRING_DUMMY, &nParam0);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"ctime: parameter 1 should be of STATIC NUMBER type";

        // function call
        time_t tempp=(time_t)nParam0;
        _C_call_result=(char*)ctime(&tempp);

        SetVariable(RESULT,VARIABLE_STRING,_C_call_result,0);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__difftime CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=2)
           return (void *)": 'difftime' parameters error. This fuction takes 2 parameters.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        double	_C_call_result;
        // Specific variables
        NUMBER       nParam0;
        NUMBER       nParam1;

        // Variable type check
        // Parameter 1
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &STRING_DUMMY, &nParam0);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"difftime: parameter 1 should be of STATIC NUMBER type";
        // Parameter 2
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[1]-1], &TYPE, &STRING_DUMMY, &nParam1);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"difftime: parameter 2 should be of STATIC NUMBER type";

        // function call
        _C_call_result=(double)difftime((time_t)nParam0, (time_t)nParam1);

        SetVariable(RESULT,VARIABLE_NUMBER,"",_C_call_result);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__localtime CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=1)
           return (void *)": 'localtime' parameters error. This fuction takes one parameter.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        time_t	_C_call_result;
        // Specific variables
        NUMBER       nParam0;

        // Variable type check
        // Parameter 1
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &STRING_DUMMY, &nParam0);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"localtime: parameter 1 should be of STATIC NUMBER type";

        // function call
        time_t tempp=(time_t)nParam0;
        struct tm * timeinfo;

        timeinfo=localtime(&tempp);

        if (!IS_OK(Invoke(INVOKE_CREATE_ARRAY,RESULT)))
           return (void *)"Failed to INVOKE_CREATE_ARRAY";

        Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"tm_hour",(INTEGER)VARIABLE_NUMBER,(char*)0,(double)timeinfo->tm_hour);
        Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"tm_isdst",(INTEGER)VARIABLE_NUMBER,(char*)0,(double)timeinfo->tm_isdst);
        Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"tm_mday",(INTEGER)VARIABLE_NUMBER,(char*)0,(double)timeinfo->tm_mday);
        Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"tm_min",(INTEGER)VARIABLE_NUMBER,(char*)0,(double)timeinfo->tm_min);
        Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"tm_mon",(INTEGER)VARIABLE_NUMBER,(char*)0,(double)timeinfo->tm_mon);
        Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"tm_sec",(INTEGER)VARIABLE_NUMBER,(char*)0,(double)timeinfo->tm_sec);
        Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"tm_wday",(INTEGER)VARIABLE_NUMBER,(char*)0,(double)timeinfo->tm_wday);
        Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"tm_yday",(INTEGER)VARIABLE_NUMBER,(char*)0,(double)timeinfo->tm_yday);
        Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"tm_year",(INTEGER)VARIABLE_NUMBER,(char*)0,(double)timeinfo->tm_year);

        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__gmtime CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=1)
           return (void *)": 'gmtime' parameters error. This fuction takes one parameter.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        time_t	_C_call_result;
        // Specific variables
        NUMBER       nParam0;

        // Variable type check
        // Parameter 1
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &STRING_DUMMY, &nParam0);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"gmtime: parameter 1 should be of STATIC NUMBER type";

        // function call
        time_t tempp=(time_t)nParam0;
        struct tm * timeinfo;

        timeinfo=gmtime(&tempp);

        if (!IS_OK(Invoke(INVOKE_CREATE_ARRAY,RESULT)))
           return (void *)"Failed to INVOKE_CREATE_ARRAY";

        Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"tm_hour",(INTEGER)VARIABLE_NUMBER,(char*)0,(double)timeinfo->tm_hour);
        Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"tm_isdst",(INTEGER)VARIABLE_NUMBER,(char*)0,(double)timeinfo->tm_isdst);
        Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"tm_mday",(INTEGER)VARIABLE_NUMBER,(char*)0,(double)timeinfo->tm_mday);
        Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"tm_min",(INTEGER)VARIABLE_NUMBER,(char*)0,(double)timeinfo->tm_min);
        Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"tm_mon",(INTEGER)VARIABLE_NUMBER,(char*)0,(double)timeinfo->tm_mon);
        Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"tm_sec",(INTEGER)VARIABLE_NUMBER,(char*)0,(double)timeinfo->tm_sec);
        Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"tm_wday",(INTEGER)VARIABLE_NUMBER,(char*)0,(double)timeinfo->tm_wday);
        Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"tm_yday",(INTEGER)VARIABLE_NUMBER,(char*)0,(double)timeinfo->tm_yday);
        Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"tm_year",(INTEGER)VARIABLE_NUMBER,(char*)0,(double)timeinfo->tm_year);

        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__time CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=0)
           return (void *)": 'time' parameters error. This fuction takes  no parameters.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        time_t	_C_call_result;
        // Specific variables

        // Variable type check

        // function call
        _C_call_result=(time_t)time(NULL);

        SetVariable(RESULT,VARIABLE_NUMBER,"",_C_call_result);
        return 0;
}
//---------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__mktime CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=1)
           return (void *)": 'mktime' parameters error. This fuction takes one parameter.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        time_t	_C_call_result;
        // Specific variables
        NUMBER       nParam0;

        // Variable type check
        // Parameter 1
        VariableDATA *param=LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1];
        GetVariable(param, &TYPE, &STRING_DUMMY, &nParam0);

        if (TYPE!=VARIABLE_ARRAY)
           return (void *)"mktime: parameter 1 should be of ARRAY type";

        // function call
        struct tm timeinfo;

        Get_TM(param, &timeinfo);

        time_t tempp=mktime(&timeinfo);

        if (!IS_OK(Invoke(INVOKE_CREATE_ARRAY,param)))
           return (void *)"Failed to INVOKE_CREATE_ARRAY";

        Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,param,"tm_hour",(INTEGER)VARIABLE_NUMBER,(char*)0,(double)timeinfo.tm_hour);
        Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,param,"tm_isdst",(INTEGER)VARIABLE_NUMBER,(char*)0,(double)timeinfo.tm_isdst);
        Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,param,"tm_mday",(INTEGER)VARIABLE_NUMBER,(char*)0,(double)timeinfo.tm_mday);
        Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,param,"tm_min",(INTEGER)VARIABLE_NUMBER,(char*)0,(double)timeinfo.tm_min);
        Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,param,"tm_mon",(INTEGER)VARIABLE_NUMBER,(char*)0,(double)timeinfo.tm_mon);
        Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,param,"tm_sec",(INTEGER)VARIABLE_NUMBER,(char*)0,(double)timeinfo.tm_sec);
        Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,param,"tm_wday",(INTEGER)VARIABLE_NUMBER,(char*)0,(double)timeinfo.tm_wday);
        Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,param,"tm_yday",(INTEGER)VARIABLE_NUMBER,(char*)0,(double)timeinfo.tm_yday);
        Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,param,"tm_year",(INTEGER)VARIABLE_NUMBER,(char*)0,(double)timeinfo.tm_year);

        RETURN_NUMBER(tempp);
        return 0;
}
//-----------------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(setlocale,2)
    T_NUMBER(0)
    T_STRING(1)

    RETURN_STRING(setlocale(PARAM_INT(0),PARAM(1)))
END_IMPL
//-----------------------------------------------------------------------------------
CONCEPT_FUNCTION_IMPL(localeconv,0)

    if (!IS_OK(Invoke(INVOKE_CREATE_ARRAY,RESULT)))
        return (void *)"Failed to INVOKE_CREATE_ARRAY";

    struct lconv * lc=localeconv();
    if (!lc)
        return 0;

    Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"decimal_point",(INTEGER)VARIABLE_STRING,lc->decimal_point,(NUMBER)0);
    Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"thousands_sep",(INTEGER)VARIABLE_STRING,lc->thousands_sep,(NUMBER)0);
    Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"thousands_sep",(INTEGER)VARIABLE_STRING,lc->thousands_sep,(NUMBER)0);

    AnsiString grouping;
    for (int i=0;i<0xFF;i++) {
        char c=lc->grouping[i];
        if (!c)
            break;

        if (i)
            grouping+=",";

        grouping+=AnsiString((long)c);
    }
    Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"grouping",(INTEGER)VARIABLE_STRING,grouping.c_str(),(NUMBER)0);
    Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"int_curr_symbol",(INTEGER)VARIABLE_STRING,lc->int_curr_symbol,(NUMBER)0);
    Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"currency_symbol",(INTEGER)VARIABLE_STRING,lc->currency_symbol,(NUMBER)0);
    Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"mon_decimal_point",(INTEGER)VARIABLE_STRING,lc->mon_decimal_point,(NUMBER)0);
    Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"mon_thousands_sep",(INTEGER)VARIABLE_STRING,lc->mon_thousands_sep,(NUMBER)0);

    grouping=(char *)"";
    for (int i=0;i<0xFF;i++) {
        char c=lc->mon_grouping[i];
        if (!c)
            break;

        if (i)
            grouping+=",";

        grouping+=AnsiString((long)c);
    }

    Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"mon_grouping",(INTEGER)VARIABLE_STRING,grouping.c_str(),(NUMBER)0);
    Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"positive_sign",(INTEGER)VARIABLE_STRING,lc->positive_sign,(NUMBER)0);
    Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"negative_sign",(INTEGER)VARIABLE_STRING,lc->negative_sign,(NUMBER)0);

    Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"int_frac_digits",(INTEGER)VARIABLE_NUMBER,(char *)0,(NUMBER)lc->int_frac_digits);
    Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"frac_digits",(INTEGER)VARIABLE_NUMBER,(char *)0,(NUMBER)lc->frac_digits);
    Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"p_cs_precedes",(INTEGER)VARIABLE_NUMBER,(char *)0,(NUMBER)lc->p_cs_precedes);
    Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"p_sep_by_space",(INTEGER)VARIABLE_NUMBER,(char *)0,(NUMBER)lc->p_sep_by_space);
    Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"n_cs_precedes",(INTEGER)VARIABLE_NUMBER,(char *)0,(NUMBER)lc->n_cs_precedes);
    Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"n_sep_by_space",(INTEGER)VARIABLE_NUMBER,(char *)0,(NUMBER)lc->n_sep_by_space);
    Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"p_sign_posn",(INTEGER)VARIABLE_NUMBER,(char *)0,(NUMBER)lc->p_sign_posn);
    Invoke(INVOKE_SET_ARRAY_ELEMENT_BY_KEY,RESULT,"n_sign_posn",(INTEGER)VARIABLE_NUMBER,(char *)0,(NUMBER)lc->n_sign_posn);
END_IMPL
//-----------------------------------------------------------------------------------
CONCEPT_DLL_API CONCEPT__slocaltime CONCEPT_API_PARAMETERS {
        if (PARAMETERS->COUNT!=1)
           return (void *)": 'localtime' parameters error. This fuction takes one parameter.";

        // General variables
        NUMBER       NUMBER_DUMMY;
        char *       STRING_DUMMY;
        INTEGER      TYPE;

        // Result
        time_t	_C_call_result;
        // Specific variables
        NUMBER       nParam0;

        // Variable type check
        // Parameter 1
        GetVariable(LOCAL_CONTEXT[PARAMETERS->PARAM_INDEX[0]-1], &TYPE, &STRING_DUMMY, &nParam0);
        if (TYPE!=VARIABLE_NUMBER)
           return (void *)"localtime: parameter 1 should be of STATIC NUMBER type";

        // function call
        time_t tempp=(time_t)nParam0;
        struct tm * timeinfo;

        timeinfo=localtime(&tempp);

        char buffer [80];
        strftime (buffer,80,"%c",timeinfo);

        SetVariable(RESULT,VARIABLE_STRING,buffer,0);
        return 0;
}
//-----------------------------------------------------------------------------------
