#ifndef __LIBRARY_H
#define __LIBRARY_H

#include "stdlibrary.h"

extern "C" {
    CONCEPT_DLL_API ON_CREATE_CONTEXT MANAGEMENT_PARAMETERS;
    CONCEPT_DLL_API ON_DESTROY_CONTEXT MANAGEMENT_PARAMETERS;

    CONCEPT_FUNCTION(PQConnect)
    CONCEPT_FUNCTION(PQLogin)
    CONCEPT_FUNCTION(PQDisconnect)
    CONCEPT_FUNCTION(PQError)
    CONCEPT_FUNCTION(PQQueryError)
    CONCEPT_FUNCTION(PQQuery)
    CONCEPT_FUNCTION(PQQueryParams)
    CONCEPT_FUNCTION(PQFreeResult)
    CONCEPT_FUNCTION(PQCountColumns)
    CONCEPT_FUNCTION(PQCountRows)
    CONCEPT_FUNCTION(PQAffectedRows)
    CONCEPT_FUNCTION(PQDescribeCol)
    CONCEPT_FUNCTION(PQIsNull)
    CONCEPT_FUNCTION(PQLength)
    CONCEPT_FUNCTION(PQGetValue)
    CONCEPT_FUNCTION(PQTable)
    CONCEPT_FUNCTION(PQTableCol)
    CONCEPT_FUNCTION(PQEscape)

    CONCEPT_FUNCTION(PQEncryptPassword)

    CONCEPT_FUNCTION(lo_open)
    CONCEPT_FUNCTION(lo_close)
    CONCEPT_FUNCTION(lo_read)
    CONCEPT_FUNCTION(lo_write)
    CONCEPT_FUNCTION(lo_lseek)
    CONCEPT_FUNCTION(lo_creat)
    CONCEPT_FUNCTION(lo_create)
    CONCEPT_FUNCTION(lo_tell)
    CONCEPT_FUNCTION(lo_truncate)
    CONCEPT_FUNCTION(lo_unlink)
    CONCEPT_FUNCTION(lo_import)
    CONCEPT_FUNCTION(lo_import_with_oid)
    CONCEPT_FUNCTION(lo_export)
}


#endif // __LIBRARY_H
