#ifndef __LIBRARY_H
#define __LIBRARY_H

#include "stdlibrary.h"

#define ERR_ENVIROMENT          "Cannot create ODBC enviroment"
#define ERR_FREE_ENVIROMENT     "Error freeing ODBC enviroment"

extern "C" {
        CONCEPT_DLL_API ON_CREATE_CONTEXT           (INTEGER LOAD_ADDR);
        CONCEPT_DLL_API ON_DESTROY_CONTEXT          (INTEGER LOAD_ADDR);

        CONCEPT_DLL_API CONCEPT_ODBCConnect                 CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_ODBCDriverConnect           CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_ODBCDisconnect              CONCEPT_API_PARAMETERS;

        CONCEPT_DLL_API CONCEPT_ODBCFirstDSN                CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_ODBCNextDSN                 CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_ODBCDriver                  CONCEPT_API_PARAMETERS;

        CONCEPT_DLL_API CONCEPT_ODBCAutoCommit              CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_ODBCCommit                  CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_ODBCRollback                CONCEPT_API_PARAMETERS;

        CONCEPT_DLL_API CONCEPT_ODBCListTables              CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_ODBCListColumns             CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_ODBCListTypes               CONCEPT_API_PARAMETERS;

        CONCEPT_DLL_API CONCEPT_ODBCStatement               CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_ODBCExecute                 CONCEPT_API_PARAMETERS;

        CONCEPT_DLL_API CONCEPT_ODBCAddParameter            CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_ODBCClearParameters         CONCEPT_API_PARAMETERS;

        CONCEPT_DLL_API CONCEPT_ODBCExecuteQuery            CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_ODBCFreeQuery               CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_ODBCDescribeCol             CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_ODBCCountColumns            CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_ODBCCountRows               CONCEPT_API_PARAMETERS;

        CONCEPT_DLL_API CONCEPT_ODBCBindResult              CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_ODBCFreeResult              CONCEPT_API_PARAMETERS;

        CONCEPT_DLL_API CONCEPT_ODBCFetchFirst              CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_ODBCFetchLast               CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_ODBCFetchPrior              CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_ODBCFetchNext               CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_ODBCFetchAbsolute           CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_ODBCPosition                CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_ODBCSkip                    CONCEPT_API_PARAMETERS;

        CONCEPT_DLL_API CONCEPT_ODBCFetchForward            CONCEPT_API_PARAMETERS;

        CONCEPT_DLL_API CONCEPT_ODBCLock                    CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_ODBCUnlock                  CONCEPT_API_PARAMETERS;

        CONCEPT_DLL_API CONCEPT_ODBCColumnGet               CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_ODBCColumnSet               CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_ODBCUpdate                  CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_ODBCDelete                  CONCEPT_API_PARAMETERS;

        CONCEPT_DLL_API CONCEPT_ODBCError                   CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_ODBCWarning                 CONCEPT_API_PARAMETERS;
}


#endif // __LIBRARY_H
