#ifndef __LIBRARY_H
#define __LIBRARY_H

#include "stdlibrary.h"

extern "C" {
	CONCEPT_DLL_API ON_CREATE_CONTEXT MANAGEMENT_PARAMETERS;
	CONCEPT_DLL_API ON_DESTROY_CONTEXT MANAGEMENT_PARAMETERS;

	CONCEPT_FUNCTION(DBOpen)
	CONCEPT_FUNCTION(DBClose)
	CONCEPT_FUNCTION(DBError)
	CONCEPT_FUNCTION(DBErrorCode)
	CONCEPT_FUNCTION(DBChanges)
	CONCEPT_FUNCTION(DBLastRowID)
	CONCEPT_FUNCTION(DBNewStmt)
	CONCEPT_FUNCTION(DBBind)
	CONCEPT_FUNCTION(DBNameBind)

	CONCEPT_FUNCTION(DBBLOBBind)
	CONCEPT_FUNCTION(DBBLOBNameBind)

	CONCEPT_FUNCTION(DBFree)
	CONCEPT_FUNCTION(DBColumns)
	CONCEPT_FUNCTION(DBFirst)
	CONCEPT_FUNCTION(DBNext)
	CONCEPT_FUNCTION(DBData)
	CONCEPT_FUNCTION(DBDataRead)
	CONCEPT_FUNCTION(DBDataWrite)
	CONCEPT_FUNCTION(DBQuery)
	CONCEPT_FUNCTION(DBReset)
	CONCEPT_FUNCTION(DBClearBindings)
	CONCEPT_FUNCTION(DBColumnDeclType)
	CONCEPT_FUNCTION(DBColumnName)
	CONCEPT_FUNCTION(DBColumnType)
	CONCEPT_FUNCTION(DBWrap)
    CONCEPT_FUNCTION(DBParamCount)
    CONCEPT_FUNCTION(DBBLOBDataBind)
    CONCEPT_FUNCTION(DBBLOBNameDataBind)
}


#endif // __LIBRARY_H
