#ifndef __LIBRARY_H
#define __LIBRARY_H

// user definition ...

extern "C" {
        CONCEPT_DLL_API ON_CREATE_CONTEXT MANAGEMENT_PARAMETERS;
        CONCEPT_DLL_API ON_DESTROY_CONTEXT MANAGEMENT_PARAMETERS;


        // other functions declared here
        CONCEPT_DLL_API CONCEPT_SerializeObject CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_UnSerializeObject CONCEPT_API_PARAMETERS;

        CONCEPT_DLL_API CONCEPT_HasMember CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_SetMember CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_GetMember CONCEPT_API_PARAMETERS;

        CONCEPT_DLL_API CONCEPT_ObjectLinks CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_StaticLinks CONCEPT_API_PARAMETERS;

        CONCEPT_DLL_API CONCEPT__ASSERT CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT__ClsPtr CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT__VarPtr CONCEPT_API_PARAMETERS;

        CONCEPT_DLL_API CONCEPT__KeySorted CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT__IsSet CONCEPT_API_PARAMETERS;

        CONCEPT_DLL_API CONCEPT__GetKeys CONCEPT_API_PARAMETERS;

        CONCEPT_FUNCTION(SerializeError)

        CONCEPT_FUNCTION(ToXML)
}


#endif // __LIBRARY_H
