#ifndef __LIBRARY_H
#define __LIBRARY_H

#include "stdlibrary.h"

extern "C" {
	CONCEPT_DLL_API ON_CREATE_CONTEXT MANAGEMENT_PARAMETERS;
	CONCEPT_DLL_API ON_DESTROY_CONTEXT MANAGEMENT_PARAMETERS;

    CONCEPT_FUNCTION(_GDCPIE_BGColor)
    CONCEPT_FUNCTION(_GDCPIE_PlotColor)
    CONCEPT_FUNCTION(_GDCPIE_LineColor)
    CONCEPT_FUNCTION(_GDCPIE_EdgeColor)
    CONCEPT_FUNCTION(_GDCPIE_other_threshold)
    CONCEPT_FUNCTION(_GDCPIE_3d_angle)
    CONCEPT_FUNCTION(_GDCPIE_3d_depth)
    CONCEPT_FUNCTION(_GDCPIE_label_dist)
    CONCEPT_FUNCTION(_GDCPIE_title)
    CONCEPT_FUNCTION(_GDCPIE_label_line)
    CONCEPT_FUNCTION(_GDCPIE_title_size)
    CONCEPT_FUNCTION(_GDCPIE_label_size)
    CONCEPT_FUNCTION(_GDCPIE_percent_labels)
    CONCEPT_FUNCTION(_GDCPIE_explode)
    CONCEPT_FUNCTION(_GDCPIE_Color) 
    CONCEPT_FUNCTION(_GDCPIE_missing)


    CONCEPT_FUNCTION(_GDC_ytitle)
    CONCEPT_FUNCTION(_GDC_xtitle)
    CONCEPT_FUNCTION(_GDC_ytitle2)
    CONCEPT_FUNCTION(_GDC_title)
    CONCEPT_FUNCTION(_GDC_title_size)
    CONCEPT_FUNCTION(_GDC_xtitle_size)
    CONCEPT_FUNCTION(_GDC_ytitle_size)
    CONCEPT_FUNCTION(_GDC_yaxisfont_size)
    CONCEPT_FUNCTION(_GDC_xaxisfont_size)
    CONCEPT_FUNCTION(_GDC_ylabel_fmt)
    CONCEPT_FUNCTION(_GDC_ylabel2_fmt)
    CONCEPT_FUNCTION(_GDC_xlabel_spacing)
    CONCEPT_FUNCTION(_GDC_ylabel_density)
    CONCEPT_FUNCTION(_GDC_requested_ymin)
    CONCEPT_FUNCTION(_GDC_requested_ymax)
    CONCEPT_FUNCTION(_GDC_requested_yinterval)
    CONCEPT_FUNCTION(_GDC_0Shelf)
    CONCEPT_FUNCTION(_GDC_grid)
    CONCEPT_FUNCTION(_GDC_xaxis)
    CONCEPT_FUNCTION(_GDC_yaxis)
    CONCEPT_FUNCTION(_GDC_xaxis_angle)
    CONCEPT_FUNCTION(_GDC_yaxis2)
    CONCEPT_FUNCTION(_GDC_yval_style)
    CONCEPT_FUNCTION(_GDC_stack_type)
    CONCEPT_FUNCTION(_GDC_3d_depth)
    CONCEPT_FUNCTION(_GDC_3d_angle)
    CONCEPT_FUNCTION(_GDC_bar_width)
    CONCEPT_FUNCTION(_GDC_HLC_style)
    CONCEPT_FUNCTION(_GDC_HLC_cap_width)
    CONCEPT_FUNCTION(_GDC_annotation_font)
    CONCEPT_FUNCTION(_GDC_annotation_ptsize)
    CONCEPT_FUNCTION(_GDC_num_scatter_pts)
    CONCEPT_FUNCTION(_GDC_thumbnail)
    CONCEPT_FUNCTION(_GDC_thumblabel)
    CONCEPT_FUNCTION(_GDC_thumbval)
    CONCEPT_FUNCTION(_GDC_border)
    CONCEPT_FUNCTION(_GDC_BGColor)
    CONCEPT_FUNCTION(_GDC_GridColor)
    CONCEPT_FUNCTION(_GDC_LineColor)
    CONCEPT_FUNCTION(_GDC_PlotColor)
    CONCEPT_FUNCTION(_GDC_VolColor)
    CONCEPT_FUNCTION(_GDC_TitleColor)
    CONCEPT_FUNCTION(_GDC_XTitleColor)
    CONCEPT_FUNCTION(_GDC_YTitleColor)
    CONCEPT_FUNCTION(_GDC_YTitle2Color)
    CONCEPT_FUNCTION(_GDC_XLabelColor)
    CONCEPT_FUNCTION(_GDC_YLabelColor)
    CONCEPT_FUNCTION(_GDC_YLabel2Color)
    CONCEPT_FUNCTION(_GDC_ExtVolColor) 
    CONCEPT_FUNCTION(_GDC_SetColor) 
    CONCEPT_FUNCTION(_GDC_ExtColor) 
    CONCEPT_FUNCTION(_GDC_transparent_bg)

    CONCEPT_FUNCTION(_GDC_title_font)
    CONCEPT_FUNCTION(_GDC_ytitle_font)
    CONCEPT_FUNCTION(_GDC_xtitle_font)
    CONCEPT_FUNCTION(_GDC_yaxis_font)
    CONCEPT_FUNCTION(_GDC_xaxis_font)

    CONCEPT_FUNCTION(_GDC_title_ptsize)
    CONCEPT_FUNCTION(_GDC_ytitle_ptsize)
    CONCEPT_FUNCTION(_GDC_xtitle_ptsize)
    CONCEPT_FUNCTION(_GDC_yaxis_ptsize)
    CONCEPT_FUNCTION(_GDC_xaxis_ptsize)

    CONCEPT_FUNCTION(_GDCPIE_title_font)
    CONCEPT_FUNCTION(_GDCPIE_label_font)
    CONCEPT_FUNCTION(_GDCPIE_title_ptsize)
    CONCEPT_FUNCTION(_GDCPIE_label_ptsize)

    CONCEPT_FUNCTION(_GDC_image_type)

	CONCEPT_FUNCTION(_pie_gif)
	CONCEPT_FUNCTION(_out_graph)
	CONCEPT_FUNCTION(_out_err)
}


#endif // __LIBRARY_H
