#include "stdlibrary.h"

extern "C" {
    CONCEPT_DLL_API ON_CREATE_CONTEXT MANAGEMENT_PARAMETERS;
    CONCEPT_DLL_API ON_DESTROY_CONTEXT MANAGEMENT_PARAMETERS;

    CONCEPT_FUNCTION(GeoIP_setup_custom_directory)
    CONCEPT_FUNCTION(GeoIP_open_type)
    CONCEPT_FUNCTION(GeoIP_new)
    CONCEPT_FUNCTION(GeoIP_open)
    CONCEPT_FUNCTION(GeoIP_db_avail)
    CONCEPT_FUNCTION(GeoIP_delete)
    CONCEPT_FUNCTION(GeoIP_country_code_by_addr)
    CONCEPT_FUNCTION(GeoIP_country_code_by_name)
    CONCEPT_FUNCTION(GeoIP_country_code3_by_addr)
    CONCEPT_FUNCTION(GeoIP_country_code3_by_name)
    CONCEPT_FUNCTION(GeoIP_country_name_by_addr)
    CONCEPT_FUNCTION(GeoIP_country_name_by_name)
    CONCEPT_FUNCTION(GeoIP_country_name_by_ipnum)
    CONCEPT_FUNCTION(GeoIP_country_code_by_ipnum)
    CONCEPT_FUNCTION(GeoIP_country_code3_by_ipnum)
    CONCEPT_FUNCTION(GeoIP_country_name_by_ipnum_v6)
    CONCEPT_FUNCTION(GeoIP_country_code_by_ipnum_v6)
    CONCEPT_FUNCTION(GeoIP_country_code3_by_ipnum_v6)
    CONCEPT_FUNCTION(GeoIP_id_by_addr)
    CONCEPT_FUNCTION(GeoIP_id_by_name)
    CONCEPT_FUNCTION(GeoIP_id_by_ipnum)
    CONCEPT_FUNCTION(GeoIP_id_by_addr_v6)
    CONCEPT_FUNCTION(GeoIP_id_by_name_v6)
    CONCEPT_FUNCTION(GeoIP_id_by_ipnum_v6)
    CONCEPT_FUNCTION(GeoIP_region_by_addr)
    CONCEPT_FUNCTION(GeoIP_region_by_name)
    CONCEPT_FUNCTION(GeoIP_region_by_ipnum)
    CONCEPT_FUNCTION(GeoIP_region_by_addr_v6)
    CONCEPT_FUNCTION(GeoIP_region_by_name_v6)
    CONCEPT_FUNCTION(GeoIP_region_by_ipnum_v6)
    //CONCEPT_FUNCTION(GeoIP_assign_region_by_inetaddr)
    //CONCEPT_FUNCTION(GeoIP_assign_region_by_inetaddr_v6)
    CONCEPT_FUNCTION(GeoIP_name_by_ipnum)
    CONCEPT_FUNCTION(GeoIP_name_by_addr)
    CONCEPT_FUNCTION(GeoIP_name_by_name)
    CONCEPT_FUNCTION(GeoIP_name_by_ipnum_v6)
    CONCEPT_FUNCTION(GeoIP_name_by_addr_v6)
    CONCEPT_FUNCTION(GeoIP_name_by_name_v6)
    CONCEPT_FUNCTION(GeoIP_code_by_id)
    CONCEPT_FUNCTION(GeoIP_code3_by_id)
    CONCEPT_FUNCTION(GeoIP_name_by_id)
    CONCEPT_FUNCTION(GeoIP_continent_by_id)
    CONCEPT_FUNCTION(GeoIP_id_by_code)
    CONCEPT_FUNCTION(GeoIP_num_countries)
    CONCEPT_FUNCTION(GeoIP_database_info)
    CONCEPT_FUNCTION(GeoIP_database_edition)
    CONCEPT_FUNCTION(GeoIP_charset)
    CONCEPT_FUNCTION(GeoIP_set_charset)
    CONCEPT_FUNCTION(GeoIP_last_netmask)
    CONCEPT_FUNCTION(GeoIP_region_name_by_code)
    CONCEPT_FUNCTION(GeoIP_time_zone_by_country_and_region)
    CONCEPT_FUNCTION(GeoIP_record_by_ipnum)
    CONCEPT_FUNCTION(GeoIP_record_by_addr)
    CONCEPT_FUNCTION(GeoIP_record_by_name)
    CONCEPT_FUNCTION(GeoIP_record_by_ipnum_v6)
    CONCEPT_FUNCTION(GeoIP_record_by_addr_v6)
    CONCEPT_FUNCTION(GeoIP_record_by_name_v6)
    CONCEPT_FUNCTION(GeoIP_record_id_by_addr)
    CONCEPT_FUNCTION(GeoIP_record_id_by_addr_v6)
}
