#include "stdlibrary.h"

extern "C" {
    CONCEPT_DLL_API ON_CREATE_CONTEXT MANAGEMENT_PARAMETERS;
    CONCEPT_DLL_API ON_DESTROY_CONTEXT MANAGEMENT_PARAMETERS;

    CONCEPT_FUNCTION(MemCachedCreate)
    CONCEPT_FUNCTION(MemCachedFree)
    CONCEPT_FUNCTION(MemCachedResetServers)

    CONCEPT_FUNCTION(MemCachedAddServer)
    CONCEPT_FUNCTION(MemCachedAddServerUDP)
    CONCEPT_FUNCTION(MemCachedAddServerUnixSocket)

    CONCEPT_FUNCTION(MemCachedServerPush)

    CONCEPT_FUNCTION(MemCachedSet)
    CONCEPT_FUNCTION(MemCachedAdd)
    CONCEPT_FUNCTION(MemCachedReplace)
    CONCEPT_FUNCTION(MemCachedPrepend)
    CONCEPT_FUNCTION(MemCachedAppend)

    CONCEPT_FUNCTION(MemCachedSetByKey)
    CONCEPT_FUNCTION(MemCachedAddByKey)
    CONCEPT_FUNCTION(MemCachedReplaceByKey)
    CONCEPT_FUNCTION(MemCachedPrependByKey)
    CONCEPT_FUNCTION(MemCachedAppendByKey)

    CONCEPT_FUNCTION(MemCachedGet)
    CONCEPT_FUNCTION(MemCachedMGet)
    CONCEPT_FUNCTION(MemCachedGetByKey)
    CONCEPT_FUNCTION(MemCachedMGetByKey)

    CONCEPT_FUNCTION(MemCachedDelete)
    CONCEPT_FUNCTION(MemCachedDeleteByKey)

    CONCEPT_FUNCTION(MemCachedIncrement)
    CONCEPT_FUNCTION(MemCachedDecrement)

    CONCEPT_FUNCTION(MemCachedFlush)
    CONCEPT_FUNCTION(MemCachedError)

    CONCEPT_FUNCTION(MemCachedBehaviorSet)
    CONCEPT_FUNCTION(MemCachedBehaviorGet)
}
