#ifndef __LIBRARY_H
#define __LIBRARY_H

// user definition ...

extern "C" {
                // other functions declared here
                CONCEPT_DLL_API CONCEPT_SOAPClientInitArgs CONCEPT_API_PARAMETERS;
                CONCEPT_DLL_API CONCEPT_SOAPClientDestroy CONCEPT_API_PARAMETERS;
                CONCEPT_DLL_API CONCEPT_SOAPClientGetBlockmode CONCEPT_API_PARAMETERS;
                CONCEPT_DLL_API CONCEPT_SOAPClientBlockSocket CONCEPT_API_PARAMETERS;
                CONCEPT_DLL_API CONCEPT_SOAPClientInvoke CONCEPT_API_PARAMETERS;
                CONCEPT_DLL_API CONCEPT_SOAPCtxGetFile CONCEPT_API_PARAMETERS;
                CONCEPT_DLL_API CONCEPT_SOAPCtxNewWithMethod CONCEPT_API_PARAMETERS;
                CONCEPT_DLL_API CONCEPT_SOAPCtxAddFile CONCEPT_API_PARAMETERS;
                CONCEPT_DLL_API CONCEPT_SOAPCtxFree CONCEPT_API_PARAMETERS;
                CONCEPT_DLL_API CONCEPT_SOAPEnvNewWithFault CONCEPT_API_PARAMETERS;
                CONCEPT_DLL_API CONCEPT_SOAPEnvNewWithMethod CONCEPT_API_PARAMETERS;
                CONCEPT_DLL_API CONCEPT_SOAPEnvNewWithResponse CONCEPT_API_PARAMETERS;
                CONCEPT_DLL_API CONCEPT_SOAPEnvNewFromDoc CONCEPT_API_PARAMETERS;
                CONCEPT_DLL_API CONCEPT_SOAPEnvNewFromBuffer CONCEPT_API_PARAMETERS;
                CONCEPT_DLL_API CONCEPT_SOAPEnvNewFromStream CONCEPT_API_PARAMETERS;
                CONCEPT_DLL_API CONCEPT_SOAPEnvAddItem CONCEPT_API_PARAMETERS;
                CONCEPT_DLL_API CONCEPT_SOAPEnvAttachment CONCEPT_API_PARAMETERS;
                CONCEPT_DLL_API CONCEPT_SOAPEnvPushItem CONCEPT_API_PARAMETERS;
                CONCEPT_DLL_API CONCEPT_SOAPEnvPopItem CONCEPT_API_PARAMETERS;
                CONCEPT_DLL_API CONCEPT_SOAPEnvFree CONCEPT_API_PARAMETERS;
                CONCEPT_DLL_API CONCEPT_SOAPEnvGetBody CONCEPT_API_PARAMETERS;
                CONCEPT_DLL_API CONCEPT_SOAPEnvGetMethod CONCEPT_API_PARAMETERS;
                CONCEPT_DLL_API CONCEPT_SOAPEnvGetFault CONCEPT_API_PARAMETERS;
                CONCEPT_DLL_API CONCEPT_SOAPEnvFindUrn CONCEPT_API_PARAMETERS;
                CONCEPT_DLL_API CONCEPT_SOAPEnvFindMethodname CONCEPT_API_PARAMETERS;
                CONCEPT_DLL_API CONCEPT_SOAPXMLDocPrint CONCEPT_API_PARAMETERS;
                CONCEPT_DLL_API CONCEPT_SOAPGetRootDoc CONCEPT_API_PARAMETERS;
                CONCEPT_DLL_API CONCEPT_SOAPGetEnv CONCEPT_API_PARAMETERS;
		CONCEPT_DLL_API CONCEPT_SOAPXMLGetChildren CONCEPT_API_PARAMETERS;
		CONCEPT_DLL_API CONCEPT_SOAPXMLGetNext CONCEPT_API_PARAMETERS;
		CONCEPT_DLL_API CONCEPT_SOAPXMLGetText CONCEPT_API_PARAMETERS;
		CONCEPT_DLL_API CONCEPT_SOAPFaultBuild CONCEPT_API_PARAMETERS;
		CONCEPT_DLL_API CONCEPT_SOAPRouterNew CONCEPT_API_PARAMETERS;
		CONCEPT_DLL_API CONCEPT_SOAPRouterFindService CONCEPT_API_PARAMETERS;
		CONCEPT_DLL_API CONCEPT_SOAPRouterFree CONCEPT_API_PARAMETERS;
		CONCEPT_DLL_API CONCEPT_SOAPServerInitArgs CONCEPT_API_PARAMETERS;
		CONCEPT_DLL_API CONCEPT_SOAPServerRegisterRouter CONCEPT_API_PARAMETERS;
		CONCEPT_DLL_API CONCEPT_SOAPServerRun CONCEPT_API_PARAMETERS;
		CONCEPT_DLL_API CONCEPT_SOAPServerDestroy CONCEPT_API_PARAMETERS;
		CONCEPT_DLL_API CONCEPT_SOAPRouterRegisterService CONCEPT_API_PARAMETERS;

                CONCEPT_DLL_API CONCEPT_SOAPGetCurrentNode CONCEPT_API_PARAMETERS;
                CONCEPT_DLL_API CONCEPT_SOAPGetRootNode CONCEPT_API_PARAMETERS;
                CONCEPT_DLL_API CONCEPT_SOAPError CONCEPT_API_PARAMETERS;
		CONCEPT_DLL_API CONCEPT_SOAPGetServiceUrn CONCEPT_API_PARAMETERS;
		CONCEPT_DLL_API CONCEPT_SOAPGetServiceMethod CONCEPT_API_PARAMETERS;

		CONCEPT_DLL_API CONCEPT_SOAPXMLGetNodeArray CONCEPT_API_PARAMETERS;
		CONCEPT_DLL_API CONCEPT_SOAPGetEnvArray CONCEPT_API_PARAMETERS;
		CONCEPT_DLL_API CONCEPT_SOAPGetCtxArray CONCEPT_API_PARAMETERS;
}


#endif // __LIBRARY_H
